/*--------------------------------------------------------------*
 | File:	conv.c						|
 | Function:	convert CR FF ESC-1 ESC-0 to other strings	|
 | Programmer	J.D.J. Derksen jr				|
 | Date:	4-10-87						|
 | Version:	V1.0						|
 |--------------------------------------------------------------|
 |----------------- (c) copyright D.H.S. 1987 ------------------|
 *--------------------------------------------------------------*/

#include stdio.h

#define CR	'\n'
#define FF	'\f'
#define ESC	27
#define UL	'-'
#define ON	'1'
#define OFF	'0'
#define CR_NEW	"$CR$"
#define FF_NEW	"$FF$"
#define UL_ON	"$UL_ON$"
#define UL_OFF	"$UL_OFF$"
#define TRUE	1

main(argc,argv)
int argc,argv[];
{
	FILE in,out;
	char c;

	switch(argc){
		case 1:
			in=stdin;
			out=stdout;
			break;
		case 2:
			if ((in=fopen(argv[1],"r"))==NULL){
				printf("Can't open %s for read\n",argv[1]);
				exit(ERR);
			}
			out=stdout;
			break;
		case 3:
			if ((in=fopen(argv[1],"r"))==NULL){
				printf("Can't open %s for read\n",argv[1]);
				exit(ERR);
			}
			if ((out=fopen(argv[2],"w"))==NULL){
				printf("Can't open %s\n for write",argv[1]);
				exit(ERR);
			}
			break;
		default:
			printf("Usage: conv [infile [outfile]]\n");
			exit(ERR);
	}

	while(TRUE){
		if((c=getc(in))==EOF)
			break;
		switch(c){
			case CR:
				fprintf(out,"%s",CR_NEW);
				break;
			case FF:
				fprintf(out,"%s",FF_NEW);
				break;
			case ESC:
				if((c=getc(in))==UL){
				    if((c=getc(in))==ON){
					fprintf(out,"%s",UL_ON);
					break;
				    }else if (c==OFF){
					fprintf(out,"%s",UL_OFF);
					break;
				    }else
					fprintf(stderr,
					    "Illagal chararacter in UL\n");
				}else
				    fprintf(stderr,"Illegal ESC sequence\n");
				break;
			default:
				fprintf(out,"%c",c);
				break;
		}

	}
	fclose(in);
	fclose(out);
}
