/* program:	hanoi.c
 * function:	Give a help with towers of hanoi
 * programmer:	J.D.J Derksen jr.
 * date:	20-9-87
*/

#define SET 1
#define ERA 0
#define CLEAR 12

#asm
at	equ	$14
outc	equ	$f000
#endasm

int	tot,		/* total number of rings  */
	height[3];	/* height of the 3 places */

topos(x,y)
int x,y;
{
#asm
	lda	#at
	jsr	outc
	lda.u	0	/* fetch arg. x */
	jsr	outc
	lda.u	2	/* fetch arg. y */
	jsr	outc
#endasm
}

block(n,pos,mode)
int n,pos,mode;
{
	topos(pos*26-tot-n,24-height[pos]);
	n=n*2;
	if(mode==SET){
		while(n){
			putchar(160);
			n--;
		}
	}
	else{
		while(n){
			putchar(' ');
			n--;
		}
	}
}

move(number,from,to)
int number,from,to;
{
	height[from]--;
	block(number,from,ERA);
	block(number,to,SET);
	height[to]++;
}

hanoi(a,b,c,d) int a,b,c,d;
{
	if(a){
		hanoi(a-1,b,d,c);
		move(a,b,c);
		hanoi(a-1,d,c,b);
	}
}

main()
{
	int n;
	printf("\nMet hoeveel ringen zal ik het proberen ");
	scanf("%d",&n);
	if(n>12){
		printf("Meer dan 12 ringen is me te veel werk\n");
		exit(-1);
	}
	putchar(CLEAR);
	tot=n;
	height[1]=0;
	height[2]=0;
	height[3]=0;
	while(n){
		block(n--,1,SET);
		height[1]++;
	}
	n=tot;
	hanoi(n,1,2,3);
	topos(1,24);
}
