Eprom programmer          18-Jan-87 14:01                          page 0

		;EPROM Programmer software
		;for 6522 controlled eprom programmer
		;this version for Junior and PME
		;tested with 2716, 2732, 2732A, 2764, 27128, 27256
		;designed to accept 2532, 2564, 2764A, 27128A
		;and in two halves 27512
		;
		;80 column terminal assumed
		;
		;version 1.0
		;Jan 1987
		;
		;*SYSTEM VECTORS*
		;
	  1A7C	brkvec	equ	$1A7C		junior keyboard break
	  1A7A	nmivec	equ	$1A7A		junior NMI
		; 
		;*PRINCIPLE ADDRESSES*
		;
	  1800	via	equ	$1800		address of 6522 VIA 
		;
		;the following need not be in zero page
	  2C00	mem	equ	$2C00		variables and workspace
		;
		;the following have to be in zero page
	  00C0	memzer	equ	$00C0		zero page (4  locations)
		;
		;*JUNIOR SUBROUTINES USED*
		;
	  1334	prcha	equ	$1334		prints char in A reg, saves X
	  12AE	reccha	equ	$12AE		get char in A reg
	  105F	labjun	equ	$105F		warm start monitor
		;
		;*ASSEMBLY ADDRESS*
		;
	  2000	begin	equ	$2000
		;
		;*BUFFER AREA*
		;
		;free ram
	  0030	membeg	equ	$30		first page
	  00D0	memend	equ	$D0		last page+1
		;
		;*EXECUTE ADDRESSES*
		;
		; cold start = begin
		;
		;
		;*PORT ADDRESSES*
		;
	  1801	PORTA	equ	via+01
	  1800	PORTB	equ	via
	  1803	DIRA	equ	via+03
	  1802	DIRB	equ	via+02
	  180B	ACR	equ	via+11
	  180C	PCR	equ	via+12
	  1804	T1CL	equ	via+04
	  1805	T1CH	equ	via+05
	  1806	T1LL	equ	via+06
	  1807	T1LH	equ	via+07
	  180D	IFR	equ	via+13
	  180E	IER	equ	via+14
		;
		;*ASSIGNMENTS*
		;
	  00C0	retadd	equ	memzer+00	mess workspace
	  00C2	ptrl	equ	memzer+02	pointer for ram
	  00C3	ptrh	equ	memzer+03	and other purposes
		;
	  2C00		ORG	mem
Eprom programmer          18-Jan-87 14:01                          page 1

2C00		stack	res	1		stack-1 on entry
2C01		oldbrk	res	2		break vector on entry
2C03		oldnmi	res	2		nmi vector on entry
2C05		romwsp	res	1		romnam scratchpad
2C06		vwsp1	res	1		scratchpad used by verify
2C07		page	res	1		page length left
2C08		pwsp	res	1		scratchpad for progall routine
2C09		lwsp	res	1		latch scratchpad
2C0A		wspepn	res	1		scratchpad used by epnam
2C0B		type	res	1		code of device type
2C0C		dev_sel	res	1		number of device selected.
2C0D		base	res	2		start of buffer
2C0F		buf_ptr	res	1		pointer to next char in buffer
2C10		buf_size res	1		size of key buffer
2C11		num	res	2		hex input buffer
2C13		num_byt	res	1		current size of buffer
2C14		par_1	res	2		hex parameter 1
2C16		par_2	res	2		hex parameter 2
2C18		parflg_1 res	1		parameter flag 1
2C19		parflg_2 res	1		parameter flag 2
2C1A		asc_1	res	1		save char here
2C1B		length	res	2		number of addresses
2C1D		count	res	2		addresses counter
2C1F		ep_ptr	res	2		current eprom address
2C21		ep_beg	res	2		first eprom address
2C23		ep_end	res	2		last eprom address
2C25		mod_ad	res	2		modify address
2C27		keybuf	res	64		keyboard input buffer
		;
		;*PROGRAM STARTS HERE*
		;
	  2000		org	begin
		;
2000 4C 752A		JMP	COLDSTA
		; *Number of types of eprom*
		; each type can include any number of devices
		; but they must all have the same EC settings
		; they may have different sizes
		; and programming voltages.
		;
		;*Number of devices supported*
	  000C	no_dev	equ	$0C
		;
		; *Eprom names*
		;8 characters each
2003 3237313620	names	fcc	'2716    '
2008 202020
200B 3235333220		fcc	'2532    '
2010 202020
2013 3237333220		fcc	'2732    '
2018 202020
201B 3237333241		fcc	'2732A   '
2020 202020
2023 3235363420		fcc	'2564    '
2028 202020
202B 3237363420		fcc	'2764    '
2030 202020
2033 3237363441		fcc	'2764A   '
2038 202020
203B 3237313238		fcc	'27128   '
2040 202020
2043 3237313238		fcc	'27128A  '
2048 412020
204B 3237323536		fcc	'27256D  '
2050 442020
2053 3237323536		fcc	'27256   '
2058 202020
205B 3237353132		fcc	'27512   '
2060 202020
		;
Eprom programmer          18-Jan-87 14:01                          page 2

		; *EPROM PARAMETERS*
		;Note 2532 2564 and 27512 untested!
		;
		;*By device*
		;
		;table of programming voltages
2063 9090909050	prv_tab	fcc	$90,$90,$90,$90,$50,$54,$34,$54,$34
2068 54345434
206C 543434		fcc	$54,$34,$34
		;
		;table of device types
206F 0001020203	typ_tab	fcc	$00,$01,$02,$02,$03,$04,$04,$04,$04
2074 04040404
2078 050506		fcc	$05,$05,$06
		;
		;table of device size-1 in pages.
207B 070F0F0F1F	page_tab fcc	$07,$0F,$0F,$0F,$1F,$1F,$1F,$3F,$3F
2080 1F1F3F3F
2084 7F7FFF		fcc	$7F,$7F,$FF
		;
		;*By type*
		;
		;table indicating if OE and Vpp connection common
		; $00=no $FF=yes
		;Note if yes (2732 mostly) make Vpp=5 before
		;setting EC and PGM lines for program
2087 0000FF0000	OE_tab	fcc	$00,$00,$FF,$00,$00,$00,$FF
208C 00FF
		;
		;table of PB4 to PB6 during read
		;Note PB7=1 always.
208E F0F0F0F0B0	cs_tab	fcc	$F0,$F0,$F0,$F0,$B0,$F0,$F0
2093 F0F0
		;
		;table to give PB4 to PB6 when device inactive
		;PB7=1
2095 A0B0B08080	ncs_tab	fcc	$A0,$B0,$B0,$80,$80,$A0,$B0
209A A0B0
		;
		;table of PB4 to PB6 during programming
209C C0F0B080A0	pg_tab	fcc	$C0,$F0,$B0,$80,$A0,$A0,$A0
20A1 A0A0
		;
		;table to define EC1 and EC2 functions
		;Entry = $00 indicates both lines are NOE/ NCS
		; or unconnected
		;Entry = $01 indicates EC1=A14, EC2=NOE/ NCS
		;Entry = $80 indicates EC1=A14, EC2=A15
20A3 0000000000	EC_tab	fcc	$00,$00,$00,$00,$00,$01,$80
20A8 0180
		;
		;*I/O SUBROUTINES*
		;
		;to get char preceded by spaces
		;carry set and z clear if no spaces
		;z set and carry clear if no char
		;z and carry clear if char preceded by spaces
20AA 20 CF20	next	JSR	char
20AD 18			CLC
20AE F0 0F		BEQ	1.f		branch if none
20B0 C9 20		CMP	#$20		is it a space?
20B2 38			SEC
20B3 D0 0A		BNE	1.f		return with carry set if no
		;
20B5 20 CF20	2	JSR	char
20B8 F0 04		BEQ	3.f
20BA C9 20		CMP	#$20		space?
20BC F0 F7		BEQ	2.b
20BE 18		3	CLC
20BF 60		1	RTS
Eprom programmer          18-Jan-87 14:01                          page 3

		;
		;fill buffer and get first char
20C0 20 9921	keyinp	JSR	fillbuf
		;
		;routine to get capital letter or number from buffer
20C3 20 AA20	incap	JSR	next
20C6 08			PHP
20C7 C9 60		CMP	#$60
20C9 90 02		BCC	1.f
20CB 29 5F		AND	#$5F
20CD 28		1	PLP
20CE 60			RTS
		;
		;routine to get next char from keybuf
20CF AC 0F2C	char	LDY	buf_ptr
20D2 CC 102C		CPY	buf_size
20D5 F0 06		BEQ	1.f
20D7 B9 272C		LDA	keybuf,Y
20DA EE 0F2C		INC	buf_ptr
20DD 60		1	RTS			z set if no more
		;
		;routine to convert ascii to hex
		;carry set if error
20DE 38		hex_conv SEC
20DF E9 30		SBC	#$30
20E1 30 24		BMI	1.f		too small
20E3 C9 0A		CMP	#$0A		number bigger than 9?
20E5 90 0A		BCC	2.f		branch if no
20E7 E9 07		SBC	#$07
20E9 C9 10		CMP	#$10
20EB 10 1A		BPL	1.f		too big
20ED C9 0A		CMP	#$0A
20EF 30 16		BMI	1.f		branch if too small
20F1 EE 132C	2	INC	num_byt		inc number of nibbles
20F4 A2 04		LDX	#$04		move existing ones along
20F6 0E 112C	7	ASL	num
20F9 2E 122C		ROL	num+1
20FC CA			DEX
20FD D0 F7		BNE	7.b
20FF 0D 112C		ORA	num
2102 8D 112C		STA	num
2105 18			CLC
2106 60			RTS
2107 38		1	SEC
2108 60			RTS			error exit
		;
		;routine to get hex word
		;max number of bytes is 1 or 2
		; C set indicates too many digits or first char invalid
		; next character returned in A
		; A=00 means buffer empty A=FF means no trailing char
2109 A9 00	inhex	LDA	#$00
210B 8D 112C		STA	num		clear lower byte
210E 8D 122C		STA	num+1		clear upper byte
2111 8D 132C		STA	num_byt		number of nibbles so far
2114 20 AA20		JSR	next		get a char skipping spaces
2117 F0 20		BEQ	1.f		branch if none, space unneeded
2119 48			PHA
211A 20 DE20		JSR	hex_conv
211D 68			PLA
211E B0 13		BCS	2.f		if invalid with z=0, char in A
2120 20 CF20	5	JSR	char
2123 F0 10		BEQ	7.f		branch if none
2125 48			PHA
2126 20 DE20		JSR	hex_conv
2129 68			PLA			retrieve last char
212A B0 0F		BCS	4.f		branch if unknown
212C AE 132C		LDX	num_byt
212F E0 05		CPX	#$05
2131 90 ED		BCC	5.b		branch if less then two bytes
Eprom programmer          18-Jan-87 14:01                          page 4

2133 38		2	SEC			error exit
2134 60			RTS
2135 A9 FF	7	LDA	#$FF
2137 D0 02		BNE	4.f
2139 A9 00	1	LDA	#$00		indicates none found
213B 18		4	CLC			valid exit
213C 60			RTS
		;
		;routine to get two parameters from buffer
		;if invalid character then C set
		;parflg's set when number found
213D A9 00	twopar	LDA	#$00
213F 8D 182C		STA	parflg_1	clear flags
2142 8D 192C		STA	parflg_2
2145 20 0921		JSR	inhex		read number from buffer
2148 90 06		BCC	1.f		branch if no erroneous char
214A C9 2C		CMP	#',		let comma to indicate default
214C D0 49		BNE	par_err		error exit if illegal begin
214E F0 1D		BEQ	onepar		get next param
2150 F0 43	1	BEQ	par_end		branch if totally empty
2152 30 08		BMI	1.f		branch if no trailing char
2154 C9 2C		CMP	#',		accept comma
2156 F0 04		BEQ	1.f
2158 C9 20		CMP	#$20		accept space
215A D0 3B		BNE	par_err		error otherwise
215C A9 FF	1	LDA	#$FF
215E 8D 182C		STA	parflg_1	set flag
2161 AD 112C		LDA	num
2164 8D 142C		STA	par_1		save answer
2167 AD 122C		LDA	num+1
216A 8D 152C		STA	par_1+1
		;
		;routine to get one parameter only
		;and save in par_2
216D A9 00	onepar	LDA	#$00
216F 8D 192C		STA	parflg_2	clear flag
2172 20 0921		JSR	inhex		read number from buffer
2175 B0 20		BCS	par_err		branch if illegal char
2177 F0 1C		BEQ	par_end		branch if empty
2179 30 09		BMI	1.f		branch if no trailing char
217B C9 20		CMP	#$20		accept space
217D F0 05		BEQ	1.f
217F 20 AA20		JSR	next		more non-spaces?
2182 D0 13		BNE	par_err		error exit if more char
2184 A9 FF	1	LDA	#$FF
2186 8D 192C		STA	parflg_2	set flag
2189 AD 112C		LDA	num
218C 8D 162C		STA	par_2		save answer
218F AD 122C		LDA	num+1
2192 8D 172C		STA	par_2+1
2195 18		par_end	CLC			c=0 as no erroneous char
2196 60			RTS
2197 38		par_err	SEC			erroneous char, in A
2198 60			RTS
		;
		;routine to fill key buffer until CR
2199 20 BB23	fillbuf	JSR	print
219C 3F00		fcc	'?',$00
		;entry with no cursor char
219E A9 00	fillb1	LDA	#$00
21A0 8D 102C		STA	buf_size	clear buffer
21A3 8D 0F2C		STA	buf_ptr
21A6 20 AE12	10	JSR	reccha
21A9 AE 102C		LDX	buf_size
21AC C9 7F		CMP	#$7F		delete char?
21AE F0 1D		BEQ	11.f
21B0 C9 0D		CMP	#$0D		CR?
21B2 F0 23		BEQ	12.f
21B4 C9 20		CMP	#$20		control char
21B6 90 EE		BCC	10.b		if yes
Eprom programmer          18-Jan-87 14:01                          page 5

21B8 E0 40		CPX	#$40		buffer full?
21BA 90 08		BCC	13.f		branch if no
21BC A9 7F		LDA	#$7F
21BE 20 3413		JSR	prcha		delete
21C1 4C A621		JMP	10.b
21C4 9D 272C	13	STA	keybuf,X
21C7 E8			INX
21C8 8E 102C		STX	buf_size
21CB D0 D9		BNE	10.b
21CD E0 00	11	CPX	#$00		buffer empty?
21CF F0 06		BEQ	12.f		branch if yes
21D1 CE 102C		DEC	buf_size
21D4 4C A621		JMP	10.b
21D7 AE 102C	12	LDX	buf_size	set z if buffer empty
21DA 60			RTS
		;
21DB 20 BB23	crlf	JSR	print
21DE 0D0A00		fcc	$0D,$0A,$00
21E1 60			RTS
		;
		;routine to turn a byte into two ascii characters
		;and print them
21E2 48		prbyt	PHA
21E3 4A			LSRA			get upper nibble
21E4 4A			LSRA
21E5 4A			LSRA
21E6 4A			LSRA
21E7 20 ED21		JSR	prtnib		print nibble
21EA 68			PLA			prtnib
21EB 29 0F		AND	#$0F
		;
21ED C9 0A	prtnib	CMP	#$0A
21EF 18			CLC
21F0 30 02		BMI	1.f
21F2 69 07		ADC	#$07
21F4 69 30	1	ADC	#$30
21F6 4C 3413		JMP	prcha
		;
		;routine to print continue message
		;and wait for key
21F9 20 BB23	contin	JSR	print
21FC 0D0A0A2A2A		fcc	$0D,$0A,$0A,'*****space to continue***** ',$00
2201 2A2A2A7370
2206 6163652074
220B 6F20636F6E
2210 74696E7565
2215 2A2A2A2A2A
221A 2000
221C 20 AE12		JSR	reccha
221F 48			PHA
2220 20 BB23		JSR	print
2223 0D0A00		fcc	$0D,$0A,$00
2226 68			PLA
2227 C9 20		CMP	#$20
2229 60			RTS
		;
		;routine to print mistake message
222A 20 BB23	mistake	JSR	print
222D 0D0A6D6973		fcc	$0D,$0A,'mistake',$0D,$0A,$00
2232 74616B650D
2237 0A00
2239 60			RTS
		;
223A 20 BB23	error	JSR	print
223D 0D0A696E76		fcc	$0D,$0A,'invalid parameter(s)',$00
2242 616C696420
2247 706172616D
224C 6574657228
2251 732900
2254 60			RTS
Eprom programmer          18-Jan-87 14:01                          page 6

		;
2255 20 BB23	space	JSR	print		print space
2258 2000		fcc	$20,$00
225A 60			RTS
		;
		;routine to print command list
225B 20 BB23	menu	JSR	print
225E 0D0A0A4550		fcc	$0D,$0A,$0A,'EPROM PROGRAMMER version 1.0'
2263 524F4D2050
2268 524F475241
226D 4D4D455220
2272 7665727369
2277 6F6E20312E
227C 30
227D 0D0A0A2063		fcc	$0D,$0A,$0A,' command list'
2282 6F6D6D616E
2287 64206C6973
228C 74
228D 0D0A202042		fcc	$0D,$0A,'  B <n>     - Set ram base address'
2292 203C6E3E20
2297 202020202D
229C 2053657420
22A1 72616D2062
22A6 6173652061
22AB 6464726573
22B0 73
22B1 0D0A202044		fcc	$0D,$0A,'  D <l>     - Select device type'
22B6 203C6C3E20
22BB 202020202D
22C0 2053656C65
22C5 6374206465
22CA 7669636520
22CF 74797065
22D3 0D0A20204D		fcc	$0D,$0A,'  M <n> <n> - Display memory'
22D8 203C6E3E20
22DD 3C6E3E202D
22E2 2044697370
22E7 6C6179206D
22EC 656D6F7279
22F1 0D0A202050		fcc	$0D,$0A,'  P <n> <n> - Program'
22F6 203C6E3E20
22FB 3C6E3E202D
2300 2050726F67
2305 72616D
2308 0D0A202052		fcc	$0D,$0A,'  R <n> <n> - Read'
230D 203C6E3E20
2312 3C6E3E202D
2317 2052656164
231C 0D0A202051		fcc	$0D,$0A,'  Q         - Quit'
2321 2020202020
2326 202020202D
232B 2051756974
2330 0D0A202056		fcc	$0D,$0A,'  V <n> <n> - Verify'
2335 203C6E3E20
233A 3C6E3E202D
233F 2056657269
2344 6679
2346 0D0A202040		fcc	$0D,$0A,'  @ <n>     - Modify ram'
234B 203C6E3E20
2350 202020202D
2355 204D6F6469
235A 6679207261
235F 6D
2360 0D0A20203F		fcc	$0D,$0A,'  ?         - Repeat this list'
2365 2020202020
236A 202020202D
236F 2052657065
2374 6174207468
2379 6973206C69
237E 7374
Eprom programmer          18-Jan-87 14:01                          page 7

2380 0D0A0A00		fcc	$0D,$0A,$0A,$00
2384 20 BB23		JSR	print
2387 2020426173		fcc	'  Base = ',$00
238C 65203D2000
2391 AD 0E2C		LDA	base+1
2394 20 E221		JSR	prbyt
2397 AD 0D2C		LDA	base
239A 20 E221		JSR	prbyt
239D 20 BB23		JSR	print
23A0 2020202020		fcc	'      Device = ',$00
23A5 2044657669
23AA 6365203D20
23AF 00
23B0 20 DA23		JSR	epnam		print device name
23B3 20 BB23		JSR	print
23B6 0D0A0A00		fcc	$0D,$0A,$0A,$00
23BA 60			RTS
		;
		;routine to print bytes following call
		;until a $00 is encountered
23BB 68		print	PLA
23BC 85 C0		STA	retadd
23BE 68			PLA
23BF 85 C1		STA	retadd+1
		;
23C1 E6 C0	1	INC	retadd
23C3 D0 02		BNE	2.f
23C5 E6 C1		INC	retadd+01
23C7 A2 00	2	LDX	#$00
23C9 A1 C0		LDA	[retadd,X]
23CB F0 06		BEQ	ret
23CD 20 3413		JSR	prcha
23D0 4C C123		JMP	1.b
		;
23D3 A5 C1	ret	LDA	retadd+01
23D5 48			PHA
23D6 A5 C0		LDA	retadd
23D8 48			PHA
23D9 60			RTS
		;*COMMAND SUBROUTINES*
		;
		;routine to print device number
23DA AD 0C2C	epnam	LDA	dev_sel
23DD 0A		epnam2	ASLA			multiply to find
23DE 0A			ASLA			the table address
23DF 0A			ASLA
23E0 AA			TAX
23E1 A9 08		LDA	#$08
23E3 8D 0A2C		STA	wspepn
23E6 BD 0320	1	LDA	names,X		print 8 char
23E9 20 3413		JSR	prcha
23EC E8			INX
23ED CE 0A2C		DEC	wspepn
23F0 D0 F4		BNE	1.b
23F2 60			RTS
		;
		;
		;rom selection routines
		;prints menu, then gets new device
23F3 AD 1A2C	romnam	LDA	asc_1		character
23F6 F0 03		BEQ	1.f		branch if no char
23F8 4C 6A24		JMP	3.f		interpret it
		;
		;full menu needed
23FB A9 00	1	LDA	#$00
23FD 8D 052C		STA	romwsp
2400 20 BB23		JSR	print
2403 0D0A204465		fcc	$0D,$0A,' Devices:',$0D,$0A,$0A
2408 7669636573
240D 3A0D0A0A
Eprom programmer          18-Jan-87 14:01                          page 8

2411 00			fcc	$00
2412 20 BB23	romna1	JSR	print		list available devices
2415 2020202000		fcc	'    ',$00	with a menu letter
241A A9 40		LDA	#$40
241C 38			SEC
241D 6D 052C		ADC	romwsp
2420 20 3413		JSR	prcha		print letter of device number
2423 20 BB23		JSR	print
2426 20			fcc	' '
2427 00			fcc	$00
2428 AD 052C		LDA	romwsp
242B 20 DD23		JSR	epnam2		print device number in A
242E EE 052C		INC	romwsp		next device
2431 A9 03		LDA	#$03
2433 2D 052C		AND	romwsp
2436 D0 06		BNE	10.f
2438 20 BB23		JSR	print		line feed after 3
243B 0D0A00		fcc	$0D,$0A,$00
243E A9 0C	10	LDA	#no_dev		number of devices
2440 CD 052C		CMP	romwsp		more?
2443 D0 CD		BNE	romna1		branch if yes
2445 20 BB23		JSR	print
2448 0D0A0A2045		fcc	$0D,$0A,$0A,' Enter choice '
244D 6E74657220
2452 63686F6963
2457 6520
2459 00			fcc	$00
245A 20 C020		JSR	keyinp		fill buffer and get char
245D F0 22		BEQ	4.f		branch if none
245F 48			PHA			save char
2460 20 C320		JSR	incap		more non-spaces?
2463 F0 04		BEQ	5.f		branch if yes
2465 68			PLA
2466 4C 2A22		JMP	mistake
2469 68		5	PLA			get char
246A 38		3	SEC
246B E9 41		SBC	#$41		convert to integer
246D 10 04		BPL	romna2		branch if big enough
246F 20 2A22	romna3	JSR	mistake
2472 60			RTS
2473 C9 0C	romna2	CMP	#no_dev		branch if too big
2475 B0 F8		BCS	romna3
2477 8D 0C2C		STA	dev_sel		keep if valid
247A A8			TAY
247B B9 6F20		LDA	typ_tab,Y	get type of device
247E 8D 0B2C		STA	type
2481 20 BB23	4	JSR	print
2484 0D0A0A4465		fcc	$0D,$0A,$0A,'Device selected is ',$00
2489 7669636520
248E 73656C6563
2493 7465642069
2498 732000
249B 20 DA23		JSR	epnam
249E 20 BB23		JSR	print
24A1 20203C00		fcc	'  <',$00
24A5 AC 0C2C		LDY	dev_sel
24A8 BE 7B20		LDX	page_tab,Y	get size-1
24AB E8			INX			X=size/pages
24AC 8A			TXA
24AD D0 07		BNE	1.f		branch if not 64K
24AF 20 BB23		JSR	print
24B2 3100		fcc	'1',$00		device is 64K, size $10000
24B4 A9 00		LDA	#$00
24B6 20 E221	1	JSR	prbyt		print size
24B9 20 BB23		JSR	print
24BC 30303E00		fcc	'00>',$00
24C0 60			RTS
		;
		;routine to reset address vectors
24C1 AD 0D2C	rst_ad	LDA	base
Eprom programmer          18-Jan-87 14:01                          page 9

24C4 85 C2		STA	ptrl		reset ram pointer
24C6 AD 0E2C		LDA	base+1
24C9 85 C3		STA	ptrh
24CB A9 00		LDA	#$00
24CD 8D 1D2C		STA	count
24D0 8D 1E2C		STA	count+1
24D3 AD 212C		LDA	ep_beg
24D6 8D 1F2C		STA	ep_ptr
24D9 AD 222C		LDA	ep_beg+1
24DC 8D 202C		STA	ep_ptr+1
24DF 60			RTS
		;
		;routine to transfer data to a latch
		;byte to be transferred in A register
		;number of latch in Y register
		;X register unused
24E0 8C 092C	latch	STY	lwsp		save number of latch
24E3 A0 FF		LDY	#$FF
24E5 8C 0318		STY	DIRA		turn porta to outputs
24E8 8D 0118		STA	PORTA		present data
24EB A9 F0		LDA	#$F0
24ED 2D 0018		AND	PORTB		keep current OE CS PGM
24F0 8D 0018		STA	PORTB		prime latches
24F3 0D 092C		ORA	lwsp		get latch number
24F6 8D 0018		STA	PORTB		trigger latch
24F9 09 07		ORA	#$07
24FB 8D 0018		STA	PORTB		deselect function
24FE A9 00		LDA	#$00
2500 8D 0318		STA	DIRA		turn porta back to inputs
2503 60			RTS
		;
		;routine to transfer address to latches
		;X register unused
2504 AD 202C	set_ad	LDA	ep_ptr+1
2507 A0 04		LDY	#$04		latch to operate on addrh
2509 20 E024		JSR	latch
250C AD 1F2C		LDA	ep_ptr
250F A0 03		LDY	#$03		latch to operate on addrl
2511 4C E024		JMP	latch
		;
		;routine to increment pointers
2514 EE 1F2C	incad	INC	ep_ptr		incr eprom address
2517 D0 03		BNE	1.f
2519 EE 202C		INC	ep_ptr+1
251C E6 C2	1	INC	ptrl		update ram pointer
251E D0 02		BNE	2.f
2520 E6 C3		INC	ptrh
2522 AD 1D2C	2	LDA	count
2525 CD 1B2C		CMP	length
2528 D0 08		BNE	1.f
252A AD 1E2C		LDA	count+1
252D CD 1C2C		CMP	length+1
2530 F0 0F		BEQ	3.f
2532 EE 1D2C	1	INC	count
2535 D0 0A		BNE	3.f
2537 EE 1E2C		INC	count+1
253A 20 BB23		JSR	print
253D 2E00		fcc	$2E,$00
253F 09 FF		ORA	#$FF
2541 60		3	RTS			z set if finished
		;
		;routine to turn rom off
		;vpp=0 or 5 before calling
2542 A0 FF	romoff	LDY	#$FF
2544 8C 0018		STY	PORTB		clear programmer
2547 A9 F7		LDA	#$F7		turn programmer on and
2549 8D 0018		STA	PORTB		set CS OE PGM to 0
254C A9 01		LDA	#$01		lamp on, power off
254E A2 C8		LDX	#$C8		set delay
2550 4C B325		JMP	setv4
Eprom programmer          18-Jan-87 14:01                          page 10

		;
		;routine to turn vpp and vcc on
		;sets vpp=5, vcc=0 or 5
		;first tests for a negative edge on CB1 when
		;PB3 taken to 0, to see if programmer on.
2553 A0 FF	romon	LDY	#$FF
2555 8C 0018		STY	PORTB		reset programmer
2558 8C 0D18		STY	IFR		reset all interrupt flags
255B C8			INY
255C 8C 0C18		STY	PCR		make CB1 negative edge triggered
255F A9 F7		LDA	#$F7
2561 8D 0018		STA	PORTB		enable programmer
2564 A9 10		LDA	#$10
2566 2D 0D18		AND	IFR		was an edge detected?
2569 D0 23		BNE	1.f		branch if yes
256B 20 BB23		JSR	print
256E 0D0A50726F		fcc	$0D,$0A,'Programmer not responding!',$00
2573 6772616D6D
2578 6572206E6F
257D 7420726573
2582 706F6E6469
2587 6E672100
258B 4C 352A		JMP	break
258E 98		1	TYA			A=$00
258F A2 C8		LDX	#$C8		delay of 20 milliseconds
2591 20 AF25		JSR	setv3
2594 4C F825		JMP	rdmode
		;
		;routine to set vpp=5 before programming
		;call only for 2732/27512
2597 A9 1A	vpp5	LDA	#$1A		Vpp must be 5 volts
2599 D0 12		BNE	setv
		;
		;routine to set vpp=0 after program
259B A9 0A	vpp0	LDA	#$0A
259D D0 0E		BNE	setv
		;
259F AC 0B2C	rdvolts	LDY	type
25A2 B9 8720		LDA	OE_tab,Y	are OE and Vpp same?
25A5 D0 04		BNE	1.f		branch if yes
25A7 A9 1A		LDA	#$1A		Vpp must be 5 volts
25A9 D0 02		BNE	setv
25AB A9 0A	1	LDA	#$0A		Vpp=0
		;
		;routine to set voltages to A register
		;
25AD A2 03	setv	LDX	#$03		load delay of 300 microsec
25AF 09 0A	setv3	ORA	#$0A		set power on bits
25B1 29 FE		AND	#$FE		lamp out
25B3 A0 05	setv4	LDY	#$05		select volts latch
25B5 20 E024		JSR	latch
		;
		;delay routine
		;delay 100 * X register /microsec
25B8 E8		delay	INX
25B9 A0 15	1	LDY	#$15		for 1MHz 6502
25BB 88		2	DEY
25BC D0 FD		BNE	2.b
25BE CA			DEX
25BF D0 F8		BNE	1.b
25C1 60			RTS
		;
		;routine to adjust control line data if
		;EC1 and EC2 are address lines
25C2 AC 0B2C	ECset	LDY	type
25C5 BE A320		LDX	EC_tab,Y	EC1 or EC2 addr line?
25C8 F0 22		BEQ	1.f		branch if no
25CA 08			PHP
25CB 09 20		ORA	#$20		make EC1=0
25CD A8			TAY			save byte
Eprom programmer          18-Jan-87 14:01                          page 11

25CE AD 202C		LDA	ep_ptr+1
25D1 29 40		AND	#$40		A14=0?
25D3 F0 04		BEQ	2.f		branch if yes
25D5 98			TYA
25D6 29 DF		AND	#$DF		make A14 (EC1) = 1
25D8 A8			TAY
25D9 98		2	TYA
25DA 28			PLP			what about EC2?
25DB 10 0F		BPL	1.f		branch if no change
25DD 09 10		ORA	#$10		make EC2=0
25DF A8			TAY
25E0 AD 202C		LDA	ep_ptr+1
25E3 29 80		AND	#$80		A15=0
25E5 F0 04		BEQ	2.f		branch if yes
25E7 98			TYA
25E8 29 EF		AND	#$EF		make EC2=1
25EA A8			TAY
25EB 98		2	TYA
25EC 60		1	RTS
		;
25ED 20 C225	ctrl_set1 JSR	ECset
		;
		;routine for setting control lines
		;deselects register
25F0 29 F7	ctrl_set AND	#$F7		clear reset bit
25F2 09 07		ORA	#$07		no register selected
25F4 8D 0018		STA	PORTB
25F7 60			RTS			return with portb data in A
		;
25F8 20 9F25	rdmode	JSR	rdvolts
25FB 4C 0227		JMP	unsel
		;
		;routine to program one location
		;length of pulse = A * 256 cycles
		;assumes Vpp set for read, EC/PGM for inactivity
25FE 08		pulse	PHP			save flags
25FF AC 0B2C		LDY	type
2602 BE 8720		LDX	OE_tab,Y	is it necessary to make Vpp=5?
		;             essential for 2732
2605 78			SEI			prevent interrupts
2606 08			PHP
2607 48			PHA			A contains pulse time
2608 F0 03		BEQ	1.f		branch if not necessary
260A 20 9725		JSR	vpp5		set Vpp=5
260D AC 0B2C	1	LDY	type
2610 B9 9C20		LDA	pg_tab,Y	get EC lines for prog
2613 20 C225		JSR	ECset		sort out A14, A15
2616 09 87		ORA	#$87		make sure bit 7 set
2618 29 F7		AND	#$F7		make sure reset bit clear
261A 8D 0018		STA	PORTB
261D 48			PHA			save portb data
261E AC 0C2C		LDY	dev_sel
2621 B9 6320		LDA	prv_tab,Y	get programming volts
2624 20 AD25		JSR	setv		set them
2627 A0 FF		LDY	#$FF
2629 8C 0318		STY	DIRA		convert porta to outputs
262C C8			INY
262D B1 C2		LDA	[ptrl],Y	get data
262F 8D 0118		STA	PORTA		present data to rom
2632 68			PLA			retrieve portb
2633 AA			TAX			and save in X
2634 29 F1		AND	#$F1		programmer in write mode
2636 8D 0018		STA	PORTB		set write mode
2639 A9 80		LDA	#$80
263B 8D 0B18		STA	ACR		one shot mode for timer 1
263E A9 00		LDA	#$00
2640 8D 0418		STA	T1CL
2643 68			PLA			fetch pulse time
2644 8D 0518		STA	T1CH		start counter, prog PB7=0
2647 A9 40	1	LDA	#$40
Eprom programmer          18-Jan-87 14:01                          page 12

2649 2D 0D18		AND	IFR
264C F0 F9		BEQ	1.b		poll until time out
264E A9 00		LDA	#$00
2650 8D 0B18		STA	ACR		clear timer, PB7=1
2653 8D 0318		STA	DIRA		porta back to inputs
2656 8E 0018		STX	PORTB		clear write mode
2659 28			PLP			recall if vpp taken to 5v before
265A F0 0C		BEQ	1.f		branch if no
265C 20 9725		JSR	vpp5		applies to 2732 and 27512
265F 20 0227		JSR	unsel		other lines for inactivity
2662 20 9B25		JSR	vpp0		make Vpp/NOE=0
2665 4C 6B26		JMP	2.f
2668 20 F825	1	JSR	rdmode		Vpp=read, EC/PGM inactivity
266B 28		2	PLP			restore interrupt status
266C 20 E026		JSR	read1		answer in A, Y set to $00
266F D1 C2		CMP	[ptrl],Y	set Z flag if successful
2671 60			RTS			return with eprom inactive
		;
		;
2672 20 BB23	progall	JSR	print
2675 0D0A50726F	1	fcc	$0D,$0A,'Program Y/N? '
267A 6772616D20
267F 592F4E3F20
2684 00			fcc	$00
2685 20 C020		JSR	keyinp
2688 C9 59		CMP	#'Y
268A F0 01		BEQ	1.f		branch if yes
268C 60		4	RTS
268D 20 5325	1	JSR	romon		power up rom
2690 20 BB23		JSR	print
2693 0D0A2E2E		fcc	$0D,$0A,'..'
2697 00			fcc	$00
2698 20 0425	pr1	JSR	set_ad		set up address
269B A9 09		LDA	#$09		store max number of
269D 8D 082C		STA	pwsp		1 msec pulses -1
26A0 A9 04	2	LDA	#$04		pulse length of 1 millisecond
26A2 20 FE25		JSR	pulse		program location
26A5 F0 05		BEQ	pr3		branch if successful
26A7 CE 082C		DEC	pwsp		reduce pulses left
26AA D0 F4		BNE	2.b		if less then 10 pulses
26AC A9 0A	pr3	LDA	#$0A
26AE 38			SEC
26AF ED 082C		SBC	pwsp		calculate pulses so far
26B2 0A			ASLA			multiply time so far
26B3 0A			ASLA			by 4
26B4 20 FE25		JSR	pulse		giant pulse
26B7 20 1425		JSR	incad		next address
26BA D0 DC		BNE	pr1		branch if not finished
26BC 20 7A27		JSR	verad		verify rom
26BF F0 1B		BEQ	pr4
26C1 20 BB23		JSR	print
26C4 0A0D457272		fcc	$0A,$0D,'Errors in programming'
26C9 6F72732069
26CE 6E2070726F
26D3 6772616D6D
26D8 696E67
26DB 00			fcc	$00
26DC 60		pr4	RTS
		;
		;routine to read eprom at current address
		;assumes Vpp and Vcc already set
		;assumes PORTA already inputs
		;all registers used
26DD 20 0425	read	JSR	set_ad
26E0 AC 0B2C	read1	LDY	type		if address set
26E3 B9 8E20		LDA	cs_tab,Y	make eprom active
26E6 20 ED25		JSR	ctrl_set1
26E9 AD 0018		LDA	PORTB
26EC 29 F0		AND	#$F0		code for
26EE 09 02		ORA	#$02		read mode
Eprom programmer          18-Jan-87 14:01                          page 13

26F0 8D 0018		STA	PORTB		programmer to read mode
26F3 09 07		ORA	#$07
26F5 AE 0118		LDX	PORTA		read eprom
26F8 8D 0018		STA	PORTB
		;Note value read in X
26FB 20 0227		JSR	unsel		eprom inactive saving X
26FE 8A			TXA
26FF A0 00		LDY	#$00		convenient to make Y=0
2701 60			RTS
		;
2702 AC 0B2C	unsel	LDY	type
2705 B9 9520		LDA	ncs_tab,Y	make eprom inactive
2708 4C F025		JMP	ctrl_set	X preserved
		;
		;
		;routine to copy rom to memory
270B AD 0E2C	readall	LDA	base+1		check enough space
270E C9 30		CMP	#membeg
2710 90 13		BCC	1.f
2712 18			CLC
2713 AD 0D2C		LDA	base
2716 6D 1B2C		ADC	length		calculate end page
2719 AD 0E2C		LDA	base+1
271C 6D 1C2C		ADC	length+1
271F B0 04		BCS	1.f
2721 C9 D0		CMP	#memend
2723 90 17		BCC	2.f
2725 20 BB23	1	JSR	print
2728 696C6C6567		fcc	'illegal ram area',$0D,$0A,$00
272D 616C207261
2732 6D20617265
2737 610D0A00
273B 60			RTS
		;
273C 20 5325	2	JSR	romon
273F 20 BB23		JSR	print
2742 7265616469		fcc	'reading...'
2747 6E672E2E2E
274C 00			fcc	$00
274D 20 DD26	rd1	JSR	read		fetch byte from eprom
2750 91 C2		STA	[ptrl],Y	store in memory
2752 20 1425		JSR	incad		next address
2755 D0 F6		BNE	rd1		branch if unfinished
2757 20 7A27		JSR	verad		verify
275A F0 17		BEQ	rd2		branch if pass
275C 20 BB23		JSR	print
275F 0A0D657272		fcc	$0A,$0D,'errors in reading',$00
2764 6F72732069
2769 6E20726561
276E 64696E6700
2773 60		rd2	RTS
		;
		;routine to verify current address
		;ram address at ptrl
		;rom address in ep_ptr
2774 20 DD26	ver	JSR	read
2777 D1 C2		CMP	[ptrl],Y	compare with memory
2779 60			RTS

		;routine to verify addresses until all 
		;or error. Assumes read volts selected.
277A 20 C124	verad	JSR	rst_ad		reset address pointers
277D 20 7427	3	JSR	ver
2780 D0 05		BNE	2.f		branch if error found
2782 20 1425		JSR	incad		next address
2785 D0 F6		BNE	3.b		branch if more addresses
2787 60		2	RTS			z set if no errors
		;
		;routine to verify rom and print errors
2788 20 5325	verify	JSR	romon		power on
Eprom programmer          18-Jan-87 14:01                          page 14

278B 20 BB23		JSR	print
278E 7665726966		fcc	'verifying...'
2793 79696E672E
2798 2E2E
279A 00			fcc	$00
279B A9 00		LDA	#$00
279D 8D 062C		STA	vwsp1		reset error flag
27A0 A9 10		LDA	#$10		page length
27A2 8D 072C		STA	page
27A5 20 7427	21	JSR	ver
27A8 F0 60		BEQ	22.f		next address if same
27AA A0 FF		LDY	#$FF
27AC 8C 062C		STY	vwsp1		set error flag
27AF 48			PHA
27B0 20 BB23		JSR	print
27B3 0D0A202020		fcc	$0D,$0A,'    ',$00
27B8 2000
27BA AD 202C		LDA	ep_ptr+1	print rom address
27BD 20 E221		JSR	prbyt
27C0 AD 1F2C		LDA	ep_ptr
27C3 20 E221		JSR	prbyt
27C6 20 BB23		JSR	print
27C9 20			fcc	' '
27CA 00			fcc	$00
27CB 68			PLA
27CC 20 E221		JSR	prbyt		print rom data
27CF 20 BB23		JSR	print
27D2 2020202020		fcc	'      (',$00
27D7 202800
27DA A5 C3		LDA	ptrh		print ram address
27DC 20 E221		JSR	prbyt
27DF A5 C2		LDA	ptrl
27E1 20 E221		JSR	prbyt
27E4 20 BB23		JSR	print
27E7 20			fcc	' '
27E8 00			fcc	$00
27E9 A0 00		LDY	#$00
27EB B1 C2		LDA	[ptrl],Y	print ram byte
27ED 20 E221		JSR	prbyt
27F0 20 BB23		JSR	print
27F3 2900		fcc	')',$00
27F5 CE 072C		DEC	page		decrement lines left on page
27F8 D0 10		BNE	22.f		branch if more lines
		;
27FA A9 10		LDA	#$10
27FC 8D 072C		STA	page		reset page length
27FF 20 4225		JSR	romoff		eprom power off
2802 20 F921		JSR	contin
2805 D0 0E		BNE	23.f		finish if not space
2807 20 5325		JSR	romon		turn on power
		;
280A 20 1425	22	JSR	incad		next address
280D D0 96		BNE	21.b
280F AD 062C		LDA	vwsp1
2812 D0 01		BNE	23.f
2814 60		5	RTS
2815 20 BB23	23	JSR	print
2818 0A0A0D4572		fcc	$0A,$0A,$0D,'Errors found'
281D 726F727320
2822 666F756E64
2827 00			fcc	$00
2828 60			RTS
		;
2829 20 5325	check	JSR	romon		turn power on
282C 20 BB23		JSR	print
282F 636865636B		fcc	'checking'
2834 696E67
2837 2E2E2E2E		fcc	'....'
283B 00			fcc	$00
283C 20 DD26	ch1	JSR	read
Eprom programmer          18-Jan-87 14:01                          page 15

283F C9 FF		CMP	#$FF		empty location?
2841 D0 11		BNE	ch2
2843 20 1425		JSR	incad		next address
2846 D0 F4		BNE	ch1		branch if unfinished
2848 20 BB23		JSR	print
284B 0D0A		fcc	$0D,$0A
284D 656D707479		fcc	'empty'
2852 00			fcc	$00
2853 60		5	RTS
2854 20 BB23	ch2	JSR	print
2857 0A0D4E6F74		fcc	$0A,$0D,'Not empty'
285C 20656D7074
2861 79
2862 00			fcc	$00
2863 60			RTS
		;
		;routine to allow keyboard input of base address
2864 AD 192C	getbase	LDA	parflg_2
2867 D0 14		BNE	2.f		if parameter
2869 20 BB23	1	JSR	print
286C 4261736520		fcc	'Base '
2871 00			fcc	$00
2872 20 9921		JSR	fillbuf		get entry
2875 20 6D21		JSR	onepar
2878 90 03		BCC	2.f		branch if valid entry
287A 4C 2A22		JMP	mistake
287D AD 192C	2	LDA	parflg_2
2880 F0 0C		BEQ	prtbase
2882 AD 162C		LDA	par_2
2885 AC 172C		LDY	par_2+1
2888 8D 0D2C		STA	base		new value
288B 8C 0E2C		STY	base+1
288E 20 BB23	prtbase	JSR	print
2891 0D0A0A4261		fcc	$0D,$0A,$0A,'Base is ',$00
2896 7365206973
289B 2000
289D AD 0E2C		LDA	base+1
28A0 20 E221		JSR	prbyt
28A3 AD 0D2C		LDA	base
28A6 4C E221		JMP	prbyt
		;
28A9 78		quit	SEI
28AA AE 002C		LDX	stack		correct stack
28AD 9A			TXS
28AE AD 012C		LDA	oldbrk		restore vectors
28B1 8D 7C1A		STA	brkvec
28B4 AD 022C		LDA	oldbrk+1
28B7 8D 7D1A		STA	brkvec+1
28BA AD 032C		LDA	oldnmi
28BD 8D 7A1A		STA	nmivec
28C0 AD 042C		LDA	oldnmi+1
28C3 8D 7B1A		STA	nmivec+1
28C6 28			PLP			get original flags
28C7 4C 5F10		JMP	labjun		jump to monitor
		;

28CA AD 192C	modify	LDA	parflg_2	argument supplied?
28CD F0 0C		BEQ	1.f		branch if no
28CF AE 162C		LDX	par_2		get previous value
28D2 8E 252C		STX	mod_ad
28D5 AD 172C		LDA	par_2+1
28D8 8D 262C		STA	mod_ad+1
28DB AE 252C	1	LDX	mod_ad
28DE 86 C2		STX	ptrl		initialise zero page ptr
28E0 AD 262C		LDA	mod_ad+1
28E3 85 C3		STA	ptrh
28E5 20 DB21	1	JSR	crlf
28E8 A5 C3		LDA	ptrh		print address
28EA 20 E221		JSR	prbyt
28ED A5 C2		LDA	ptrl
Eprom programmer          18-Jan-87 14:02                          page 16

28EF 20 E221		JSR	prbyt
28F2 20 5522		JSR	space
28F5 A2 00		LDX	#$00
28F7 A1 C2		LDA	[ptrl,X]	print contents
28F9 20 E221		JSR	prbyt
28FC 20 5522		JSR	space
28FF 20 5522		JSR	space
2902 20 9E21		JSR	fillb1		input get keybd input
2905 F0 64		BEQ	6.f		end if empty
2907 20 0921	2	JSR	inhex
290A B0 31		BCS	3.f		branch if illegal char
290C F0 D7		BEQ	1.b		branch if empty
290E AA			TAX			put trailing char in X
290F AD 122C		LDA	num+1
2912 D0 54		BNE	4.f		error if upper byte
2914 AD 112C		LDA	num
2917 E0 FF		CPX	#$FF		no trailing char?
2919 F0 15		BEQ	12.f
291B E0 20	11	CPX	#$20		space
291D F0 11		BEQ	12.f
291F E0 2E		CPX	#$2E		comma
2921 F0 0D		BEQ	12.f
2923 E0 2B		CPX	#'+
2925 F0 04		BEQ	9.f
2927 E0 2D		CPX	#'-
2929 D0 3D		BNE	4.f		error if not found
292B CE 0F2C	9	DEC	buf_ptr		for next time
292E 48			PHA
292F 68		10	PLA			contains byte
2930 A2 00	12	LDX	#$00
2932 81 C2		STA	[ptrl,X]	store it
2934 E6 C2	8	INC	ptrl		increment pointer
2936 D0 CF		BNE	2.b
2938 E6 C3		INC	ptrh
293A 4C 0729		JMP	2.b
		;
293D C9 2B	3	CMP	#'+		is bad character a + ?
293F F0 F3		BEQ	8.b
		;
2941 C9 2D		CMP	#'-		is it a - ?
2943 D0 0B		BNE	0.f
2945 A6 C2		LDX	ptrl		decrement pointer
2947 D0 02		BNE	5.f
2949 C6 C3		DEC	ptrh
294B C6 C2	5	DEC	ptrl
294D 4C 0729		JMP	2.b
		;
2950 C9 27	0	CMP	#$27		is it a ' ?
2952 D0 14		BNE	4.f
2954 20 CF20		JSR	char		get next char
2957 F0 0F		BEQ	4.f		error if none
2959 C9 20		CMP	#$20
295B 90 0B		BCC	4.f		error if control char
295D 48			PHA			save it
295E 20 CF20		JSR	char		get separator
2961 F0 CC		BEQ	10.b		OK if no more
2963 AA			TAX			put separator in X
2964 68			PLA			get character
2965 4C 1B29		JMP	11.b
		;
2968 20 2A22	4	JSR	mistake
296B A5 C2	6	LDA	ptrl		save pointer
296D 8D 252C		STA	mod_ad
2970 A5 C3		LDA	ptrh
2972 8D 262C		STA	mod_ad+1
2975 60			RTS
		;
2976 AD 182C	dump	LDA	parflg_1	par 1 supplied?
2979 F0 09		BEQ	2.f		branch if no
297B AD 142C		LDA	par_1
Eprom programmer          18-Jan-87 14:02                          page 17

297E AE 152C		LDX	par_1+1
2981 4C 8A29		JMP	7.f
2984 AD 0D2C	2	LDA	base		get base as default
2987 AE 0E2C		LDX	base+1
298A 29 F0	7	AND	#$F0
298C 85 C2		STA	ptrl
298E 86 C3		STX	ptrh
2990 A9 00		LDA	#$00
2992 AA			TAX
2993 AC 192C		LDY	parflg_2	par 2 supplied?
2996 F0 06		BEQ	6.f		branch if no
2998 AD 162C		LDA	par_2
299B AE 172C		LDX	par_2+1
299E 8D 1D2C	6	STA	count
29A1 8E 1E2C		STX	count+1
29A4 20 BB23	8	JSR	print
29A7 0D0A202020		fcc	$0D,$0A,'      ',$00
29AC 20202000
29B0 A9 10		LDA	#$10
29B2 8D 072C		STA	page
29B5 A9 00		LDA	#00
29B7 48		9	PHA
29B8 20 ED21		JSR	prtnib		print header
29BB 20 BB23		JSR	print
29BE 202000		fcc	'  ',$00
29C1 68			PLA
29C2 AA			TAX
29C3 E8			INX
29C4 8A			TXA
29C5 E0 10		CPX	#$10
29C7 D0 EE		BNE	9.b
29C9 20 DB21	5	JSR	crlf
29CC A5 C3		LDA	ptrh		print address
29CE 20 E221		JSR	prbyt
29D1 A5 C2		LDA	ptrl
29D3 20 E221		JSR	prbyt
29D6 20 BB23		JSR	print
29D9 3A00		fcc	':',$00
29DB A9 00		LDA	#$00
29DD 48		3	PHA			print 16 bytes
29DE 20 5522		JSR	space
29E1 68			PLA
29E2 48			PHA
29E3 A8			TAY
29E4 B1 C2		LDA	[ptrl],Y
29E6 20 E221		JSR	prbyt
29E9 68		4	PLA
29EA AA			TAX
29EB E8			INX
29EC 8A			TXA
29ED E0 10		CPX	#$10		more?
29EF D0 EC		BNE	3.b		branch if yes
29F1 20 BB23		JSR	print
29F4 202000		fcc	$20,$20,$00
29F7 A9 10		LDA	#$10
29F9 48		3	PHA			print ascii
29FA A0 00		LDY	#$00
29FC B1 C2		LDA	[ptrl],Y
29FE C9 20		CMP	#$20
2A00 90 04		BCC	1.f
2A02 C9 7F		CMP	#$7F
2A04 90 02		BCC	2.f
2A06 A9 2E	1	LDA	#'.
2A08 20 3413	2	JSR	prcha
2A0B E6 C2		INC	ptrl		increment pointer
2A0D D0 02		BNE	1.f
2A0F E6 C3		INC	ptrh
2A11 68		1	PLA
2A12 AA			TAX
2A13 CA			DEX			more char on line?
Eprom programmer          18-Jan-87 14:02                          page 18

2A14 8A			TXA
2A15 D0 E2		BNE	3.b
2A17 AD 1E2C		LDA	count+1
2A1A C5 C3		CMP	ptrh
2A1C 90 16		BCC	7.f
2A1E D0 07		BNE	4.f
2A20 A5 C2		LDA	ptrl
2A22 CD 1D2C		CMP	count
2A25 B0 0D		BCS	7.f
2A27 CE 072C	4	DEC	page
2A2A D0 9D		BNE	5.b
2A2C 20 F921		JSR	contin
2A2F D0 03		BNE	7.f
2A31 4C A429		JMP	8.b
2A34 60		7	RTS
		;
		;Junior break vector points here
2A35 20 4225	break	JSR	romoff
2A38 20 BB23		JSR	print
2A3B 0D0A0A6162		fcc	$0D,$0A,$0A,'aborted',$00
2A40 6F72746564
2A45 00
2A46 AE 002C		LDX	stack
2A49 9A			TXS
2A4A 4C A72B		JMP	mp1
		;
		;*COMMAND PARAMETER TABLES*
		;
2A4D 56		cmnds	fcc	'V'		verify
2A4E 52			fcc	'R'		read
2A4F 50			fcc	'P'		program
2A50 51			fcc	'Q'		quit
2A51 44			fcc	'D'		device
2A52 43			fcc	'C'		check
2A53 42			fcc	'B'		base address
2A54 3F			fcc	'?'		Print command list
2A55 40			fcc	'@'		modify ram
2A56 4D			fcc	'M'		memory dump
		;
		;parameter table: $00 means no checking
		;            Bit7=1 means no parameter
		;            Bit6=1 means letter parameter only
		;            Bit5=1 means one numeric parameter only
		;            Bit4=1 means two numeric parameters only
		;            Bit3=1 means two numeric parameters which are
		;              also eprom addresses. They are checked
2A57 08		no_pars	fcc	$08
2A58 08			fcc	$08
2A59 08			fcc	$08
2A5A 80			fcc	$80
2A5B 40			fcc	$40
2A5C 08			fcc	$08
2A5D 20			fcc	$20
2A5E 80			fcc	$80
2A5F 20			fcc	$20
2A60 10			fcc	$10
		;
		;addresses
2A61 87		cmdlo	fcc	verify-1&255
2A62 0A			fcc	readall-1&255
2A63 71			fcc	progall-1&255
2A64 A8			fcc	quit-1&255
2A65 F2			fcc	romnam-1&255
2A66 28			fcc	check-1&255
2A67 63			fcc	getbase-1&255
2A68 5A			fcc	menu-1&255
2A69 C9			fcc	modify-1&255
2A6A 75			fcc	dump-1&255
2A6B 27		cmdhi	fcc	verify-1>>8
2A6C 27			fcc	readall-1>>8
Eprom programmer          18-Jan-87 14:02                          page 19

2A6D 26			fcc	progall-1>>8
2A6E 28			fcc	quit-1>>8
2A6F 23			fcc	romnam-1>>8
2A70 28			fcc	check-1>>8
2A71 28			fcc	getbase-1>>8
2A72 22			fcc	menu-1>>8
2A73 28			fcc	modify-1>>8
2A74 29			fcc	dump-1>>8
		;
		;*MAIN PROGRAM*
		;
2A75 08		COLDSTA	PHP			save flags
2A76 D8			CLD			clear decimal
2A77 AD 7C1A		LDA	brkvec		save old break vector
2A7A 8D 012C		STA	oldbrk
2A7D AD 7D1A		LDA	brkvec+1
2A80 8D 022C		STA	oldbrk+1
2A83 AD 7A1A		LDA	nmivec		save old NMI
2A86 8D 032C		STA	oldnmi
2A89 AD 7B1A		LDA	nmivec+1
2A8C 8D 042C		STA	oldnmi+1
2A8F A9 35		LDA	#break&255	set break and nmi vectors
2A91 8D 7C1A		STA	brkvec
2A94 8D 7A1A		STA	nmivec
2A97 A9 2A		LDA	#break>>8
2A99 8D 7B1A		STA	nmivec+1
2A9C 8D 7D1A		STA	brkvec+1
2A9F BA			TSX			save stack
2AA0 8E 002C		STX	stack
2AA3 58			CLI			permit interrupts
2AA4 A9 00		LDA	#$00
		;
		;initialise VIA and variables
2AA6 8D 0E18		STA	IER		disable interrupts
2AA9 8D 0C18		STA	PCR
2AAC 8D 0B18		STA	ACR
2AAF 8D 0B2C		STA	type		initialise to zero
2AB2 8D 0C2C		STA	dev_sel		and a correponding device
2AB5 8D 0D2C		STA	base
2AB8 8D 252C		STA	mod_ad
2ABB A9 FF		LDA	#$FF
2ABD 8D 0018		STA	PORTB		Note: before portb outputs!!!
2AC0 8D 0218		STA	DIRB		portb outputs
2AC3 A9 30		LDA	#membeg		default base address
2AC5 8D 0E2C		STA	base+1		initialise base address
2AC8 8D 262C		STA	mod_ad+1	initialise default modify
2ACB 20 4225		JSR	romoff
2ACE 20 5B22		JSR	menu
2AD1 20 DB21	mp0	JSR	crlf
2AD4 20 C020		JSR	keyinp		get keyboard input
2AD7 F0 F8		BEQ	mp0		branch if none
2AD9 48			PHA			save input
2ADA 20 BB23		JSR	print
2ADD 0D0A00		fcc	$0D,$0A,$00
2AE0 68		1	PLA			retrieve character
		;
		;search command table for entry
2AE1 A0 09		LDY	#$09		set index to number of entries
2AE3 D9 4D2A	3	CMP	cmnds,Y
2AE6 D0 03		BNE	1.f		branch if entry not found
2AE8 4C 6C2B		JMP	8.f
2AEB 88		1	DEY
2AEC 10 F5		BPL	3.b		branch if more entries
		;
2AEE 48			PHA			entry not found
2AEF 68		9	PLA
2AF0 20 2A22		JSR	mistake
2AF3 4C D12A		JMP	mp0
		;
		;get two eprom addresses check and
Eprom programmer          18-Jan-87 14:02                          page 20

		;initialise pointers
2AF6 20 3D21	14	JSR	twopar		get parameters
2AF9 B0 F4		BCS	9.b		branch if error
2AFB AD 182C		LDA	parflg_1	first parameter found?
2AFE D0 05		BNE	1.f		branch if yes
2B00 A9 00		LDA	#$00		set default of zero
2B02 A8			TAY
2B03 F0 06		BEQ	2.f
2B05 AD 142C	1	LDA	par_1		get value
2B08 AC 152C		LDY	par_1+1
2B0B 8D 212C	2	STA	ep_beg		initialise eprom address
2B0E 8C 222C		STY	ep_beg+1
		;
		;work out length
2B11 AD 192C		LDA	parflg_2	second parameter?
2B14 D0 0A		BNE	1.f		branch if yes
2B16 AE 0C2C		LDX	dev_sel
2B19 BC 7B20		LDY	page_tab,X	get size of eprom, default
2B1C A9 FF		LDA	#$FF
2B1E D0 06		BNE	2.f		branch always
2B20 AD 162C	1	LDA	par_2
2B23 AC 172C		LDY	par_2+1
2B26 8D 232C	2	STA	ep_end
2B29 8C 242C		STY	ep_end+1
2B2C 38			SEC
2B2D ED 212C		SBC	ep_beg
2B30 8D 1B2C		STA	length
2B33 98			TYA
2B34 ED 222C		SBC	ep_beg+1
2B37 8D 1C2C		STA	length+1
2B3A B0 1A		BCS	1.f		branch if param2>=param1
2B3C 68		10	PLA
2B3D 20 BB23		JSR	print
2B40 696C6C6567		fcc	'illegal parameters',$00
2B45 616C207061
2B4A 72616D6574
2B4F 65727300
2B53 4C D12A		JMP	mp0
		;
		;check end address not bigger then rom
2B56 AE 0C2C	1	LDX	dev_sel
2B59 BC 7B20		LDY	page_tab,X	64K device?
2B5C 30 08		BMI	4.f		branch if yes
2B5E BD 7B20		LDA	page_tab,X
2B61 CD 242C		CMP	ep_end+1
2B64 90 D6		BCC	10.b		branch if pages less or equal
2B66 20 C124	4	JSR	rst_ad		initialise values
2B69 4C 9A2B		JMP	exec
		;
2B6C 98		8	TYA			save routine number
2B6D 48			PHA
		;get max number and type of parameters needed
		;then check valid
2B6E B9 572A		LDA	no_pars,Y
2B71 F0 2C		BEQ	exec1		branch if no checking
2B73 30 25		BMI	exec		branch if no parameter
2B75 0A			ASLA
2B76 30 18		BMI	7.f		branch if letter
2B78 0A			ASLA
2B79 30 0D		BMI	6.f		branch if one number
2B7B 0A			ASLA
2B7C 30 03		BMI	5.f		branch if two numbers
2B7E 4C F62A		JMP	14.b		get two addresses
		;
2B81 20 3D21	5	JSR	twopar
2B84 B0 07		BCS	3.f		branch on error
2B86 90 12		BCC	exec
		;
2B88 20 6D21	6	JSR	onepar
2B8B 90 0D		BCC	exec		branch on error
Eprom programmer          18-Jan-87 14:02                          page 21

2B8D 4C EF2A	3	JMP	9.b
		;
		;routine for a letter parameter
2B90 20 C320	7	JSR	incap		get letter
2B93 D0 02		BNE	2.f		branch if there is one
2B95 A9 00		LDA	#$00
2B97 8D 1A2C	2	STA	asc_1		save it
		;
		;execute routine
		;first check no more parameters
2B9A 20 AA20	exec	JSR	next
2B9D D0 EE		BNE	3.b
2B9F 68		exec1	PLA			get table number
2BA0 A8			TAY
2BA1 20 B22B		JSR	jump
2BA4 20 4225		JSR	romoff
2BA7 20 BB23	mp1	JSR	print
2BAA 0D0A4F4B00		fcc	$0D,$0A,'OK',$00
2BAF 4C D12A		JMP	mp0
		;
2BB2 B9 6B2A	jump	LDA	cmdhi,Y		high order (command addr - 1)
2BB5 48			PHA
2BB6 B9 612A		LDA	cmdlo,Y		low order (command addr - 1)
2BB9 48			PHA
2BBA 60			RTS			dummy return

Eprom programmer          18-Jan-87 14:02                          page 22

				global labels

ACR       180B	COLDSTA   2A75	DIRA      1803	DIRB      1802	EC_tab    20A3
ECset     25C2	IER       180E	IFR       180D	OE_tab    2087	PCR       180C
PORTA     1801	PORTB     1800	T1CH      1805	T1CL      1804	T1LH      1807
T1LL      1806	asc_1     2C1A	base      2C0D	begin     2000	break     2A35
brkvec    1A7C	buf_ptr   2C0F	buf_size  2C10	ch1       283C	ch2       2854
char      20CF	check     2829	cmdhi     2A6B	cmdlo     2A61	cmnds     2A4D
contin    21F9	count     2C1D	crlf      21DB	cs_tab    208E	ctrl_set  25F0
ctrl_set1 25ED	delay     25B8	dev_sel   2C0C	dump      2976	ep_beg    2C21
ep_end    2C23	ep_ptr    2C1F	epnam     23DA	epnam2    23DD	error     223A
exec      2B9A	exec1     2B9F	fillb1    219E	fillbuf   2199	getbase   2864
hex_conv  20DE	incad     2514	incap     20C3	inhex     2109	jump      2BB2
keybuf    2C27	keyinp    20C0	labjun    105F	latch     24E0	length    2C1B
lwsp      2C09	mem       2C00	membeg    0030	memend    00D0	memzer    00C0
menu      225B	mistake   222A	mod_ad    2C25	modify    28CA	mp0       2AD1
mp1       2BA7	names     2003	ncs_tab   2095	next      20AA	nmivec    1A7A
no_dev    000C	no_pars   2A57	num       2C11	num_byt   2C13	oldbrk    2C01
oldnmi    2C03	onepar    216D	page      2C07	page_tab  207B	par_1     2C14
par_2     2C16	par_end   2195	par_err   2197	parflg_1  2C18	parflg_2  2C19
pg_tab    209C	pr1       2698	pr3       26AC	pr4       26DC	prbyt     21E2
prcha     1334	print     23BB	progall   2672	prtbase   288E	prtnib    21ED
prv_tab   2063	ptrh      00C3	ptrl      00C2	pulse     25FE	pwsp      2C08
quit      28A9	rd1       274D	rd2       2773	rdmode    25F8	rdvolts   259F
read      26DD	read1     26E0	readall   270B	reccha    12AE	ret       23D3
retadd    00C0	romna1    2412	romna2    2473	romna3    246F	romnam    23F3
romoff    2542	romon     2553	romwsp    2C05	rst_ad    24C1	set_ad    2504
setv      25AD	setv3     25AF	setv4     25B3	space     2255	stack     2C00
twopar    213D	typ_tab   206F	type      2C0B	unsel     2702	ver       2774
verad     277A	verify    2788	via       1800	vpp0      259B	vpp5      2597
vwsp1     2C06	wspepn    2C0A

Errors detected: 0
