 ;* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 ;Program name: VIDI.MAC
 ;Creation date: 2 DEC 1986
 ;Update: VARIOUS
 ;Version V1.7
 ;Release version: V2.1  MEI 1987
 ;Programmer: Bram de Bruine
 ;Program requirements: XXXX bytes
 ;Hardware: DOS 65
 ;Purpose: VIDEOTEX COMMUNICATION VIA RS232
 ;Program description: VARIABLES/CONSTANTS COMMUNICATIONPRG
 ;* * * * * * * * * * * * * * * * * * * * * * * * * * * * *

 ;EXTENSION FILES: 
 ;	-VIDI1.MAC
 ;	-VIDI2.MAC
 ;	-SELECT.MAC
 ;	-VIDITEL.MAC (* NOT YET IMPLEMENTED)
 ;	-DIAL.MAC

 ;UTILITIES:
 ;	-MCONFIG HELPS TO CONFIGURATE THIS PROGRAM FOR A CERTAIN MODEM

	ORG	$A000	;Define startvector
VIDI	JMP	$1000

 ;---DEFINITIONS ENTRIES VARIABLES---

	LIB	DOSLIB

 ;Timer 1 is used for the receiverclock of the acia
 ;When operating at split speed
 ;Timer 2 is used for interfacing with interspeeder
 ;Modems without hardware handshake

 ;Part dependent on split variable (if split=0)
 ;Speedconversion 1200/75 - 75/1200 modem-->acia
 ;Pb7 via2 is clockoutput and must be connected with rxc
 ;Pen 5 acia

FREMODE	EQU	%11000000	;Free running t1
STOPRXC	EQU	%00111111	;Disable free running t1
MODET2	EQU	%11100011	;Timer 2 sr disabled
	;Oscillatorfrequencies dependend on systemclock
	;-2 correction count from zero, wrap around endvalue
T1200	EQU	417	;833/2=417 us   base 1mhz
T19K2	EQU	26	;26/2=13 us

T12001	EQU	T1200-1		;1mhz
T19K21	EQU	T19K2-1
T12002	EQU	T1200*2-1	;2mhz                  
T19K22	EQU	T19K2*2-1
T12003	EQU	T1200*3-1	;3mhz
T19K23	EQU	T19K2*3-1	
T12004	EQU	T1200*4-1	;4mhz
T19K24	EQU	T19K2*4-1

	;Constants interspeeder delay with t2 via2
WAI	EQU	2		;Counts waitloop entered. base 1mhz
CDT2L	EQU	$24		;Initial value t2
CDT2H	EQU	$F4
	;Conversion delay = 125 msec
	;T2del = 125.000/2=62.500 == $f424
	;Cdelay = 125 msec if delval=wai1,2,3,4

	;Constanten
CAN	EQU	$18	;CANCEL

	;Communication parameters acia
NOPAR	EQU	%00000101	;NO PARITY
RTSEN	EQU	%00000100	;RTS ACTIVE
EPAR	EQU	%01100100	;EVEN PARITY
DTREN	EQU	%00000101	;DTR ON/OFF
DTRDIS	EQU	%11111110
BEGLO	EQU	$00	;Startaddress storage memory
BEGHI	EQU	$36	;*********
ENDMEM	EQU	$9E	;Endaddress (hi-only)
MAXTRAN	EQU	$FF	;Length transmitter buffer
	;Constants autodialer
TELBEG	EQU	$800	;2k buffer tel.dir
TELEND	EQU	$1000	;End buffer tel.dir

	;Page zero locations
MEM	EQU	$90	;Storage memory pointer
POI	EQU	MEM+2	;End of file marker
TELTXT	EQU	MEM+4	;Pointer autodialer
TEMP	EQU	MEM+6	;Temporary pointer
PAG	EQU	MEM+8	;VIDITEL PAGEPOINTER
VIM	EQU	PAG+2	;Viditel readpointer
PRI	EQU	PAG+4	;VIDITEL PRINTPAGE POI

;Function of pointers
;Poi = end of file, if file is loaded from disk, else poi=beglo/hi
;Mem = end of file, if file is received from modem, else mem=beglo/hi
;Vim = readpointer, varies from beglo/hi until mem or poi

	;VIDITELPAGE
PAGLO	EQU	$00
PAGHI	EQU	$9C
PAGEND	EQU	$A0

;Viditel version 2.6 86-09-27 
;Last rev.      86-12-03
;Dos 65 edition 3.2.87

;
;VARIABLES DOS 65
RAMPTR	EQU	$A0
VIDRAM	EQU	$E800
SEC1D20	EQU	$E737	;1/20 SEC TIMER


	;Interne variabelen van communicatieprogramma
RECBUF	EQU	$0200	;Receiverbuffer $200-$3ff
TRANBUF	EQU	$0300	;Transmitterbuffer $300-$3ff

	ORG	$0400
	;Hayes-strings
HAYSTR	FCC	'AT\r',0,0,0,0,0,0,0,0,0,0,0,0,0	;Y=00
 	FCC	'ATS13=0\r',0,0,0,0,0,0,0,0		;Y=10
	FCC	'ATS13=12\r',0,0,0,0,0,0,0		;Y=20
	FCC	'\r',0,0,0,0,0,0,0,'ATA;\r',0,0,0	;Y=30,y=38

	;Macro strings
MC1	FCC	'KLANTNUMMER#',0,0,0,0		;Y=40
MC2	FCC	'CODENR.#',0,0,0,0,0,0,0,0	;Y=50
MC3	FCC	'PRIVECODE#',0,0,0,0,0,0	;Y=60
MC4	FCC	'Many-used-string\r'		;Y=70
	FCB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	;Notice: the last macro has double length !

CRTTAB	FCB	$7E,$28,$50,$88,$1E,$00
	FCB	$19,$1C,$00,$09,$00,$09
	FCB	$00,$00,$00,$00,40,$18
	;CRTTAB+9 contains the number of scanlines
	;for octopus this is 08, for dos-65 it is $09.
	;COMPLETE TABLE CHANGED FOR DOS-65
	RES	18,$20	;Futural expansion
ATD	FCC	'ATD'	;Hayes dial command
PUTO	FCC	'P'	;Pulse, tone or def dialing
DIALBUF	RES	17,0	;Buffer used by autodial

	;Configuration flags
CLOCK	RES	1,1	;Processorspeed 1,2,3 & 4 mhz
SPLIT	RES	1,$FF	;Split baud modem 75/1200
HAYES	RES	1,$0	;Zero, if smart modem used
EXTRA	RES	1,$00	;Autobaud modem initialisation
DIALFLG	RES	1,$FF	;Transp. modem: 00=autodial
PROTOCO	RES	1,2	;Protocolchoice
TIMFL	RES	1,0	;0=update time, <>0 don't
	;*:*:*:*:* do not change table below :*:*:*:*:*
ECHO	FCB	$FF	;Fullduplex = ff {defauld}
ANSORG	FCB	$0	;Originate = 00 {defauld}
WORDFOT	FCC	'B'	;A=8n1, b=7e1 {defauld}
BAUDPAR	FCB	4	;Baudrate {defauld}
	;*:*:*:*:* end table :*:*:*:*:*
CFG1	FCB	$FF	;0=astrid, $ff=viditel configuration
CFG2	FCC	'2'	;Version number hi
EXTOSC	RES	1,$FF	;00=external acia osc (outside uc)
			;Ff=via-osc for acia (only if split=0)
CHRGEN	RES	1,2	;O=OCTOPUS, ELSE DOS65 V1,V2
MONIT	RES	1,5	;5=50HZ,6=60HZ,7=71HZ
AUTREV	RES	1,$FF	;AUTO REVEAL ON/OFF
	RES	2,0	;Futural expansion

	;Keycodes menu transfer parameters
KEYUP	FCB	$0B	;^
KEYDOW	FCB	$0A	;Lf
KEYBAC	FCB	$08	;Bs
KEYFOR	FCB	$09	;Ht
KEYBRK	FCB	ESC	;Common breakkey
KEYPUP	FCB	$17	;^w page up
KEYPDO	FCB	$1A	;^z page down
	RES	3,0	;Futural expansion

	;Keycodes macro expansion
KEYMAC	FCB	$0E	;^n macro-key (2nd)
MKHELP	JSR	JVITXT
KEYMAC1	FCC	'1'	;Macro 1
	FCC	','
KEYMAC2	FCC	'2'	;Macro 2
	FCC	','
KEYMAC3	FCC	'3'	;Macro 3
	FCC	','
KEYMAC4	FCC	'4'	;Macro 4
	FCB	0
	RTS

	ORG	$1000
	JMP	START	;0
	;Jumptabel routines usable for external modules
SEN2	JMP	EN2	;+3 sen2 destroys x
PARPROG	JMP	PARCHO	;+6
IGET	JMP	GET	;+9
LASTIME	JMP	SETTIM	;+c
JVITXT	JMP	VITXT	;+F

	;Flags and variables
	;VIDITELVARIABLES
TOP	RES	1	;Vim points to top of file
BOT	RES	1	;Vim points to bottom of file
	;Buffers, disk variables
RECPNT	RES	1,0	;Number of char in receiver queue
TRANPNT	RES	1,0
NBUF	RES	20,0	;Filenamebuffer
FNPNT	RES	1,0	;Filenamelength
FILENR	RES	1	;Savelocation filenr disk i/o
CONTR	FCB	BEGLO,BEGHI	;Controlblock disk i/o
BYLO	RES	1	;Fileinfo filelength
BYHI	RES	1	;Filelength/number of blocks
BYEXT	RES	1	;Number of blocks hi
FLL	RES	1,0	;Extended filelength (3thd byte)
TOBIG	RES	1	;File too large
ASCOHEX	RES	1	;Asc or hex file to disk ?
	;COMMON VAR/FLASS
STRAN	RES	4	;Savearea echo t/m baudpar
SACIINT	RES	2	;Save location acia intvec
SKEYINT	RES	2	;       keyb
SDLYINT	RES	2	;	tim2.2
BREAK	RES	1,$FF	;Zero, if break occurred
CANFLG	RES	1,$FF	;Up/downloading cancelled ?
BAUD	RES	1	;Baudratecode ,masked from acia
MOCOM	RES	1	;Commando copy acia
MOCTR	RES	1	;Copy ctl acia
SSTATOG	RES	1
STORAGE	RES	1,$FF
SCURPX	RES	1	;Copy cursorposition
SCURPY	RES	1
ASAVE	RES	1	;Common used temps
XSAVE	RES	1
YSAVE	RES	1
XTEMP	RES	1
LHOUR	RES	1	;Rtc/time variables
LMINU	RES	1
M0	RES	1
H0	RES	1
TM0	RES	1
MIN	RES	1
SMIN	RES	1
TH0	RES	1
HOUR	RES	1
SHOUR	RES	1
DM0	RES	1
DH0	RES	1	;End time variable list
TRY1	RES	1,0	;Error try again filename input
FIFORM	RES	1	;File format 0=hex, else asc
EMPTYM	RES	1	;Data in memoryspace ?
OOM	RES	1	;Out of memoryflag
UPA	RES	1,$FF	;Ascii upload flag
HALFBL	RES	1	;Restblock uploading
TIM1L	RES	1	;Necessary for prog via by splitspeed
TIM1H	RES	1
EXSTRI	RES	1
DOS	RES	1,$FF	;Execute a doscommand
STIMFL	RES	1	;Save location timfl
INPUT	RES	1,$FF	;Input to keybuf if 0
FINISH	RES	1,PAGHI	;End of memory value
AHOLD	RES	1	;Save location a
SUSPEND	RES	1,$FF	;Flag ^s sended
MACRO	RES	1,$FF	;00 if macro key pressed
MACIND	RES	1	;Macro number for define menu
YHAST	RES	1	;Savelocation y in hast subroutine
DELAY	RES	1	;Interspeeder: delay 1200/75 conversion
CDELAY	RES	1	;Conv. 1200/75 delay timer
OSCEN	RES	1,$FF	;Split osc enabled if 0
SKEYMAC	RES	1	;Save loc. keymac
CRFLG	RES	1,$FF	;Flag cr detected
LFCONV	RES	1,$FF	;Convert cr to crlf if 0
LOCFG	FCC	'LOAD S:VIDITEL.CFG 400,4FF',0

	;Variabels, names autodialer
TELNAME	FCC	'S:VITEL.dir',0
CRCOUNT	RES	1	;Number of cr's
TELFINR	RES	1	;Filenr. tel.dir
STELTXT	RES	2	;Saveloc teltxt pointer
LIN	RES	1	;Linenr pointed by cursor
PAGE	RES	1	;Current pagenr
SPAGE	RES	1	;Saveloc page
TELCLOS	RES	1	;File tel.dir close=00
DESTROY	RES	1	;Block tel.dir loaded if 0
RESTART	RES	1	;Open file after not destroyed
DIERR	RES	1	;Dial error flag
OEF	RES	1	;END OF DISKFILE
OPTPAT	RES	1	;OPTIONS PATTERN
NAMFO	RES	1	;COPY NAMB
AUTTER	RES	1	;IF 0 AUTO TERMINALMODE
LOGFLG	FCB	$FF	;0=LOGGINGMODE

	;Table clockdependent values
CL1	FCB	T12001&255,T12001>>8	;Lo,hi value t1-init 75
	FCB	T19K21&255,T19K21>>8	;Lo,hi 1200 b
	FCB	WAI			;Count waitloop
CL2	FCB	T12002&255,T12002>>8	;Lo,hi value t1-init 75
	FCB	T19K22&255,T19K22>>8	;Lo,hi 1200 b
	FCB	WAI*2
CL3	FCB	T12003&255,T12003>>8	;Lo,hi value t1-init 75
	FCB	T19K23&255,T19K23>>8	;Lo,hi 1200 b
	FCB	WAI*3
CL4	FCB	T12004&255,T12004>>8	;Lo,hi value t1-init 75
	FCB	T19K24&255,T19K24>>8	;Lo,hi 1200 b
	FCB	WAI*4
TIM75L	RES	1	;User clock var.
TIM75H	RES	1	;Startvalue t1 75 baud if split
TIM12L	RES	1	;Startvalue t1 1200 baud if split
TIM12H	RES	1
DELVAL	RES	1	;Conv. 1200/75 delay timer startvalue
	FCC	'(C) B. de Bruine 2-12-1986'

	;Mmmmmmmmmmmmmm macro definitions mmmmmmmmmmmmmmmm

POSIT	MACRO	XPOS,YPOS	;Set cursor at x,y
	LDX	#XPOS
	LDY	#YPOS
	JSR	POSIC
	ENDM

MOVE	MACRO	SOURCE,DEST
			;Move contents source address to destination
			;Communicationreg = a
	LDA	SOURCE
	STA	DEST
	ENDM

MOVEM	MACRO	SOU,DES	;Move multiple (2) databytes
	LDA	SOU	;From sou,sou+1 to des,des+1
	STA	DES	;Communicationreg = a
	LDA	SOU+1
	STA	DES+1
	ENDM

MOVEQ	MACRO	A,B	;Move immediate data a to destination b
	LDA	#A
	STA	B
	ENDM

TYPE	MACRO	PRI$	;Print pri$
	JSR	PRINT
	FCC	PRI$,0
	ENDM

	CONT	VIDI1
