DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 0

		;UNIVERSAL TERMINAL FOR DOS 65 version 2.0x
		;
		;  ****************************************************
		;  *                                                  *
		;  *  By Andrew Gregory, England                      *
		;  *                                                  *
		;  ****************************************************
		;
		;
		;This version requires baud/parity settings to be set
		;with RS232 utiliity and stored at $E734. The interrupt
		;and DTR status is restored at the end of the program.
		;
		;The menu line error in v0.21 has been corrected.
		;Now printer output control codes are filtered.
		;Screen time out works - but non-standard routines
		;Baud rate options added
		;
		;Improvements and additions still needed:
		; - Check on effects of control/escape characters. 
		;   Make VT52 compatible.
		; - Allow host to switch printer on and off with Ascii DC1
		; - Add Xon/Xoff option
		; - Provide an indication on the status line of 
		;   framing and parity errors
		; - Provide indication of DCD not detected
		; - For unknown reason if ^S typed as program
		;   loaded DOS65 seizes on leaving terminal
		;   correct this bug.
		;
		;I/O65 routines.
	  F921	toffsc	equ	$F921		turn screen off if time out
	  F92F	tonsc	equ	$F92F		screen on
	  F01B	cwhsln	equ	$F01B		clear status line
	  F01E	maksln	equ	$F01E		make status line
	  F021	norstat	equ	$F021		restore status
	  F024	posit	equ	$F024		position cursur
	  F027	unpos	equ	$F027		get old position
		;
		;I/O65 variables.
	  E7AD	start	equ	$E7AD		pointer to video ram
	  E734	aciadat	equ	$E734
	  E7B7	keypnt	equ	$E7B7
		;
		;DOS65 routines
		;
		;DOS65 variables
	  00FE	opt	equ	$00FE		option bits
		;
		;interface addresses
	  E130	ACIA	equ	$E130
	  E100	VIAA	equ	$E100
	  E110	VIAB	equ	$E110
	  E140	CRTCAR	equ	$E140
	  E141	CRTCRF	equ	$E141
		;
		;assignments
	  E130	RECREG	equ	ACIA		;Receive register
	  E130	TRAREG	equ	ACIA		;Transmit register
	  E131	ACIASR	equ	ACIA+1		;Status register
	  E132	ACICMD	equ	ACIA+2		;Command register
	  E133	ACICTL	equ	ACIA+3		;Control register
		;
	  E100	VAPBD	equ	VIAA
	  E101	VAPAD	equ	VIAA+01
	  E10D	VAIFR	equ	VIAA+$0D
	  E110	VBPBD	equ	VIAB
		;
	  E76C	aciavec	equ	$E76C		ACIA interrupt vector
	  E75A	keyvec	equ	$E75A		VIA interrupt vector
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 1

		;
	  0018	p_beg	equ	$18		first page of printer pr_buf
	  00A0	p_end	equ	$A0		last page+1 of printer pr_buf
		;
		;zero page workspace
		;
	  0080		org	$80
		;
0080		rw_ad	res	2		address of menu line char
0082		prq_in	res	2		address of printer queue in
0084		prq_out	res	2		address of printer queue out
0086		vpar	res	2		communication parameters v
0088		wpar	res	2		w
008A		xpar	res	2		x
008C		ypar	res	2		y
008E		zpar	res	2		z
		;
	  0200		org	$0200		workspace
		;
0200		retadd	res	2		return address on completion
0202		retstk	res	1		stack after subroutine
0203		b_tmp	res	1		temp buffer for file chars
0204		dev_tmp	res	1
0205		file_tp	res	1
0206		nib_tmp	res	1		temporary store
0207		b_len	res	2		data number
0209		oldkey	res	2		old KEYBD vector
020B		oldacia	res	2		old ACIA vector 
020D		fname_buf res	20		filename for transfer
0221		fname_len res	1		length of filename
0222		tra_end	res	1		transmitted flag
0223		dcdflg	res	1		indicates state of DCD
		;
		;send buffer contains characters waiting to be sent to 
		;the screen and RS232 output. A character cannot be
		;printed on screen until it is transmitted - to keep 
		;order correct.
0224		send_buf res	16		queue of transmit characters
0234		send_num res	1		number of chars in send_buf
0235		send_in	res	1		next in pointer
0236		send_out res	1		next out pointer
		;
		;output buffer - for output to screen, printer and disc
0237		op_tmp	res	1		save transmitted char here
0238		op_buf	res	16		queue of characters for output
0248		op_num	res	1		number of chars in op_buf
0249		op_in	res	1		next in pointer
024A		op_out	res	1		next out pointer
		;
024B		key_rec	res	1		keyboard char rec flag
024C		key_char res	1		keyboard char received
024D		brk_rec	res	1		indicates control C break
024E		delay	res	1		required delay
024F		waitflg	res	1		count of delay characters
0250		cflag	res	1		indicates C option
0251		dflag	res	1		indicates D option
0252		kflag	res	1		indicates K option
0253		lflag	res	1		indicates L option
0254		mflag	res	1		indicates M option
0255		pflag	res	1		indicates P option
0256		no_plf	res	1		block next printer char if LF
0257		scrbeg	res	2		beginning of screen
0259		mpos	res	1		position on menu line
025A		mset	res	1		indicates menu set
025B		stlnn	res	1		indicates which status line
025C		fileflg	res	1		indicates output file open
025D		filecode res	1		contains file number
025E		pr_on	res	1		printer buffer status
025F		pr_num	res	2		number of characters in pr_buf
0261		svline	res	80		saved line under menu
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 2

		;
	  0800		org	$0800
0800 4C E40B		JMP	begin		start of program
		;
		;give help reply
0803 C8C5CCD04C		fcc	$C8,$C5,$CC,$D0,$4C,$4C,$4C Help in inverse
0808 4C4C
080A 0D554E4956		fcc	'\rUNIVERSAL TERMINAL version 0.23'
080F 455253414C
0814 205445524D
0819 494E414C20
081E 7665727369
0823 6F6E20302E
0828 3233
082A 0D0D202053		fcc	'\r\r  Syntax:  TERMinal [-CDKLMP +v,w,x,y,z]'
082F 796E746178
0834 3A20205445
0839 524D696E61
083E 6C205B2D43
0843 444B4C4D50
0848 202B762C77
084D 2C782C792C
0852 7A5D
0854 0D20204F70		fcc	'\r  Options: -C : Print unknown control '
0859 74696F6E73
085E 3A202D4320
0863 3A20507269
0868 6E7420756E
086D 6B6E6F776E
0872 20636F6E74
0877 726F6C20
087B 6368617261		fcc	'characters on screen [ ]'
0880 6374657273
0885 206F6E2073
088A 637265656E
088F 205B205D
0893 0D20202020		fcc	'\r           -D : Delay after '
0898 2020202020
089D 20202D4420
08A2 3A2044656C
08A7 6179206166
08AC 74657220
08B0 6561636820		fcc	'each character '
08B5 6368617261
08BA 6374657220
08BF 647572696E		fcc	'during file transfer. For'
08C4 672066696C
08C9 6520747261
08CE 6E73666572
08D3 2E20466F72
08D8 0D20202020		fcc	'\r                systems without '
08DD 2020202020
08E2 2020202020
08E7 2020737973
08EC 74656D7320
08F1 776974686F
08F6 757420
08F9 68616E6473		fcc	'handshaking (e.g. Junior)'
08FE 68616B696E
0903 672028652E
0908 672E204A75
090D 6E696F7229
0912 0D20202020		fcc	'\r           -K : Keep local copy of '
0917 2020202020
091C 20202D4B20
0921 3A204B6565
0926 70206C6F63
092B 616C20636F
0930 7079206F66
0935 20
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 3

0936 6368617261		fcc	'characters typed from keyboard'
093B 6374657273
0940 2074797065
0945 642066726F
094A 6D206B6579
094F 626F617264
0954 0D20202020		fcc	'\r           -L : Transmit line feed with CR'
0959 2020202020
095E 20202D4C20
0963 3A20547261
0968 6E736D6974
096D 206C696E65
0972 2066656564
0977 2077697468
097C 204352
097F 0D20202020		fcc	'\r           -M : Add line '
0984 2020202020
0989 20202D4D20
098E 3A20416464
0993 206C696E65
0998 20
0999 6665656420		fcc	'feed to a CR received'
099E 746F206120
09A3 4352207265
09A8 6365697665
09AD 64
09AE 0D20202020		fcc	'\r           -P : Do not send LF '
09B3 2020202020
09B8 20202D5020
09BD 3A20446F20
09C2 6E6F742073
09C7 656E64204C
09CC 4620
09CE 746F207072		fcc	'to printer after CR'
09D3 696E746572
09D8 2061667465
09DD 72204352
09E1 0D2020202B		fcc	'\r   +v,w,x,y,z : Communication parameters '
09E6 762C772C78
09EB 2C792C7A20
09F0 3A20436F6D
09F5 6D756E6963
09FA 6174696F6E
09FF 2070617261
0A04 6D65746572
0A09 7320
0A0B 2864656661		fcc	'(defaults to original settings)'
0A10 756C747320
0A15 746F206F72
0A1A 6967696E61
0A1F 6C20736574
0A24 74696E6773
0A29 29
0A2A 0D0D20763D		fcc	'\r\r v=transmit baud : 1-External  2-50  '
0A2F 7472616E73
0A34 6D69742062
0A39 617564203A
0A3E 20312D4578
0A43 7465726E61
0A48 6C2020322D
0A4D 35302020
0A51 332D373520		fcc	'3-75  4-110  5-134  6-150  7-300  8-600'
0A56 20342D3131
0A5B 302020352D
0A60 3133342020
0A65 362D313530
0A6A 2020372D33
0A6F 3030202038
0A74 2D363030
0A78 0D20202020		fcc	'\r                   9-1200  10-1800  '
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 4

0A7D 2020202020
0A82 2020202020
0A87 2020202020
0A8C 392D313230
0A91 3020203130
0A96 2D31383030
0A9B 2020
0A9D 31312D3234		fcc	'11-2400  12-3600  13-4800  14-7200'
0AA2 3030202031
0AA7 322D333630
0AAC 3020203133
0AB1 2D34383030
0AB6 202031342D
0ABB 37323030
0ABF 0D20202020		fcc	'\r                   15-9600  16-19200'
0AC4 2020202020
0AC9 2020202020
0ACE 2020202020
0AD3 31352D3936
0AD8 3030202031
0ADD 362D313932
0AE2 3030
0AE4 0D20773D77		fcc	'\r w=word length   : 1-8 bits  '
0AE9 6F7264206C
0AEE 656E677468
0AF3 2020203A20
0AF8 312D382062
0AFD 6974732020
0B02 322D372062		fcc	'2-7 bits  3-6 bits  4-5 bits'
0B07 6974732020
0B0C 332D362062
0B11 6974732020
0B16 342D352062
0B1B 697473
0B1E 0D20783D70		fcc	'\r x=parity        : 1-None  2-Odd  '
0B23 6172697479
0B28 2020202020
0B2D 2020203A20
0B32 312D4E6F6E
0B37 652020322D
0B3C 4F64642020
0B41 332D457665		fcc	'3-Even  4-Mark  5-Space'
0B46 6E2020342D
0B4B 4D61726B20
0B50 20352D5370
0B55 616365
0B58 0D20793D73		fcc	'\r y=stop bits     : 1-1 bit  2-1 1.5 or '
0B5D 746F702062
0B62 6974732020
0B67 2020203A20
0B6C 312D312062
0B71 6974202032
0B76 2D3120312E
0B7B 35206F7220
0B80 3220626974		fcc	'2 bits (depends on w and x)'
0B85 7320286465
0B8A 70656E6473
0B8F 206F6E2077
0B94 20616E6420
0B99 7829
0B9B 0D207A3D72		fcc	'\r z=receive baud  : 0-same as transmitter '
0BA0 6563656976
0BA5 6520626175
0BAA 6420203A20
0BAF 302D73616D
0BB4 6520617320
0BB9 7472616E73
0BBE 6D69747465
0BC3 7220
0BC5 2864656661		fcc	'(default)  1-external',0
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 5

0BCA 756C742920
0BCF 20312D6578
0BD4 7465726E61
0BD9 6C00
		;
		;tables
0BDB 00204060	wltab	fcc	$00,$20,$40,$60
0BDF C02060A0E0	ptab	fcc	$C0,$20,$60,$A0,$E0
		;
0BE4 08		begin	PHP			save dec, int flags
0BE5 78			SEI
0BE6 D8			CLD
		;
		;check a suitable I/O 65 ROM
0BE7 48			PHA			save string address
0BE8 AD 2FF9		LDA	tonsc		non-standard routine
0BEB C9 08		CMP	#$08		is it here?
0BED F0 1F		BEQ	beg1		branch if yes
0BEF 68			PLA
0BF0 20 3BC0		JSR	print
0BF3 57726F6E67		fcc	'Wrong version of I/O65\r',0
0BF8 2076657273
0BFD 696F6E206F
0C02 6620492F4F
0C07 36350D00
0C0B 4C DF0D		JMP	exit
		;
0C0E 68		beg1	PLA
0C0F 20 68C0		JSR	sopt
0C12 444B4C434D		fcc	'DKLCMP',0
0C17 5000
0C19 90 17		BCC	1.f		branch if OK
0C1B 20 3BC0	2	JSR	print
0C1E 496C6C6567		fcc	'Illegal options\r',0
0C23 616C206F70
0C28 74696F6E73
0C2D 0D00
0C2F 4C DF0D		JMP	exit
		;
0C32 A2 C0	1	LDX	#$C0
0C34 20 6BC0		JSR	spar		get baud rate options
0C37 86888A8C8E		fcc	vpar,wpar,xpar,ypar,zpar,0
0C3C 00
0C3D B0 DC		BCS	2.b
		;
		;get baud/parity of ACIA
0C3F E0 00		CPX	#$00
0C41 D0 09		BNE	8.f		+ options entered
0C43 AD 35E7		LDA	aciadat+1	command reg at $E735
0C46 AC 34E7		LDY	aciadat		control reg at $E734
0C49 4C A90C		JMP	aciainit
		;
		;sort out baud rate options
0C4C A4 86	8	LDY	vpar		baud rate
0C4E 88			DEY
0C4F C0 10		CPY	#$10		entry too big?
0C51 B0 2E		BCS	6.f		error
0C53 98			TYA
0C54 A4 8E		LDY	zpar		receiver clock
		; this bit of code could be expanded
		; to set rate from 6522 clock output
0C56 F0 05		BEQ	4.f
0C58 88			DEY
0C59 D0 26		BNE	6.f
0C5B F0 02		BEQ	5.f
0C5D 09 10	4	ORA	#$10
0C5F A4 88	5	LDY	wpar		word length
0C61 88			DEY
0C62 C0 04		CPY	#$04		too big?
0C64 B0 1B		BCS	6.f
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 6

0C66 19 DB0B		ORA	wltab,Y
0C69 A4 8C		LDY	ypar		stop bits
0C6B 88			DEY
0C6C F0 05		BEQ	7.f
0C6E 88			DEY
0C6F D0 10		BNE	6.f
0C71 09 80	5	ORA	#$80
0C73 A8		7	TAY			control register into Y
0C74 A6 8A		LDX	xpar		parity
0C76 CA			DEX
0C77 E0 05		CPX	#$05		too big?
0C79 B0 06		BCS	6.f
0C7B BD DF0B		LDA	ptab,X		parity table
0C7E 4C A90C		JMP	aciainit
0C81 20 3BC0	6	JSR	print
0C84 496C6C6567		fcc	'Illegal communication parameters\r',0
0C89 616C20636F
0C8E 6D6D756E69
0C93 636174696F
0C98 6E20706172
0C9D 616D657465
0CA2 72730D00
0CA6 4C DF0D		JMP	exit
		;
0CA9 29 E5	aciainit AND	#%11100101	turn on interrupts
0CAB 09 05		ORA	#%00000101
0CAD 8D 31E1		STA	ACIASR		Reset ACIA
0CB0 8D 32E1		STA	ACICMD		Set value of command reg
0CB3 8C 33E1		STY	ACICTL		Set value of control reg
0CB6 AD 31E1		LDA	ACIASR
0CB9 29 20		AND	#%00100000	get DCD
0CBB 8D 2302		STA	dcdflg
		;
		;Change ACIA interrupt vector and save old
0CBE AD 6CE7		LDA	aciavec		get old interrupt vector
0CC1 AE 6DE7		LDX	aciavec+1
0CC4 8D 0B02		STA	oldacia		save it
0CC7 8E 0C02		STX	oldacia+1
0CCA A9 C4		LDA	#int_acia-1&255	get new vector
0CCC A2 13		LDX	#int_acia-1>>8
0CCE 8D 6CE7		STA	aciavec		store it
0CD1 8E 6DE7		STX	aciavec+1
		;
		;Change keyboard interrupt vector and save old
0CD4 AD 5AE7		LDA	keyvec		get old interrupt vector
0CD7 AE 5BE7		LDX	keyvec+1
0CDA 8D 0902		STA	oldkey		save it
0CDD 8E 0A02		STX	oldkey+1
0CE0 A9 45		LDA	#int_key-1&255	get new vector
0CE2 A2 14		LDX	#int_key-1>>8
0CE4 8D 5AE7		STA	keyvec
0CE7 8E 5BE7		STX	keyvec+1
		;
		;initialise flags
0CEA A9 00		LDA	#$00
0CEC A2 3F		LDX	#(pr_num+2-tra_end)
0CEE 9D 2102	1	STA	tra_end-1,X
0CF1 CA			DEX
0CF2 D0 FA		BNE	1.b
0CF4 20 3C11		JSR	pr_init		initialise printer variables
		;
0CF7 20 5111		JSR	formfeed	clear screen
0CFA A9 68		LDA	#$68
0CFC A2 0A		LDX	#$0A
0CFE 20 0413		JSR	wrcrtc		restore cursor
		;
0D01 A2 FF		LDX	#$FF
		;
0D03 A9 04		LDA	#$04		P option?
0D05 25 FE		AND	opt
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 7

0D07 F0 03		BEQ	1.f
0D09 8E 5502		STX	pflag
		;
0D0C A9 08	1	LDA	#$08		M option?
0D0E 25 FE		AND	opt
0D10 F0 03		BEQ	1.f
0D12 8E 5402		STX	mflag
		;
0D15 A9 10	1	LDA	#$10		C option?
0D17 25 FE		AND	opt
0D19 F0 03		BEQ	1.f
0D1B 8E 5002		STX	cflag
		;
0D1E A9 20	1	LDA	#$20		L option?
0D20 25 FE		AND	opt
0D22 F0 03		BEQ	1.f
0D24 8E 5302		STX	lflag
		;
0D27 A9 40	1	LDA	#$40		K option?
0D29 25 FE		AND	opt
0D2B F0 03		BEQ	1.f
0D2D 8E 5202		STX	kflag
		;
0D30 A9 80	1	LDA	#$80		D option?
0D32 25 FE		AND	opt
0D34 F0 0B		BEQ	loop
0D36 A9 06		LDA	#$06
0D38 8D 5102		STA	dflag
		;
0D3B 20 1913		JSR	no_pmark
0D3E 20 0F13		JSR	no_fmark
		;
0D41 A0 5D	loop	LDY	#m_online&255
0D43 A9 14		LDA	#m_online>>8
0D45 20 1EF0		JSR	maksln		print status line
0D48 20 27F0		JSR	unpos
0D4B A9 00		LDA	#$00
0D4D 8D 5B02		STA	stlnn
0D50 8D 4D02		STA	brk_rec
0D53 8D 4E02		STA	delay		make D option ineffective
0D56 58			CLI
0D57 AD 4D02	loop1	LDA	brk_rec		break?
0D5A D0 18		BNE	offline
0D5C AD 3402		LDA	send_num	is there room?
0D5F C9 0C		CMP	#$0C
0D61 B0 08		BCS	3.f		branch if no
0D63 20 5E11		JSR	getkey		char entered through keyboard?
0D66 F0 03		BEQ	3.f		branch if no
0D68 20 7511		JSR	send_add	add to output queue
0D6B 20 BB11	3	JSR	all_out
0D6E 20 1011		JSR	int_set		DTR off if queues too long
0D71 4C 570D		JMP	loop1
		;
		;Offline
0D74 AD 5102	offline	LDA	dflag
0D77 8D 4E02		STA	delay		make delay effective
0D7A A0 AD		LDY	#m_offline&255
0D7C A9 14		LDA	#m_offline>>8
0D7E 20 1EF0		JSR	maksln
0D81 20 F210		JSR	waitforq	wait for queues or break again
0D84 A9 17	off2	LDA	#$17
0D86 20 7310		JSR	messxa
0D89 20 5811	6	JSR	waitkey
0D8C A2 00		LDX	#$00		clear any breaks
0D8E 8E 4D02		STX	brk_rec
0D91 29 DF		AND	#$DF		upper case to lower
0D93 C9 43		CMP	#'C		send control C
0D95 D0 08		BNE	7.f
0D97 A9 03		LDA	#$03		control C
0D99 20 7511		JSR	send_add
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 8

0D9C 4C F10D		JMP	5.f
0D9F C9 45	7	CMP	#'E		exit to DOS?
0DA1 D0 3E		BNE	8.f
		;
		;Close output file
		;Restore old vectors and status line
		;Then return to DOS65
0DA3 AD 5C02		LDA	fileflg
0DA6 F0 03		BEQ	1.f
0DA8 20 910F		JSR	fclose
0DAB 20 4913	1	JSR	menu_off
0DAE 78			SEI
0DAF AD 0902		LDA	oldkey		reset keybd IRQ vector
0DB2 AE 0A02		LDX	oldkey+1
0DB5 8D 5AE7		STA	keyvec
0DB8 8E 5BE7		STX	keyvec+1
0DBB AD 0B02		LDA	oldacia		reset ACIA IRQ vector
0DBE AE 0C02		LDX	oldacia+1
0DC1 8D 6CE7		STA	aciavec
0DC4 8E 6DE7		STX	aciavec+1
0DC7 20 21F0		JSR	norstat		normal status line
0DCA 20 2FC0		JSR	crlf
0DCD 20 2FC0		JSR	crlf
0DD0 AD 35E7		LDA	aciadat+1	restore interrupt, DTR
0DD3 8D 31E1		STA	ACIASR
0DD6 8D 32E1		STA	ACICMD
0DD9 AD 34E7		LDA	aciadat		restore settings
0DDC 8D 33E1		STA	ACICTL
0DDF 28		exit	PLP			restore dec, int flags
0DE0 60			RTS			return to DOS
		;
0DE1 C9 55	8	CMP	#'U		Output menu?
0DE3 F0 15		BEQ	u1
0DE5 C9 49		CMP	#'I		Input menu?
0DE7 F0 0E		BEQ	1.f
0DE9 C9 50		CMP	#'P		Printer menu?
0DEB F0 4F		BEQ	p1
0DED C9 4F		CMP	#'O		Online?
0DEF D0 98		BNE	6.b
0DF1 20 4913	5	JSR	menu_off
0DF4 4C 410D		JMP	loop
0DF7 4C 8D0E	1	JMP	i1
		;End of main loop
		;
		;Output menu
		;Outputs to host are keyboard, ascii and binary disc files
0DFA 20 4E10	u1	JSR	setret
0DFD 4C 030E		JMP	1.f
0E00 20 F210		JSR	waitforq	wait for queues to empty
0E03 A9 14	1	LDA	#m_offline>>8
0E05 A0 AD		LDY	#m_offline&255
0E07 20 1EF0		JSR	maksln
0E0A A9 0F		LDA	#$0F
0E0C 20 7310		JSR	messxa
0E0F 20 5811	2	JSR	waitkey
0E12 A2 00		LDX	#$00
0E14 8E 4D02		STX	brk_rec		clear any breaks
0E17 29 DF		AND	#$DF
0E19 C9 51		CMP	#'Q		Quit?
0E1B F0 15		BEQ	off1
0E1D C9 42		CMP	#'B		Binary transfer?
0E1F D0 03		BNE	1.f		branch if no
0E21 4C 130F		JMP	bin_tr
0E24 C9 57	1	CMP	#'W		binary with addresses?
0E26 D0 03		BNE	1.f
0E28 4C 170F		JMP	bin_trw
0E2B C9 41	1	CMP	#'A		Ascii transfer?
0E2D D0 E0		BNE	2.b
0E2F 4C EC0E		JMP	asc_trans
0E32 4C 740D	off1	JMP	offline		back to main menu
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 9

		;
		;printer menu
0E35 A9 14	p2	LDA	#m_offline>>8	re-draw status line
0E37 A0 AD		LDY	#m_offline&255
0E39 20 1EF0		JSR	maksln
0E3C A9 19	p1	LDA	#$19
0E3E 20 7310		JSR	messxa
0E41 AD 5E02		LDA	pr_on
0E44 30 04		BMI	1.f
0E46 A2 11		LDX	#$11
0E48 D0 02		BNE	2.f
0E4A A2 12	1	LDX	#$12
0E4C 20 7910	2	JSR	messx
0E4F AD 5F02		LDA	pr_num
0E52 0D 6002		ORA	pr_num+1
0E55 F0 05		BEQ	3.f
0E57 A2 13		LDX	#$13		Printer abort message
0E59 20 7910		JSR	messx
0E5C 20 5811	3	JSR	waitkey
0E5F 29 DF		AND	#$DF
0E61 C9 51		CMP	#'Q		quit
0E63 D0 02		BNE	1.f
0E65 F0 0C		BEQ	5.f		branch always
0E67 C9 41	1	CMP	#'A		abort printing
0E69 D0 0B		BNE	1.f
0E6B 20 3C11		JSR	pr_init
0E6E A9 00		LDA	#$00		printer off
0E70 8D 5E02	4	STA	pr_on
0E73 4C 320E	5	JMP	off1
0E76 C9 50	1	CMP	#'P		printing on/off
0E78 D0 E2		BNE	3.b
0E7A AD 5E02		LDA	pr_on
0E7D 30 07		BMI	1.f
0E7F 20 1513		JSR	pmark
0E82 A9 80		LDA	#$80
0E84 D0 EA		BNE	4.b
0E86 20 1913	1	JSR	no_pmark
0E89 A9 01		LDA	#$01
0E8B D0 E3		BNE	4.b		branch always 
		;
		;
		;Input to file menu
0E8D 20 4E10	i1	JSR	setret
0E90 4C 930E		JMP	95.f		this statement is necessary!
		;return address on error
0E93 A9 14	95	LDA	#m_offline>>8
0E95 A0 AD		LDY	#m_offline&255
0E97 20 1EF0		JSR	maksln
0E9A A9 10		LDA	#$10
0E9C 20 7310		JSR	messxa
0E9F A2 14		LDX	#$14		open File message 
0EA1 AD 5C02		LDA	fileflg		file open? 
0EA4 F0 02		BEQ	99.f
0EA6 A2 15		LDX	#$15		close file message
0EA8 20 7910	99	JSR	messx
0EAB 20 5811	96	JSR	waitkey
0EAE A2 00		LDX	#$00
0EB0 8E 4D02		STX	brk_rec
0EB3 29 DF		AND	#$DF
0EB5 C9 46		CMP	#'F		file command
0EB7 D0 29		BNE	98.f
0EB9 AD 5C02		LDA	fileflg		to open or close
0EBC F0 06		BEQ	97.f
0EBE 20 910F		JSR	fclose
0EC1 4C 320E		JMP	off1
0EC4 20 E60F	97	JSR	getfname
0EC7 A2 E1		LDX	#$E1
0EC9 20 36D0		JSR	create
0ECC 8E 5D02		STX	filecode
0ECF 90 06		BCC	1.f
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 10

0ED1 20 8310	88	JSR	ermenu
0ED4 4C 930E	89	JMP	95.b
0ED7 20 0B13	1	JSR	fmark
0EDA A9 FF		LDA	#$FF
0EDC 8D 5C02		STA	fileflg
0EDF 4C 320E		JMP	off1
0EE2 C9 51	98	CMP	#'Q
0EE4 D0 03		BNE	93.f
0EE6 4C 320E		JMP	off1
0EE9 4C AB0E	93	JMP	96.b
		;
0EEC A9 81	asc_trans LDA	#$81		code for ascii
0EEE 20 C60F		JSR	tranmess	open file and set status line;
0EF1 20 0A0F	1	JSR	infile		get char
0EF4 20 B40F		JSR	q3		add to queue, check break
0EF7 4C F10E		JMP	1.b
		;
0EFA C9 04	tr_err	CMP	#$04
0EFC F0 03		BEQ	tr_end
0EFE 20 8310		JSR	ermenu
0F01 AE 0402	tr_end	LDX	dev_tmp
0F04 20 48D0		JSR	close		close read file
0F07 4C 6610		JMP	ret
		;
0F0A AE 0402	infile	LDX	dev_tmp		fd>4
0F0D 20 00D0		JSR	sread		get one char
0F10 B0 E8		BCS	tr_err
0F12 60			RTS
		;
		;transmit  binary file
0F13 A0 00	bin_tr	LDY	#$00
0F15 F0 02		BEQ	1.f
0F17 A0 FF	bin_trw	LDY	#$FF		addresses
0F19 8C 0502	1	STY	file_tp		indicate if addresses sent
		;
0F1C A9 82		LDA	#$82		code for binary file
0F1E 20 C60F		JSR	tranmess	open file, set status line
0F21 20 0A0F	bin1	JSR	infile
0F24 C9 02		CMP	#$02		run address to follow?
0F26 D0 09		BNE	74.f
0F28 20 0A0F		JSR	infile		discard 2 bytes
0F2B 20 0A0F		JSR	infile
0F2E 20 0A0F		JSR	infile		get next byte
0F31 C9 01	74	CMP	#$01		load address to follow?
0F33 D0 54		BNE	79.f		unknown format err
0F35 20 0A0F		JSR	infile		get load address low
0F38 8D 0302		STA	b_tmp
0F3B 20 0A0F		JSR	infile		get load address high
0F3E AE 0502		LDX	file_tp		is this to be sent?
0F41 F0 1A		BEQ	77.f		branch if no
0F43 20 A011		JSR	asc_conv
0F46 20 B40F		JSR	q3		send upper nibble
0F49 20 AA0F		JSR	q4		send lower nibble
0F4C AD 0302		LDA	b_tmp
0F4F 20 A011		JSR	asc_conv	send low byte
0F52 20 B40F		JSR	q3		send upper nibble
0F55 20 AA0F		JSR	q4		send lower nibble
0F58 A9 20		LDA	#$20		space
0F5A 20 B40F		JSR	q3		send space
0F5D 20 0A0F	77	JSR	infile		get length
0F60 8D 0702		STA	b_len
0F63 20 0A0F		JSR	infile
0F66 AA			TAX			assume length>0
0F67 E8			INX			if not there will be error
0F68 8E 0802		STX	b_len+1
0F6B 20 0A0F	76	JSR	infile
0F6E 20 A011		JSR	asc_conv
0F71 20 B40F		JSR	q3		send upper nibble
0F74 20 AA0F		JSR	q4		send lower nibble
0F77 A9 2E		LDA	#'.
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 11

0F79 20 B40F		JSR	q3		send '.
0F7C CE 0702		DEC	b_len
0F7F D0 EA		BNE	76.b
0F81 CE 0802		DEC	b_len+1
0F84 F0 9B		BEQ	bin1
0F86 4C 6B0F		JMP	76.b
		;
0F89 A2 0B	79	LDX	#$0B
0F8B 20 8F10		JSR	ermessx		unknown binary format message
0F8E 4C 010F		JMP	tr_end
		;
		;close a write file
0F91 20 0F13	fclose	JSR	no_fmark
0F94 A2 00		LDX	#$00
0F96 8E 5C02		STX	fileflg
0F99 A9 18		LDA	#$18
0F9B 20 7310		JSR	messxa
0F9E AE 5D02		LDX	filecode
0FA1 20 48D0		JSR	close
0FA4 90 03		BCC	1.f
0FA6 20 8310		JSR	ermenu		close failed
0FA9 60		1	RTS
		;
0FAA AD 0602	q4	LDA	nib_tmp
0FAD D0 05		BNE	q3		branch always
0FAF 48		1	PHA
0FB0 20 0D11		JSR	q2
0FB3 68			PLA
0FB4 AE 4D02	q3	LDX	brk_rec		break?
0FB7 F0 03		BEQ	2.f
0FB9 4C 010F		JMP	tr_end
0FBC A2 0B	2	LDX	#$0B
0FBE EC 3402		CPX	send_num	room?
0FC1 90 EC		BCC	1.b		branch if no
0FC3 4C 0A11		JMP	q1
		;
		;routine to get file name, set status line, open.
		;file type in A
0FC6 20 E60F	tranmess JSR	getfname
0FC9 20 3FD0		JSR	open
0FCC 90 06		BCC	1.f
0FCE 20 8310		JSR	ermenu		open failed
0FD1 4C 6610		JMP	ret
		;
0FD4 8E 0402	1	STX	dev_tmp		some sort of file number
0FD7 A0 FC		LDY	#m_trans&255
0FD9 A9 14		LDA	#m_trans>>8
0FDB 20 1EF0		JSR	maksln
0FDE A9 FF		LDA	#$FF
0FE0 8D 5B02		STA	stlnn
0FE3 4C 4913		JMP	menu_off
		;
		;get filename
0FE6 48		getfname PHA			save file type
0FE7 A9 00		LDA	#$00
0FE9 8D 2102		STA	fname_len	set length to 0
0FEC A9 16		LDA	#$16
0FEE 20 7310		JSR	messxa
0FF1 AD 4D02	gf0	LDA	brk_rec		break?
0FF4 D0 14		BNE	gf4
0FF6 20 5E11		JSR	getkey
0FF9 F0 F6		BEQ	gf0
		;
0FFB C9 0D		CMP	#$0D		CR?
0FFD D0 1E		BNE	gf2
0FFF AE 2102		LDX	fname_len
1002 9D 0D02		STA	fname_buf,X	CR is an acceptable delimiter
1005 AD 2102		LDA	fname_len	Z empty?
1008 D0 03		BNE	gf1
100A 4C 6610	gf4	JMP	ret		back to menu
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 12

100D A0 0D	gf1	LDY	#fname_buf&255	points to file name
100F A9 02		LDA	#fname_buf>>8
1011 20 9FD0		JSR	setfiln
1014 68			PLA
1015 B0 2F		BCS	fname_err
1017 AA			TAX			file type
1018 A0 0D		LDY	#fname_buf&255
101A A9 02		LDA	#fname_buf>>8
101C 60			RTS
		;
		;char in buffer
101D C9 7F	gf2	CMP	#$7F		delete?
101F D0 0E		BNE	gf3
1021 AE 2102		LDX	fname_len
1024 F0 CB		BEQ	gf0
1026 CE 2102		DEC	fname_len
1029 20 9513		JSR	ch_menu		perform delete
102C 4C F10F		JMP	gf0
102F AE 2102	gf3	LDX	fname_len
1032 E0 14		CPX	#20		buffer full?
1034 10 BB		BPL	gf0		branch if yes
1036 C9 20		CMP	#$20		control character?
1038 90 B7		BCC	gf0		branch if yes
103A 9D 0D02		STA	fname_buf,X	put in buffer
103D 20 9513		JSR	ch_menu
1040 EE 2102		INC	fname_len
1043 4C F10F		JMP	gf0
		;
1046 A2 0D	fname_err LDX	#$0D
1048 20 8F10		JSR	ermessx
104B 4C 6610		JMP	ret
		;
		;routine to set return address to following byte+3
104E 68		setret	PLA			low byte
104F A8			TAY
1050 68			PLA			high byte
1051 BA			TSX
1052 8E 0202		STX	retstk
1055 AA			TAX
1056 48			PHA
1057 98			TYA
1058 48			PHA
1059 18			CLC
105A 69 03		ADC	#$03		address of next instruction
105C 8D 0002		STA	retadd
105F 8A			TXA
1060 69 00		ADC	#$00
1062 8D 0102		STA	retadd+1
1065 60			RTS
		;
		;routine to return, correcting stack
1066 AE 0202	ret	LDX	retstk
1069 9A			TXS
106A AD 0102		LDA	retadd+1	avoid 6502 bug by not using 6C
106D 48			PHA
106E AD 0002		LDA	retadd
1071 48			PHA
1072 60			RTS
		;
		;
1073 48		messxa	PHA			clear and print message A
1074 20 5F13		JSR	menu_on		on and clear
1077 68			PLA
1078 AA			TAX
1079 BD B410	messx	LDA	h_er,X		print menu message X
107C BC CE10		LDY	l_er,X
107F 20 A413		JSR	pr_menu
1082 60			RTS
		;
1083 A2 09	ermenu	LDX	#$09		DOS errors
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 13

1085 DD E810	2	CMP	er_tab,X
1088 F0 05		BEQ	ermessx
108A CA			DEX
108B 10 F8		BPL	2.b
108D A2 0A		LDX	#$0A		message is 'error'
		;
108F AD 5A02	ermessx	LDA	mset
1092 48			PHA			remember if menu on or off
1093 8A			TXA
1094 20 7310		JSR	messxa
1097 A2 0E		LDX	#$0E
1099 20 7910		JSR	messx
109C A9 14		LDA	#m_offline>>8
109E A0 AD		LDY	#m_offline&255
10A0 20 1EF0		JSR	maksln
		;
10A3 20 5E11	1	JSR	getkey		remove any existing char
10A6 20 5811		JSR	waitkey
10A9 C9 0D		CMP	#$0D
10AB D0 F6		BNE	1.b
10AD 68			PLA
10AE F0 01		BEQ	1.f
10B0 60			RTS
10B1 4C 4913	1	JMP	menu_off
		;
10B4 15		h_er	fcc	#m_e2>>8
10B5 15			fcc	#m_e13>>8
10B6 15			fcc	#m_e21>>8
10B7 15			fcc	#m_e26>>8
10B8 15			fcc	#m_e27>>8
10B9 15			fcc	#m_e29>>8
10BA 15			fcc	#m_e80>>8
10BB 15			fcc	#m_e90>>8
10BC 15			fcc	#m_eC0>>8
10BD 15			fcc	#m_eD0>>8
10BE 15			fcc	#m_x00>>8
10BF 15			fcc	#m_x01>>8
10C0 16			fcc	#m_x02>>8
10C1 16			fcc	#m_x03>>8
10C2 16			fcc	#m_x04>>8
10C3 16			fcc	#m_output>>8
10C4 16			fcc	#m_input>>8
10C5 16			fcc	#m_input1>>8
10C6 16			fcc	#m_input2>>8
10C7 16			fcc	#m_input3>>8
10C8 16			fcc	#m_input4>>8
10C9 16			fcc	#m_input5>>8
10CA 16			fcc	#m_fname>>8
10CB 16			fcc	#m_menu>>8
10CC 17			fcc	#m_close>>8
10CD 17			fcc	#m_input6>>8
		;
10CE 4C		l_er	fcc	#m_e2&255
10CF 57			fcc	#m_e13&255
10D0 67			fcc	#m_e21&255
10D1 7A			fcc	#m_e26&255
10D2 90			fcc	#m_e27&255
10D3 A5			fcc	#m_e29&255
10D4 B7			fcc	#m_e80&255
10D5 C3			fcc	#m_e90&255
10D6 D0			fcc	#m_eC0&255
10D7 E1			fcc	#m_eD0&255
10D8 F1			fcc	#m_x00&255	X=A
10D9 F8			fcc	#m_x01&255	X=B
10DA 0F			fcc	#m_x02&255	X=C
10DB 28			fcc	#m_x03&255	X=D
10DC 3A			fcc	#m_x04&255	X=E
10DD 4C			fcc	#m_output&255	X=0F
10DE 83			fcc	#m_input&255	X=10
10DF 90			fcc	#m_input1&255	X=11
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 14

10E0 93			fcc	#m_input2&255	X=12
10E1 97			fcc	#m_input3&255	X=13
10E2 A8			fcc	#m_input4&255	X=14
10E3 B2			fcc	#m_input5&255	X=15
10E4 BD			fcc	#m_fname&255	X=16
10E5 D0			fcc	#m_menu&255	X=17
10E6 1F			fcc	#m_close&255	X=18
10E7 2D			fcc	#m_input6&255	X=19
		;
		;look up table to get X for DOS65 error codes
10E8 02		er_tab	fcc	$02
10E9 13			fcc	$13
10EA 21			fcc	$21
10EB 26			fcc	$26
10EC 27			fcc	$27
10ED 29			fcc	$29
10EE 80			fcc	$80
10EF 90			fcc	$90
10F0 C0			fcc	$C0
10F1 D0			fcc	$D0
		;
		;
		;wait until queues empty or a break
10F2 A2 00	waitforq LDX	#$00		clear any breaks
10F4 8E 4D02		STX	brk_rec
10F7 AE 4D02	2	LDX	brk_rec
10FA D0 0D		BNE	1.f
10FC 20 0D11		JSR	q2		empty the queues
10FF AE 3402		LDX	send_num
1102 D0 F3		BNE	2.b
1104 AE 4802		LDX	op_num
1107 D0 EE		BNE	2.b
1109 60		1	RTS
		;
		;routine to control queues, their input and output.
		;q1 is entry point for adding a character to send queue
110A 20 7511	q1	JSR	send_add
110D 20 BB11	q2	JSR	all_out
		;
		;
		;routine to set ACIA interrupt mask if queues too full
		;otherwise clear it
1110 08		int_set	PHP
1111 78			SEI
1112 A0 0B		LDY	#$0B
1114 AD 32E1		LDA	ACICMD
1117 CC 4802		CPY	op_num
111A 90 11		BCC	4.f
111C AC 5E02		LDY	pr_on
111F 10 15		BPL	2.f		if no entries to printer queue
1121 AC 5102		LDY	dflag
1124 D0 10		BNE	2.f		do not block queue 
		;                  if no handshaking
1126 A0 86		LDY	#(p_end-p_beg-2) is printer buffer
1128 CC 6002		CPY	pr_num+1	within one page of overflow?
112B B0 09		BCS	2.f
112D 29 F3	4	AND	#%11110011	tra and rec interrupts off
112F 09 02		ORA	#%00000010
1131 8D 32E1	3	STA	ACICMD
1134 28			PLP
1135 60			RTS
1136 29 F5	2	AND	#%11110101	tra and rec interrupts on
1138 09 04		ORA	#%00000100
113A D0 F5		BNE	3.b		branch always
		;
		;
113C A9 00	pr_init	LDA	#$00		initialise printer variables
113E 8D 5F02		STA	pr_num
1141 8D 6002		STA	pr_num+1
1144 85 82		STA	prq_in
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 15

1146 85 84		STA	prq_out
1148 A9 18		LDA	#p_beg		beg = printer buffer start
114A 85 83		STA	prq_in+1
114C 85 85		STA	prq_out+1
114E 4C 1913		JMP	no_pmark
		;
1151 A9 0C	formfeed LDA	#$0C
1153 A2 01	prvdu	LDX	#$01
1155 4C 06F0		JMP	outxdv
		;
		;routine to get keyboard input, if any
		;X,Y unchanged
1158 20 5E11	waitkey	JSR	getkey
115B F0 FB		BEQ	waitkey		key pressed?
115D 60			RTS
		;
115E AD 4B02	getkey	LDA	key_rec		character received?
1161 F0 0C		BEQ	21.f		branch if no
1163 08			PHP
1164 78			SEI
1165 A9 00		LDA	#$00
1167 8D 4B02		STA	key_rec
116A AD 4C02		LDA	key_char
116D 28			PLP
116E 60			RTS
116F 08		21	PHP
1170 20 21F9		JSR	toffsc
1173 28			PLP
1174 60			RTS
		;
1175 C9 0D	send_add CMP	#$0D		CR?
1177 D0 0A		BNE	send1		branch if no
1179 AE 5302		LDX	lflag		LF with CR?
117C F0 05		BEQ	send1		branch if no
117E 20 8311		JSR	send1		send CR
1181 A9 0A		LDA	#$0A		send LF
		;
1183 A0 0E	send1	LDY	#$0E
1185 CC 3402		CPY	send_num	ignore if queue too full
1188 90 15		BCC	1.f
118A 08			PHP
118B 78			SEI
118C EE 3402		INC	send_num
118F AE 3502		LDX	send_in
1192 9D 2402		STA	send_buf,X
1195 48			PHA
1196 E8			INX
1197 8A			TXA
1198 29 0F		AND	#$0F
119A 8D 3502		STA	send_in
119D 68			PLA
119E 28			PLP
119F 60		1	RTS
		;
		;
		;convert to ascii
11A0 48		asc_conv PHA			save it
11A1 29 0F		AND	#$0F
11A3 20 B111		JSR	nib
11A6 8D 0602		STA	nib_tmp		save lower nibble
11A9 68			PLA
11AA 4A			LSRA			get upper nibble
11AB 4A			LSRA
11AC 4A			LSRA
11AD 4A			LSRA
11AE 4C B111		JMP	nib
		;
		;
		;routine to turn nibble to ascii
11B1 C9 0A	nib	CMP	#$0A
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 16

11B3 18			CLC
11B4 30 02		BMI	61.f
11B6 69 07		ADC	#$07
11B8 69 30	61	ADC	#$30
11BA 60			RTS
		;
		;General output of Centronics and VDU queues
11BB 20 4112	all_out	JSR	ctr_out
		;print char, from op_buf recognising backspace
		;also send to the file (if open)
11BE AD 4802		LDA	op_num
11C1 F0 66		BEQ	9.f		return if no chars in buffer
11C3 08			PHP
11C4 78			SEI
11C5 AC 4A02		LDY	op_out
11C8 BE 3802		LDX	op_buf,Y
11CB C8			INY
11CC 98			TYA
11CD 29 0F		AND	#$0F
11CF 8D 4A02		STA	op_out
11D2 CE 4802		DEC	op_num
11D5 8A			TXA
11D6 28			PLP
11D7 AC 5C02		LDY	fileflg		is file open?
11DA 48			PHA
11DB F0 18		BEQ	prt
11DD AE 5D02		LDX	filecode
11E0 20 4DC0		JSR	outputx
11E3 90 10		BCC	prt
11E5 48			PHA
11E6 20 48D0		JSR	close
11E9 A2 00		LDX	#$00
11EB 8E 5C02		STX	fileflg
11EE 20 0F13		JSR	no_fmark
11F1 68			PLA
11F2 20 8310		JSR	ermenu
		;
11F5 20 2FF9	prt	JSR	tonsc
11F8 68			PLA
11F9 C9 7F		CMP	#$7F		backspace?
11FB D0 03		BNE	8.f		branch if no
11FD 4C 36CA		JMP	pdel		DOS65 delete routine
1200 C9 0C	8	CMP	#$0C
1202 D0 16		BNE	10.f
1204 20 5111		JSR	formfeed
1207 AD 5B02		LDA	stlnn		which status line?
120A D0 07		BNE	11.f
120C A9 14		LDA	#m_online>>8
120E A0 5D		LDY	#m_online&255
1210 4C 1EF0		JMP	maksln		replace it
1213 A9 14	11	LDA	#m_trans>>8
1215 A0 FC		LDY	#m_trans&255
1217 4C 1EF0		JMP	maksln
121A C9 20	10	CMP	#$20		control char?
121C B0 08		BCS	12.f		branch if no
121E C9 0E		CMP	#$0E
1220 B0 08		BCS	13.f
1222 C9 07		CMP	#$07		include beeps
1224 90 04		BCC	13.f
		;
1226 4C 5311	12	JMP	prvdu
1229 60		9	RTS
		;
122A AE 5002	13	LDX	cflag
122D F0 FA		BEQ	9.b
122F 48			PHA
1230 A9 5B		LDA	#'[
1232 20 5311		JSR	prvdu
1235 68			PLA
1236 18			CLC
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 17

1237 69 40		ADC	#$40
1239 20 5311		JSR	prvdu
123C A9 5D		LDA	#']
123E 4C 5311		JMP	prvdu
		;
		;
		;Centronics printer out
		;modified I/O 65 routine
		;not interrupt driven at present
1241 08		ctr_out	PHP
1242 78			SEI
1243 AD 5F02		LDA	pr_num
1246 0D 6002		ORA	pr_num+1
1249 F0 4A		BEQ	1.f		branch if buffer empty
124B AD 10E1		LDA	VBPBD		check select and PE
124E 49 10		EOR	#$10
1250 29 18		AND	#$18
1252 F0 41		BEQ	1.f
1254 AD 0DE1		LDA	VAIFR		wait for acknowledge
1257 29 10		AND	#$10
1259 F0 3A		BEQ	1.f
125B A0 00		LDY	#$00
125D B1 84		LDA	[prq_out],Y
125F C9 0A		CMP	#$0A		LF?
1261 D0 05		BNE	5.f
1263 AE 5602		LDX	no_plf		allowed?
1266 D0 07		BNE	6.f		branch if no
1268 8D 00E1	5	STA	VAPBD		send character to printer
126B C9 0D		CMP	#$0D		CR?
126D F0 04		BEQ	3.f
126F A9 00	6	LDA	#$00		allow printing of following LF
1271 F0 03		BEQ	4.f
1273 AD 5502	3	LDA	pflag		cancel next char if LF
1276 8D 5602	4	STA	no_plf		cancel it if A=$FF
1279 E6 84		INC	prq_out
127B D0 0B		BNE	2.f
127D A4 85		LDY	prq_out+1
127F C8			INY
1280 C0 A0		CPY	#p_end
1282 D0 02		BNE	3.f
1284 A0 18		LDY	#p_beg
1286 84 85	3	STY	prq_out+1
1288 AC 5F02	2	LDY	pr_num
128B 08			PHP
128C CE 5F02		DEC	pr_num
128F 28			PLP
1290 D0 03		BNE	1.f
1292 CE 6002		DEC	pr_num+1
1295 28		1	PLP
1296 60			RTS
		;
		;A routine to add a char to VDU/file and printer queues
1297 08		op_add	PHP
1298 78			SEI
1299 A0 0E		LDY	#$0E
129B CC 4802		CPY	op_num		buffer full?
129E 90 5B		BCC	2.f		branch if yes
12A0 EE 4802		INC	op_num
12A3 AC 4902		LDY	op_in
12A6 99 3802		STA	op_buf,Y
12A9 AA			TAX			save char
12AA C8			INY
12AB 98			TYA
12AC 29 0F		AND	#$0F
12AE 8D 4902		STA	op_in
12B1 AD 5E02		LDA	pr_on		is printer queue accepting?
12B4 10 45		BPL	2.f		branch if no
12B6 8A			TXA
12B7 C9 07		CMP	#$07
12B9 90 40		BCC	2.f		filter out codes $00..$06
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 18

12BB C9 20		CMP	#$20
12BD B0 04		BCS	prt2		permit codes $20..$FF
12BF C9 0E		CMP	#$0E
12C1 B0 38		BCS	2.f		filter out codes $0E..$1F
		;
12C3 A2 00	prt2	LDX	#$00
12C5 81 82		STA	[prq_in,X]
12C7 E6 82		INC	prq_in
12C9 D0 0B		BNE	4.f
12CB A4 83		LDY	prq_in+1
12CD C8			INY
12CE C0 A0		CPY	#p_end
12D0 D0 02		BNE	3.f
12D2 A0 18		LDY	#p_beg		start of printer buffer area
12D4 84 83	3	STY	prq_in+1
12D6 EE 5F02	4	INC	pr_num
12D9 D0 20		BNE	2.f
12DB AC 6002		LDY	pr_num+1
12DE C8			INY
12DF 8C 6002		STY	pr_num+1
12E2 C0 88		CPY	#(p_end-p_beg)
12E4 D0 15		BNE	2.f
12E6 A9 01		LDA	#$01
12E8 8D 5E02		STA	pr_on		accept no more
12EB 58			CLI
12EC 20 1913		JSR	no_pmark	remove 'P' from status line
12EF A2 0C		LDX	#$0C		'printer buffer overflow'
12F1 20 8F10		JSR	ermessx
12F4 A9 14		LDA	#m_online>>8
12F6 A0 5D		LDY	#m_online&255
12F8 20 1EF0		JSR	maksln
12FB 28		2	PLP
12FC 60			RTS
		;
		;routine to read crtc register X
12FD 8E 40E1	rdcrtc	STX	CRTCAR
1300 AD 41E1		LDA	CRTCRF
1303 60			RTS
		;
		;routine to write crtc register X
1304 8E 40E1	wrcrtc	STX	CRTCAR
1307 8D 41E1		STA	CRTCRF
130A 60			RTS
		;
130B A9 46	fmark	LDA	#'F
130D D0 02		BNE	1.f
130F A9 20	no_fmark LDA	#$20
1311 A0 22	1	LDY	#34
1313 D0 08		BNE	mark
1315 A9 50	pmark	LDA	#'P
1317 D0 02		BNE	1.f
1319 A9 20	no_pmark LDA	#$20
131B A0 21	1	LDY	#33
131D 99 AD14	mark	STA	m_offline,Y
1320 99 5D14		STA	m_online,Y
1323 99 FC14		STA	m_trans,Y
1326 60			RTS
		;
		;screen read and write
1327 A9 00	rdmenu	LDA	#$00
1329 48		wrmenu	PHA			byte $00 cannot be written
132A A2 00		LDX	#$00
132C 98			TYA
132D 18			CLC
132E 6D ADE7		ADC	start
1331 85 80		STA	rw_ad
1333 A9 00		LDA	#$00
1335 6D AEE7		ADC	start+1
1338 C9 F0		CMP	#$F0		screen end+1
133A 90 02		BCC	1.f
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 19

133C A9 E8		LDA	#$E8		screen start
133E 85 81	1	STA	rw_ad+1
		;
1340 68			PLA
1341 D0 03		BNE	wr
1343 A1 80		LDA	[rw_ad,X]	screen read
1345 60			RTS
		;
1346 81 80	wr	STA	[rw_ad,X]	screen write
1348 60			RTS
		;
1349 AD 5A02	menu_off LDA	mset
134C F0 10		BEQ	2.f
134E A0 4F		LDY	#79		screen width
1350 B9 6102	1	LDA	svline,Y
1353 20 2913		JSR	wrmenu
1356 88			DEY
1357 10 F7		BPL	1.b
1359 A9 00		LDA	#$00
135B 8D 5A02		STA	mset
135E 60		2	RTS
		;
		;routine to save top line
		;and clear menu
135F AD 5A02	menu_on	LDA	mset
1362 D0 10		BNE	cl_menu
1364 A0 4F		LDY	#79		screen width
1366 20 2713	1	JSR	rdmenu
1369 99 6102		STA	svline,Y
136C 88			DEY
136D 10 F7		BPL	1.b
136F A9 FF		LDA	#$FF
1371 8D 5A02		STA	mset
		;
1374 A9 00	cl_menu	LDA	#$00
1376 8D 5902		STA	mpos		position
1379 A0 4F		LDY	#79
137B A9 A0		LDA	#$A0
137D 20 2913	1	JSR	wrmenu
1380 88			DEY
1381 10 FA		BPL	1.b
1383 60			RTS
		;
1384 AC 5902	d_menu	LDY	mpos
1387 F0 0B		BEQ	1.f
1389 CE 5902		DEC	mpos
138C A9 20		LDA	#$20
138E 20 9513		JSR	ch_menu
1391 CE 5902		DEC	mpos
1394 60		1	RTS
		;
		;print a character on menu
1395 C9 7F	ch_menu	CMP	#$7F
1397 F0 EB		BEQ	d_menu
1399 09 80		ORA	#$80
139B AC 5902		LDY	mpos
139E EE 5902		INC	mpos
13A1 4C 2913		JMP	wrmenu
		;
		;print a string on menu
13A4 8D AC13	pr_menu	STA	pr+2
13A7 8C AB13		STY	pr+1
13AA AD FFFF	pr	LDA	$FFFF
13AD F0 0E		BEQ	1.f
13AF 20 9513		JSR	ch_menu
13B2 EE AB13		INC	pr+1
13B5 D0 F3		BNE	pr
13B7 EE AC13		INC	pr+2
13BA 4C AA13		JMP	pr
13BD 60		1	RTS
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 20

		;
13BE AE 4E02	setwait	LDX	delay		a wait needed if <> 0
13C1 8E 4F02		STX	waitflg
13C4 60		50	RTS
		;
		;Interrupt routines
		;
13C5 78		int_acia SEI
13C6 AD 31E1		LDA	ACIASR		ACIA interrupt routine
13C9 AA			TAX
13CA 29 08		AND	#$08		Receiver interrupt?
13CC F0 21		BEQ	11.f		Branch if no
13CE 8A			TXA
13CF 29 03		AND	#$03		framing or parity error?
13D1 08			PHP
13D2 AD 30E1		LDA	RECREG		get char, clear interrupt
13D5 28			PLP
13D6 D0 28		BNE	12.f
13D8 C9 0D		CMP	#$0D		CR?
13DA D0 0A		BNE	13.f
13DC AC 5402		LDY	mflag		add an LF
13DF F0 05		BEQ	13.f		branch if no
13E1 20 9712		JSR	op_add
13E4 A9 0A		LDA	#$0A
13E6 20 9712	13	JSR	op_add		put in vdu queue
13E9 20 BE13	10	JSR	setwait		set timer if needed
13EC 4C 1011		JMP	int_set
13EF 8A		11	TXA
13F0 29 10		AND	#$10		Transmitter interrupt?
13F2 D0 0D		BNE	3.f		Branch if yes
13F4 8A			TXA
13F5 29 20		AND	#%00100000
13F7 AA			TAX
13F8 4D 2302		EOR	dcdflg		DCD change?
13FB F0 03		BEQ	12.f		branch if no
13FD 8E 2302		STX	dcdflg
1400 60		12	RTS
		;
		;Note transmitter produces continuous interrupts even if
		;no characters are being transmitted
1401 AD 2202	3	LDA	tra_end		was a character sent?
1404 F0 16		BEQ	1.f		branch if no
1406 A9 00		LDA	#$00
1408 8D 2202		STA	tra_end
140B 20 BE13		JSR	setwait
140E AE 5202		LDX	kflag		local copy?
1411 F0 09		BEQ	1.f
1413 AD 3702		LDA	op_tmp
1416 20 9712		JSR	op_add		put in output queue
1419 20 1011		JSR	int_set
141C AD 4F02	1	LDA	waitflg
141F F0 04		BEQ	rs_out
1421 CE 4F02		DEC	waitflg
1424 60			RTS
		;
		;routine to transmit RS232
1425 AE 3402	rs_out	LDX	send_num
1428 F0 1B		BEQ	1.f		branch if no character to send
142A CE 3402		DEC	send_num
142D AC 3602		LDY	send_out
1430 BE 2402		LDX	send_buf,Y
1433 8E 30E1		STX	TRAREG		start transmission
1436 8E 3702		STX	op_tmp		save it
1439 C8			INY
143A 98			TYA
143B 29 0F		AND	#$0F
143D 8D 3602		STA	send_out
1440 A9 FF		LDA	#$FF
1442 8D 2202		STA	tra_end
1445 60		1	RTS
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 21


1446 20 2FF9	int_key	JSR	tonsc		screen on
1449 AD 01E1		LDA	VAPAD
144C A2 FF		LDX	#$FF
144E C9 03		CMP	#$03		break?
1450 F0 07		BEQ	1.f
1452 8D 4C02	2	STA	key_char
1455 8E 4B02		STX	key_rec
1458 60			RTS
1459 8E 4D02	1	STX	brk_rec
145C 60			RTS
		;
		;
		;Status line messages (bottom line)
145D 20444F5336	m_online fcc	' DOS65 Terminal V0.23 : ONLINE          '
1462 3520546572
1467 6D696E616C
146C 2056302E32
1471 33203A204F
1476 4E4C494E45
147B 2020202020
1480 2020202020
1485 2020202020		fcc	'                    control C to escape',0
148A 2020202020
148F 2020202020
1494 2020202020
1499 636F6E7472
149E 6F6C204320
14A3 746F206573
14A8 6361706500
14AD 20444F5336	m_offline fcc	' DOS65 Terminal V0.23 : OFFLINE        '
14B2 3520546572
14B7 6D696E616C
14BC 2056302E32
14C1 33203A204F
14C6 46464C494E
14CB 4520202020
14D0 20202020
14D4 2020202020		fcc	'                          select option',0
14D9 2020202020
14DE 2020202020
14E3 2020202020
14E8 2020202020
14ED 2073656C65
14F2 6374206F70
14F7 74696F6E00
14FC 20444F5336	m_trans	fcc	' DOS65 Terminal V0.23 : TRANSFER        '
1501 3520546572
1506 6D696E616C
150B 2056302E32
1510 33203A2054
1515 52414E5346
151A 4552202020
151F 2020202020
1524 2020202020		fcc	'                    control C to escape',0
1529 2020202020
152E 2020202020
1533 2020202020
1538 636F6E7472
153D 6F6C204320
1542 746F206573
1547 6361706500
		;
		;Menu line messages on top line
		; 
		;DOS error messages (displayed on menu line)
154C 2044697363	m_e2	fcc	' Disc full',0
1551 2066756C6C
1556 00
1557 2046696C65	m_e13	fcc	' File not found',0 X=0
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 22

155C 206E6F7420
1561 666F756E64
1566 00
1567 2046696C65	m_e21	fcc	' File already open',0
156C 20616C7265
1571 616479206F
1576 70656E00
157A 2046696C65	m_e26	fcc	' File write protected',0
157F 2077726974
1584 652070726F
1589 7465637465
158E 6400
1590 2046696C65	m_e27	fcc	' File read protected',0
1595 2072656164
159A 2070726F74
159F 6563746564
15A4 00
15A5 20496E636F	m_e29	fcc	' Incorrect format',0
15AA 7272656374
15AF 20666F726D
15B4 617400
15B7 2052656164	m_e80	fcc	' Read error',0
15BC 206572726F
15C1 7200
15C3 2057726974	m_e90	fcc	' Write error',0
15C8 6520657272
15CD 6F7200
15D0 2044726976	m_eC0	fcc	' Drive not ready',0
15D5 65206E6F74
15DA 2072656164
15DF 7900
15E1 2044697363	m_eD0	fcc	' Disc protected',0 9
15E6 2070726F74
15EB 6563746564
15F0 00
		;
		;Other messages
15F1 204572726F	m_x00	fcc	' Error',0	X=A
15F6 7200
15F8 20556E6B6E	m_x01	fcc	' Unknown binary format',0 X=B
15FD 6F776E2062
1602 696E617279
1607 20666F726D
160C 617400
160F 205072696E	m_x02	fcc	' Printer buffer overflow',0 X=C
1614 7465722062
1619 7566666572
161E 206F766572
1623 666C6F7700
1628 20496C6C65	m_x03	fcc	' Illegal filename',0 X=D
162D 67616C2066
1632 696C656E61
1637 6D6500
163A 20202D2020	m_x04	fcc	'  -  Press return',0 X=E
163F 5072657373
1644 2072657475
1649 726E00
		;
164C 20512D7175	m_output fcc	' Q-quit   A-ascii   B-binary   W-binary ' X=F
1651 6974202020
1656 412D617363
165B 6969202020
1660 422D62696E
1665 6172792020
166A 20572D6269
166F 6E61727920
1674 7769746820		fcc	'with addresses',0
1679 6164647265
167E 7373657300
1683 20512D7175	m_input	fcc	' Q-quit   F-',0 X=10
DOS65 TERMINAL SOFTWARE V0.23              5-Jul-87 14:32              page 23

1688 6974202020
168D 462D00
1690 6F6E00	m_input1 fcc	'on',0		X=11
1693 6F666600	m_input2 fcc	'off',0		X=12
1697 2C2020412D	m_input3 fcc	',  A-print abort',0 X=13
169C 7072696E74
16A1 2061626F72
16A6 7400
16A8 6F70656E20	m_input4 fcc	'open file',0	X=14
16AD 66696C6500
16B2 636C6F7365	m_input5 fcc	'close file',0	X=15
16B7 2066696C65
16BC 00
16BD 20456E7465	m_fname	fcc	' Enter filename:  ',0 X=16
16C2 722066696C
16C7 656E616D65
16CC 3A202000
16D0 20452D6578	m_menu	fcc	' E-exit  O-online  P-printer  '
16D5 697420204F
16DA 2D6F6E6C69
16DF 6E65202050
16E4 2D7072696E
16E9 7465722020
16EE 552D6F7574		fcc	'U-output file  '
16F3 7075742066
16F8 696C652020
16FD 492D696E70		fcc	'I-input to file  C-send control C',0
1702 757420746F
1707 2066696C65
170C 2020432D73
1711 656E642063
1716 6F6E74726F
171B 6C204300
171F 20636C6F73	m_close	fcc	' closing file',0 X=18
1724 696E672066
1729 696C6500
172D 20512D7175	m_input6 fcc	' Q-quit  P-turn printer ',0 X=19
1732 6974202050
1737 2D7475726E
173C 207072696E
1741 7465722000

Errors detected: 0
