
			ADVANCED DOS65
			--------------


INHOUD
------

1 DISK STRUCTUUR
  1.1 system sector
  1.2 directory sector
  1.3 track/sectorlist sector
  1.4 data sector

2 BINAIRE FILE


1. DISK STRUCTUUR
-----------------

Een DOS65 disk bezit naast data sectors ook sectors om bij te houden waar
de data staat, hoe de file heet, hoe de disk eruit ziet enz. Sectors van
DOS65 disks zijn onder te verdelen in:

- system	Een sector per disk. In deze sector staan de eigenschappen
  		van de disk. Tevens wordt hier bijgehouden welke sectors
		in gebruik zijn.

- directory	Een of meer sectors per disk, nul of meer sectors per
		directory. In deze sectors staan de namen van de files.

- track/sectorlist Een of meer sectors per file. In deze sectors staan de
		adressen van de data sectors.

- data		Nul of meer sectors per file.

De system sector staat altijd op track 0 sector 1. De home directory
(directory @) begint altijd op track 0 sector 3 (het sector adres
is logisch, dit geldt, mits anders vermeld, ook voor de komende sector
adressen). De andere typen sectoren kunnen over de gehele disk voorkomen.


1.1 System sector
-----------------
Als DOS65 nog geen file op de geadresseerde disk open heeft staan, dan zal
allereerst de system sector gelezen worden. Dit is noodzakelijk omdat
hierin de tabel staat met de logisch/fysische vertaling van sector
adressen en andere voor DOS65 noodzakelijke informatie. Het fysische
adres van sector 1 is als de sector ingelezen moet worden, niet bekend. Om
toch een sector met 1 als adres te kunnen lezen, wordt sector adres 1
altijd vertaalt tot fysisch adres 1.

Inhoud system sector:

byte
00-1F	conversie tabel van logisch naar fysisch sector adres.
	Hiermee is het mogelijk een opzoek tabel van 32 adressen te
	realizeren.

20	bit
	7	indien dit bit staat dan wordt er geen conversie gedaan. Het
		logische adres wordt beschouwd als het fysische adres.

	6	indien dit bit staat, dan wordt er voor sectoren op kant een
		(1) van de disk een opzoekfunctie verricht met offset. Dit
		houdt in dan allereerst het aantal sectoren dat aan een kant
		staat van het logische adres wordt afgetrokken, dan de
		conversie via de tabel waarna bij het aldus gevonden
		fysische adres weer het aantal sectoren wordt opgeteld wat
		er eerst was afgetrokken. Op deze manier is het mogelijk de
		conversie tabel te gebruiken tot maximaal 64 sectoren per
		track.

	5	Als dit bit staat dan wordt bit 7 van het het track adres
		hoog gemaakt. Hiermee wordt voorkomen dat de diskdriver
		bij het opzoeken van de track twee stappen doet per track
		(dit geldt alleen voor 80 tracks drives).

	4-0	gereserveerd.

21	aantal tracks. Een betere benaming is het aantal cilinders, uit
	gewoonte en gebruik is dit niet gedaan.

22	aantal sectors per track.
	Voor een lees/schrijf sector actie wordt er getest of het
	track adres niet groter gelijk is aan het track maximum en of het
	sector adres niet groter is dan het sector maximum. Track adres 0
	en sector adres 1 worden altijd toegelaten. Dit is noodzakelijk
	voor het lezen van de system sector.

23	aantal sectors per kant (side).
	Dit aantal wordt gebruikt voor het bepalen van de kant van de
	disk. Als het fysisch sector adres groter is dat dit maximum dan
	wordt bit 7 hoog gemaakt. Dit maximum sector adres wordt tesamen
	met bit 6 van byte 20 ook gebruikt voor de offset conversie functie.

24-27	bitmap van geheel lege disk per vier allocatie bytes. Deze bitmap
	wordt gebruikt voor het zoeken van een aaneengesloten stuk
	diskruimte dat vrij is. Bits die nul zijn, zijn sector adressen
	die niet bestaan. In de allocatie map zijn de corresponderende
	bits dan ook tijdens het initialiseren van de disk op nul gezet.
	Het zoek algoritme zal dan ook allocatie bits overslaan die
	corresponderen met een gereset bit in deze vier bytes.

28	allocatie aantal. Dit byte geeft aan hoeveel sectoren er bezet
	geboekt worden per bit. Het getal moet altijd een macht van twee zijn
	(1,2,4,..). Dit aantal heeft tevens effect hoe uit het vrij gevonden
	track/sector adres het sector adres wordt aangepast (het aantal keer
	dat het berekende sectoradres vermenigvuldigd wordt met twee).
	Voor een allocatie aantal 2 en gevonden sector adres 3, wordt het
	effectieve sector adres (3-1)*2+1 = 5. De factor 1 komt regelmatig
	voor; dit is de offset die de eerste sector heeft. DOS65 weet dat
	als er een sector gealloceerd wordt uit de vrije map dat er,
	voor dit geval, nog een sector vrij is namelijk een sector met
	adres 6. Voor een allocatie aantal van 4 en hoger gaat het
	algoritme op een soortgelijke manier.

29	byte/bit positie naar track/sector adres conversie. Dit byte geeft
	aan hoe uit de gevonden vrije bitpositie het track/sector adres
	gevormd moet worden. De inhoud is het aantal maal dat het track adres
	berekent uit de bytepositie t.o.v. byte 60 door twee gedeeld moet
	worden. Bij het sectoradres wat aanvankelijk bepaald is uit de
	gevonden bit positie, wordt de rest van de deling vermenigvuldigt met
	het aantal bits wat in een byte gaat, opgeteld. Praktisch gezien is
	de inhoud van dit byte 2 (delen door 4) voor 40 tracks drives, 1 voor
	80 tracks en 0 voor grotere drives (winchesters). Bij het sectoradres
	wordt resp. byte positie modulo 3, 1 of 0 vermenigvuldigd met 8
	opgetelt. Een voorbeeld: bit 4 byte 66 is vrij. De schuif aantal
	is 2. Het track adres wordt dus: (66-60)/4 = 1, het sector adres
	wordt: (66-60)%4*8+4+1 = 21 (`%' is de modulo operatie). Het
	sector adres wordt hierna aangepast volgens het algoritme
	beschreven bij byte 28. Was het schuif aantal 1 dan wordt het
	track adres (66-60)/2 = 3 en het sector adres (66-60)%2*8+4+1 = 5.


2A,2B	eerste track/sectorlist adres track/sector allocatie. Byte 26 wijst
	naar de track terwijl byte 27 het bitpatroon bevat waarmee een
	gedeelte van het allocatiebyte beschermd kan worden. Met deze twee
	bytes kan effectief een aantal bits allocatie gereserveerd worden
	voor directory sectors.

2C	eerste data sector allocatie track. Hiermee is het mogelijk een
	aantal tracks te reserveren voor directory en track/sectorlist
	sectors.

2D-2F	gereserveerd.

30,31	track/sector adres van de track/sectorlist sector van de te booten
	file. Dit adres wordt ingesteld met het commando `BOOTLINK file'.

32,33-	track/sector adressen naar de eerste sector van de directories
3E,3F	A t/m G. Sector adres 0 betekent dat de directory nog niet gecreerd
	is.

40-57	naam van de disk. De naam moet afgesloten zijn door 00.

58-5B	tijd en datum van disk initialisatie.
5C-5F	tijd en datum van laatste disk verandering.

60-FF	allocatie bitmap bytes. Afhankelijk van byte 28 staat elk bit voor
	een of meer sectors, afhankelijk van byte 29 staan een of meer bytes
	voor een track. Een gereset bit betekent dat die sector(s) in gebruik
	zijn.


1.2 Directory sector
--------------------
Er kunnen onder DOS65 op een disk acht directories bestaan. De `home'
directory (@) begint altijd op track 0 sector 3. De eerste sectors van de
andere directories (A t/m G) worden aangewezen door de bytes beschreven in de
system sector. Directories worden indien nodig automatisch uitgebreid of
gecreerd.

Een directory sector ziet er als volgt uit:

byte
00-0D	naam van de file. Een negatief eerste karakter betekent dat die file
	verwijderd is. Als het eerste byte nul is, dan betekent dit het einde
	van de directory. Negatieve karakters in de rest van de filenaam
	duiden op `wilde' karakters bedoeld voor commando's. De naam wordt
	met 00 afgesloten als zij minder dan 14 karakters lang is.

0E,0F	track/sector adres van de eerste track/sectorlist sector.

10-EF	gelijk 00-0F alleen voor de volgende files. Er kunnen dus maximaal
	15 filenamen in een directory sector worden opgeslagen.

F0,F1	track/sector adres van de vervolg directory sector. Nul als
	sector adres betekent het einde van de directory.
F2,F3	terugwaards adres naar de vorige directory sector. Dit is nog niet
	geimplementeerd.
F4-FF	gereserveerd.


1.3 Track/sectorlist sector
---------------------------
De track/sectorlist (TSL) bestaat uit een of meer sectors. De eerste TSL
sector heeft de volgende opbouw:

byte
00,01	vervolg TSL adres. Sector adres 0 betekent de laatste TSL sector.
02,03	vorige TSL adres. In de eerste TSL sector staat sector adres 0.

04	protectie en modebyte van de file.
	bit 7,6,5,4 staan voor resp. read,write,delete en program.
	bit 3,2 voor 01 executable, 10 command en 11 extended.
	bit 1,0 voor 01 ascii, 10 binary en 11 special.

05	gereserveerd.

06,07	filenaam directory positie. Byte 06 is het volgnummer van
	de directory sector in de lijst van directorysectors, Byte 07 bit 0-2
	adresseren de directory, bit 4-7 wijst naar de positie in de
	directory sector.

08-0F	gereserveerd.

10,11	file load adres. Dit is het geheugenadres vanaf waar de file geladen
	wordt. Voor binary files wordt dit adres niet gebruikt, daar staan
	de load adressen in de file zelf.
12,13	file start adres. Het programma wordt op dit adres gestart. Voor
	binary files geldt ook hier dat het startadres in de file staat.

14-16	aantal bytes dat de file lang is.
17	file versie nummer. Dit wordt iedere keer verhoogt indien de file
	voor write geopend is.
18-1B	tijd en datum dat de file gecreerd is.
1C-1F	tijd en datum dat de file veranderd is.

20-FF	track/sector adressen van de data sectors.
	Een sector adres 0 betekent dat er geen data sectoren meer zijn.

Vervolg TSL sectors hebben dezelfde opbouw alleen beginnen de track/sector
adressen van de data sectors dan op byteadres 4.


1.4 Data sector
---------------
Data sectors bevatten alleen data. Niet geheel gevulde laatste sectors
bevatten voor de rest van de sector niet gedefinieerde data.

2. BINAIRE FILE
---------------

In tegenstelling tot files waar het loadadres, startadres en lengte van
het programma in de eerste TSL sector is gespecificeerd, staat deze informatie
bij binaire files tussen de data. Hiermee is het mogelijk een programma op
meerdere plaatsen in het geheugen te laden.

Het formaat van binaire files wordt voor data bytes gedefinieerd door
header byte 01, een twee byte loadadres, een twee byte aantal specificatie
en data bytes. Een startadres specificatie heeft header 02 gevolgd door
een twee byte startadres.


		      1	 	  2		2	     n
		 ---------------------------------------------------
programma	| header 01 | loadadres | n data bytes | data bytes |
		 ---------------------------------------------------
		 ------------------------
startadres	| header 02 | startadres |
      		 ------------------------

In het twee byte adres of in de twee byte aantal specificatie komt eerst
het low byte gevolgd door het high byte.

Binaire files worden o.a. gegenereerd door assemblers. Zij hebben dan
voldoende aan een klein object buffer dat regelmatig geleegd wordt.
