


		    ##		  ######
		  ##  ##	##
		##	##	##
		##########	  ####
		##      ##	      ##
		##      ##	      ##
		##      ##	######



Conditionele macro assembler voor de 65(C)02 microprocessor.


A.B.M. Brouwer
Nieuwkoopseweg 44
2641 PB Pijnacker


De assembler wordt gestart met het commando `as filenaam'. AS zal de
source file lezen en hieruit direct uitvoerbare 65(C)02 code genereren.

De source filenamen hebben default de extensie .mac. De object file
krijgt default de extensie .bin.

As assembleert de source in twee fasen, pass 1 en pass 2. Alleen
tijdens pass 2 komen er foutmeldingen op het scherm en wordt er code
naar de object file geschreven.


OPTIES
------

Opties mogen voor of achter de filenaam worden opgegeven. Opties die
gevolgd worden door een string of getal moeten afgesloten worden met
een "witte" spatie (spatie, tab of einde regel). Losstaande opties
mogen achter elkaar worden opgegeven.

 -l	laat een listing zien. Een `opt nolis' instruktie stopt het
	printen tot een `opt lis' instruktie.
 -s	print na afloop de globale labels.
 -n	print de source regels met regelnummers voor het labelveld.
 -o	geen binary object file.

 -cnnn	definieer de maximale lengte van de listing regel.
	Maximaal is dit 240, minimaal 10. Default wordt 240 genomen,
	optie -c alleen definieert de lengte op 78.

 -aargument,..	definieer een argument voor de argm instruktie. Deze
		argumenten moeten in hetzelfde formaat worden
		opgegeven als een standaard macro aanroep. In het
		argument kunnen echter geen spaties voorkomen.

 -bbinfile	definieer de binary object filenaam. De file krijgt
		default extensie `.bin'.

`As -lns test' assembleert `test.mac' met object file `test.bin', met
listing, regelnummers en listing label tabel.

`As -boutput.obj -c -l test.txt' assembleert `test.txt' met binary
object file `output.obj' en listing waarbij de regels tot 78
karakters beperkt worden (terminal breedte).

`As test -lc96 -o' assembleert test zonder binary output file, met
listing waarbij de regel beperkt blijft tot 96 karakters.

`As test -a"text",3' assembleert `test.mac' met binary output file,
met als argumenten `"text"' en `3'.


SOURCE FORMAAT
--------------

Een regel source heeft vier velden, n.l. label instruktie operand en
een commentaar veld. Als een instruktie geen operand nodig heeft, dan
wordt eventueel volgende tekst als commentaar opgevat.

De velden worden van elkaar gescheiden door een of meer "witte"
spaties. Dit geldt niet voor het operand veld wanneer spaties zich
binnen een string bevinden of als er een karakter als konstante
gedefinieerd wordt.

In elk veld kan een commentaar veld gestart worden d.m.v. het `;'
karakter. Lege regels zijn ook commentaar regels.

label	inx			voorbeeld
label	sta	label		voorbeeld
label				;voorbeeld `;' noodzakelijk omdat
;				anders `voorbeeld' als instruktie
;				wordt beschouwd.

Labelvelden mogen 40 karakters lang zijn, instruktievelden 20
karakters en afzonderlijke operands in het operandveld 80 karakters.
De totale regel mag 160 karakters lang zijn. Deze afmetingen zijn
gekozen rekening houdend met het feit dat de originele source velden
aanzienlijk langer kunnen worden tijdens macro executie wanneer
parameters door argumenten worden vervangen.


65(C)02 INSTRUCTIE SET
----------------------

Standaard 6502 instrukties. Zover mogelijk en wenselijk is de
standaard mnemonic gehandhaaft.

adc	and	asl	asla	bcc	bcs	beq	bit
bmi	bne	bpl	brk	bvc	bvs	clc	cld
cli	clv	cmp	cpx	cpy	dec	dex	dey
eor	inc	inx	iny	jmp	jsr	lda	ldx
ldy	lsr	lsra	nop	ora	pha	php	pla
plp	rol	rola	ror	rora	rti	rts	sbc
sec	sed	sei	sta	stx	sty	tax	tay
tsx	txa	txs	tya

Standaard 65C02.
Deze wordt geselecteerd met de pseudo instruktie `opt c02'. Naast een
aantal standaard instrukties waarvan de adresseringsmogelijkheden
zijn uitgebreid, zijn er ook nieuwe instrukties:

bra	deca	inca	stz	trb	tsb	phx	phy
plx	ply


Rockwell 65C02.
Deze worden tesamen met de andere 65C02 uitbreidingen geselecteerd
met de pseudo instruktie `opt rc02'. De volgende instrukties zijn
toegevoegd:

bbr	bbs	rmb	smb


INSTRUKTIE OPERAND
------------------

Instrukties zonder operand:
6502:
asla	brk	clc	cld	cli	clv	dex	dey
inx	iny	lsra	nop	pha	php	pla	plp
rola	rora	rti	rts	sec	sed	sei	tax
tay	tsx	txa	txs	tya

65C02:
bra	deca	inca	phx	phy	plx	ply


De andere instrukties hebben een of meer operands.

De vier rockwell 65C02 instrukties hebben twee of drie operands. Er
is gekozen om het bit nummer dat bij deze instrukties hoort, naar het
operand veld te verplaatsen omdat het dan mogelijk is het bit nummer
d.m.v. een label voor te stellen. De syntax is als volgt:

	bbr (bbs)	#bit,memoryadres,sprongadres
	rmb (smb)	#bit,memoryadres

Addresserings keuze:

<opr	forced page zero. As kiest default page zero adressering als
	de operand kleiner is dan 256 en de page zero
	adresseringsmode voor die instruktie aanwezig is.

>opr	forced absolute. Dit kan nodig zijn in het geval van opr,x
	adressering, waarbij het effectieve adres hoger is dan 255.

#opr	immediate.

opr,x	indexed x.
opr,y	indexed y.

[opr]	indirect.
[opr,x]	indexed x indirect.
[opr],y	indirect indexed y.


PSEUDO INSTRUKTIES
------------------

	argl	argument	definieer een default argument in het
				geval de gebruiker geen -a argument
				meegeeft.

label	argm	parameter,..	definieer de argument macro.
				Parameters die gedefinieerd zijn
				worden vervangen door het argl
				argument. Label is de naam die aan
				het argument toegekend wordt (dit
				label wordt verder niet gebruikt).

	cont	filenaam	sluit de huidige source file en ga
				verder met file filenaam.

	else			assembleer tot endif indien er binnen
				de huidige if-endif nog niet
				geassembleerd is.

	elseif	conditie	assembleer tot de volgende endif,
				elseif of else indien er binnen de
				huidige if-endif nog niet
				geassembleerd is en conditie waar is.

	end	[adres]		stop met lezen uit de huidige file.
				Indien adres wordt opgegeven, dan
				wordt dit als startadres naar de
				object file verstuurd. Dit gebeurt
				niet voor lib files.

	endif			sluit het huidige if-endif blok.

	endm			einde macro definitie.

label	equ	expressie	definieer een label met waarde
				expressie.

	exitm			verlaat de huidige macro.

[label]	fcb	expressie,..	genereer bytes expressie.

[label]	fcc	expressie,..	genereer bytes gelijk fcb. Expressie
				mag hierbij ook een string zijn
				omsloten door `'' of `"'.

[label]	fdb	expressie,..	genereer woorden expressie.

	if	expressie	assembleer de volgende source tot
				endif, elseif of endif indien
				expressie waar is.

	ifb	expressie,offset	spring binnen de huidige
				macro indien expressie waar is.
				Offset gelijk aan 1 slaat de volgende
				regel over, offset -1 springt naar de
				vorige macro regel.

	lib	filenaam	voeg de source van file filenaam
				tussen die van de huidige file. Dit
				kan 2 niveaus diep.

label	macro	parameter,..	definieer de volgende source regels
				tot endm als macro met naam label.

	opt	optie,..	(re)set assembler opties. Behalve
				optie con staan alle opties aan.

[label]	org	expressie	zet de programmateller op expressie.

	pag			begin de volgende regel op een nieuwe
				bladzijde. Er wordt op elke pagina
				een kop geprint indien optie pag aan
				is en de titel (ttl) string
				gedefinieerd is. Een pagina wordt
				afgesloten door een form-feed ($0c).

	pag	expressie	definieer de pagina lengte (default
				58). Indien expressie negatief is,
				wordt er op een nieuwe pagina
				begonnen als er minder dan
				-(expressie) regels op de huidige
				bladzijde over zijn.

[label]	res	expressie	reserveer een stuk geheugen ter grote
				van expressie bytes.

[label]	res	expressie,data	vul expressie bytes met waarde data.

label	set	expressie	geef label de waarde expressie. Zonodig
				wordt tijdens pass 1 dit label gecreerd.

	ttl	string		definieer een kop regel die boven
				elke bladzijde wordt afgedrukt.


LABELS
------

Karakters die een label vormen zijn:

A-Z, a-z, 0-9, _, ., en $.

Als het eerste karakter van een label een nummer is, dan is dit een
locaal label. Volgende karakters mogen alleen nummers zijn. De waarde
van dit getal mag liggen tussen 0 en 255 (Grotere getallen worden
modulo 256 genomen).

Locale labels zijn niet toegestaan als `EQU' of `SET' label.

Labels mogen tijdens declaratie worden afgeloten met `:' of met `.'
voor locale labels.

Globale labels mogen 40 karakters lang zijn. Kleine en hoofdletters
zijn verschillend.


EXPRESSIE
---------

Een expressie mag bestaan uit labels of getallen met daartussen
rekenkundige, relationele en/of logische operaties.

Een label kenmerkt zich met een niet nummer en geen `$' als eerste
karakter (dus A-Z, a-z, _, of .). Een decimaal getal gevolgd door `.'
is een locaal label. Locale labels kunnen niet uniek zijn. Om het
zoeken te dwingen is het karakter achter de `.' het dwing karakter.
Deze karakters zijn:

 F,f	zoek het label dat het kleinste positieve verschil ongelijk
	nul heeft met de huidige programmateller (ligt "verder weg").
 B,b	zoek het label dat het kleinste negatieve verschil heeft met
	de huidige programmateller.

	Zonder dit dwing karakter kiest AS automatisch het label dat
	absoluut gezien de kleinste afstand heeft tot de waarde van
	de huidige programma teller. Als de afstand tot het vorige
	label gelijk is aan de afstand tot het volgende label dan
	kiest AS voor het volgende label.


Getallen zijn er in decimaal, binair, octaal en hexadecimaal. Het
talstelsel wordt gedefinieerd door het eerste of het laatste
karakter. Het talstelsel is decimaal als er geen talstelsel
wordt gespecificeerd.

 %	%0001	binair		
 @	@377	octaal
 $	$a05	hexadecimaal
 ..B	101b	binair
 ..O	563o	octaal
 ..H	08fh	hexadecimaal


Constanten

$	$+1	huidige programmateller. Het `$' karakter wordt als
		zodanig herkent	omdat het niet wordt gevolgd door een
		karakter dat tot een label behoort.

'.'	'a'	Een (1) karakter. De sluit `'' is niet noodzakelijk
		maar het gebruik ervan wordt wel aanbevolen.

".."	"cd"	Dubbel karakter (woord). Het sluit karakter `"'
		hierbij is niet noodzakelijk.

Karakters in een string of als konstante worden direct overgenomen.
Het `\' karakter vervult hierbij een speciale functie. Het karakter
achter `\' wordt omgezet tot:

 \a	$07	bell
 \b	$08	backspace
 \t	$09	tab
 \n	$0a	line feed
 \f	$0c	form feed
 \r	$0d	carriage return
 \E	$1b	escape

 \nnn		een getal achter `\' wordt octaal omgezet ('\0' is
		$00).

Alle andere karakters worden normaal overgenomen ('\\' wordt dus `\').

Operaties

Enkelvoudige operaties werken op de expressie direct achter de
operator. Deze operaties zijn:

 ~	~1	one's complement (bit inversie)
 !	!0	logical not (nul wordt een, niet nul wordt een)
 -	-5	minus (two's complement)

Meervoudige operaties zijn onder te verdelen in aritmetische,
logische, relationele en conditionele operaties.

Aritmetische operaties:

 *	3*3	vermenigvuldigen	
 /	5/3	delen
 %	4%3	modulo
 +	4+6	optellen
 -	4-1	aftrekken

 <<	1<<8	schuif naar links (1 acht naar links)
 >>	256>>8	schuif naar rechts

 &	4&1	en (bit en)
 ^	9^2	exclusive or
 |	1|4	inclusive or

Logische operaties 

 ==	3==2	gelijk
 !=	4!=4	ongelijk

    "de"=="de"	Alleen bij deze twee operaties gelden de operatoren
      		tevens voor strings. In alle andere gevallen is het
      		resultaat niet gedefinieerd. Strings worden alleen
		herkent bij de fcc of conditionele pseudo instrukties.
		
 <	4<3	kleiner dan
 <=		kleiner dan of gelijk
 >		groter dan
 >=		groter dan of gelijk

 &&	3&&0	logische en
 ||	3||0	logische or

Conditionele operatie

 ? :	1?2:3	indien dan anders. Bij deze operatie zijn dus twee
		vervolg operatoren gescheiden door `:' nodig.

De operaties worden van links naar rechts geevalueerd daarbij
rekening houdend met de volgende regels:

Een expressie tussen haakjes `(  )' heeft de hoogste prioriteit.

In tabelvorm aflopend in prioriteit.

 -	~  !  -
 -	*  /  %
 -	+  -
 -	<< >>
 -	< <= > >=
 -	== !=
 -	&
 -	^
 -	|
 -	&&
 -	||
 -	?:


CONDITIONELE INSTRUKTIES
------------------------

De conditionele instrukties if, elseif, else en endif kunnen 10
niveaus diep gaan. Het is dus mogenlijk om if-endif konstrukties in
elkaar te plaatsen.

Voor if en elseif zijn onbekende labels gelijk aan nul (0) wat het
conditioneel assembleren beperkt tot het wel of niet van te voren
definieeren van dat label ongelijk aan nul.

Het is verder mogelijk om een conditie afhankelijk van het eerste
karakter van het label te laten zijn. Dit gebeurt in de vorm van `if
karakter,operand'. Voor karakters die toegelaten worden als label
(bv. `a') geldt dan dat die operand exact gelijk moet zijn aan het
karakter waarmee het vergeleken wordt (bv. `a,a'). Voor andere
karakters is het voldoende dat het eerste karakter gelijk is (bv.
`#,#5').

Met de `.,operand' expressie kan getest worden of een operand
aanwezig is. De expressie is waar in het geval dat er geen operand
is.

Tijdens het verwerken van operands als `>#5' worden er karakters
overgeslagen zolang deze behoren tot `<', `>' of `#'. Deze karakters
worden voor standaard instrukties gebruikt om de assembler voor een
bepaald type operand te laten kiezen. Voor pseudo instrukties (bv.
fcc) zijn ze van geen nut en worden dan overgeslagen.

De gegeven opzet is voornamelijk van belang voor macro's. Door
macro's zorgvuldig te definieren, kan met een macro definitie gekozen
worden uit verschillende uitvoer.


MACRO'S
-------

Macro's kunnen tot 10 niveaus diep gaan. Zij kunnen daarbij andere
macro's aanroepen waarbij dan de eventueel bijbehorende argumenten
doorgegeven worden.

Macro's definities mogen niet langer zijn dan 255 regels.

Labels, instrukties of operands worden door meegegeven argumenten
vervangen indien het label, de instruktie of operand gelijk is aan
een parameter in de macro definitie.

Parameters in de macro definitie worden gescheiden door `,'. Alle
karakters worden opgenomen in de lijst maar er volgt een foutmelding
indien er een niet label karakter in een parameter voorkomt.

Aanroep argumenten worden gescheiden door `,'. Als het `\' karakter
de `,' voorgaat, dan wordt het `,' karakter opgenomen in het
argument. Hiermee is het mogenlijk om gehele operands over te nemen
(bv `temp\,x' in de aanroep wordt `temp,x' als operand tijdens macro
expansie).

Het argument wordt beschouwd als string indien dit omsloten wordt met
`'' of `"'. Indien dit karakter voorafgegaan wordt door `\', dan
geldt dit karakter niet als openings of sluitings teken maar wordt
dan letterlijk overgenomen. Indien het de bedoeling is een (1) of een
dubbel karakter mee te geven, dan moet dit afgesloten worden (voor
niet macro's was dit niet verplicht).


TTL INSTRUKTIE
--------------

De operand van de ttl instuktie moet als string opgegeven worden.
De eerste drie karakters van de string bepalen de argumenten die
meegegeven worden. Dit zijn:

 t	datum en tijd.
 f	huidige filenaam.
 p	bladzijde nummer.

Indien voor het vierde karakter een karakter staat dat niet voldoet
aan de hiervoor genoemde letters, dan wordt dit scannen gestopt en
wordt er verder gegaan met het printen van de string.

Uitvoer controle karakters.

 %d	print het volgende argument decimaal (pagina nummer).
 %b	print het volgende argument binair.
 %o	print het volgende argument octaal.
 %x	print het volgende argument hexadecimaal.

 %c	print het volgende argument als karakter.
 %s	print het volgende argument als string (tijd datum, filenaam).

	elk ander karakter wordt geprint (dus `%%' print `%').

Een decimaal nummer tussen `%' en het format karakter plaatst het
uitvoer argument in een n breed veld. Dit wordt dan aan de linker
kant opgevuld met spaties of `0' indien het eerste karakter van het
nummer `0' is. Het argument wordt aan de linker kant van het veld
geplaatst als voor het nummer het `-' karakter staat.

Als het nummer gevolgd wordt door `.' en een nummer, dan wordt het
argument maximaal dat aantal breed.

vb.	"t.Dit is de tijd %s"	Dit is de tijd 13-Nov-85 10:21

Dit laat de tijd zien. De `.' achter `t' stopt het plaatsen van
argumenten maar wordt zelf niet afgedrukt.

	"tfpTijd %s  file %s  pagina %d"
	Tijd 13-Nov-85 10:21  file TEST.MAC  pagina 1

Hieruit is te zien dat `tfp' in dezelfde volgorde moet staan als de
volgorde waarin ze geprint worden. Het verkeerd opgeven heeft meestal
vreemde gevolgen.

	"tfpTijd %s  file %15s  pagina %04d"
	Tijd 13-Nov-85 10:21  file        TEST.MAC  pagina 0001

	"fp.File %-20s  blz. %4d"
	File TEST.MAC            blz.    1

	"fp.File %-20.4s  blz. %4d"
	File TEST                blz.    1

Omdat het argument van ttl eerst door de string processor gaat,
worden backslashes eerst vertaalt tot speciale karakters.

".\7"	als ttl string print het bel karakter op elke pagina.


OPT INSTRUKTIE
--------------

Gedefinieerd opties zijn:

(no)lis		list control. Er wordt alleen een listing gegenereerd
		indien de assembler met de -l optie is gestart.

(no)pag		tel de regels per pagina. Print de titel regel boven
		elke pagina en sluit de pagina af met een form-feed.

(no)gen		meervoudige uitvoer regels voor fcb, fcc en fdb
		indien dit nodig is.

(no)mac		laat de macro aanroep regel zien. Deze wordt tevens
		geprint indien er een label voor de macro instruktie
		staat.

(no)exp		print regels tijdens macro uitvoering.

(no)con		print niet geassembleerd source (conditionele
		source).

(no)mne		laat pseudo instrukties regels zien die alleen dienen
		voor de assembler. Als een label optioneel is worden
		zij altijd geprint indien er een label voor de
		instruktie staat.

c02		selecteer bij de standaard 6502 instrukties de 65C02
		instrukties en toegevoegde adresserings
		mogelijkheden.

rc02		selecteer bij de 65C02 de rockwell 65C02 instrukties.


ASSEMBLER FOUTMELDINGEN
-----------------------

phasing error detected
----------------------
Deze melding wordt gegeven als gezien wordt dat het programma er
tijdens pass 2 anders uitziet dan tijdens pass 1. Dit geldt niet voor
de operand velden waar de labels vaak pas bekend zijn na pass 1 maar
voor de instrukties die op een andere plaats terecht komen. Deze
positiefout wordt herkent op een regel met een globaal label dat de
waarde krijgt (pass 1) of moet hebben (pass 2) van de huidige
programma teller. De positie fout is dus opgetreden tussen het
huidige globale label en de regel met het vorige globale
programmateller label.

Dit probleem wordt meestal veroorzaakt door een operand dat in pass 2
een zodanig verschil heeft met dezelfde operand tijdens pass 1 dat de
assembler tijdens pass 2 niet dezelfde adressering toepast als
tijdens pass 1. Uit voorzorg hiervoor neemt AS tijdens pass 1 aan dat
een onbekend label later een waarde krijgt dat groter is dan 255.

De positie fout kan ook optreden bij conditioneel assembleren als er
verschillende gedeeltes geassembleerd worden.

Om niet een hele reeks fouten op het scherm te krijgen, wordt deze
foutmelding maar een keer per programmadeel (org instruktie) geprint.

unrecognizable mnemonic or macro
--------------------------------
Er is een onbekende instruktie gedefinieerd. Meestal is dit een
invoerfout. AS genereert drie NOP instrukties zodat de gebruiker deze
desgewenst zelf kan invullen.

operand syntax error
--------------------
Leeg of niet correct operand veld. De assembler zal in veel gevallen
toch een correcte uitvoer geven.

invalid addressing mode
-----------------------
Niet toegestane adresserings mogelijkheid. De assembler zal
afhankelijk van de bestaande mogelijkheden en opgegeven adresserings
informatie een bestaande instruktie genereren.

missing ']'
----------
Bij de indirecte adressering wordt de sluit `]' gemist. Afhankelijk
van de indexering genereerd AS een indirecte instruktie.

branch too long
----------------
De relatieve sprong van de branch instruktie is groter dan +127 of
kleiner dan -128. Dit geldt ook voor de rockwell 65c02 test en spring
instruktie.

operand not at page zero
------------------------
Het operand adres is groter dan 255. Deze fout wordt gegeven voor de
indirecte adressering (behalve jmp) en voor de rockwell 65c02 bit
instrukties.

operand truncated
-----------------
Deze waarschuwing wordt alleen op verzoek (commando optie -w) geprint
als een byte operand groter is dan 255. (immediate adresering, fcb
instruktie en andere enkelbyte operands).

can't open source file
----------------------
Voor lib of cont instrukties. Bij de lib instruktie gaat de assembler
verder met de huidige file, bij de cont instruktie in library files
wordt de fout beschouwd als end-of-file, anders (hoofdprogramma)
springt AS, na een melding, naar het operating system.


macro label equals mnemonic
---------------------------
Er wordt een macronaam bij aanvang van een macro definitie gebruikt
die al bestaat als standaard opcode. De macro definitie wordt
overgeslagen.

macro label missing
-------------------
Er is geen macronaam in het labelveld bij aanvang van een macro
definitie. De macro definitie wordt overgeslagen.

macro not defined in pass 1
---------------------------
Tijdens pass 2 wordt een macro definitie gezien die niet gedefinieerd
is tijdens pass 1.

multiple defined macro
----------------------
Deze macronaam is al in gebruik. De macro definitie wordt
overgeslagen.

can't replace parameter
-----------------------
Tijdens macro executie kan een parameter niet vervangen worden door
een argument die aan de macro is meegegeven. Meestal zijn er dan bij
de aanroep geen of te weinig argumenten meegegeven.

not allowed in this context
---------------------------
Een instruktie die alleen geldig is binnen een macro (exitm) of
tijdens een macro definitie (endm) of die niet voor mag komen in een
macro (lib).

invalid expression
------------------
Een operand expressie die niet klopt. Voor de opt instruktie betekent
het dat de gespecificeerde optie niet bestaat (meestal syntax fout).

missing ')'
-----------
De expressie die tussen haakjes staat, mist de sluit `)'.

digit not in specified range
----------------------------
In de expressie komt een karakter voor die niet in het bereik ligt
van het talstelsel.

label not defined in pass 1
---------------------------
Tijdens pass 2 komt een label voor dat niet tijdens pass 1
gedefinieerd is.

undefined label
---------------
Het opgegeven label in het operandveld niet gevonden worden.

missing label
-------------
Geen labelnaam in het labelveld bij een equ of set instruktie. De
instruktie wordt genegeerd.

invalid label
-------------
Een niet correct gedefinieerd label. De labelnaam wordt zover
mogelijk gebruikt.

multiple defined label
----------------------
Het opgegeven label bestaat al. Het huidige label wordt genegeerd. In
expressie evaluatie wordt dus alleen het eerste label gebruikt.

unbalanced conditional
----------------------
Als de conditionele instruktie hier niet mogelijk is. B.v. else of
endif zonder dat er eerst een if instruktie aan vooraf gegaan is. Het
eenmaal misgaan van een conditionele instruktie (b.v. door er een
syntax fout) kan grote gevolgen hebben.


ANDERE FOUTMELDINGEN
--------------------

Deze foutmeldingen zijn fataal, d.w.z. er wordt direct daarna
teruggekeerd naar het operating system. De meeste meldingen laten
zien waar in de file de fout optrad.


can't open source file
----------------------
De file die geassembleerd moet worden, bestaat niet of kan niet
geopend worden.

can't create object file
------------------------
Er kan om de een of andere reden geen object file gecreerd worden.

error writing object file
-------------------------
Tijdens het schrijven naar de object file komt er een fout voor.
Waarschijnlijk is de disk beschermd of vol.

library nesting too deep
------------------------
Het niveau van library files wordt door deze lib instruktie groter
dan 2. Dit aantal is zo gekozen dat het voor normaal gebruik
voldoende is.

can't continue
--------------
De file die het vervolg is in het hoofdprogramma bestaat niet of kan
niet geopend worden. Een continue error voor library files wordt
beschouwd als einde file.

if level too deep
-----------------
Het niveau van conditionele instrukties wordt door deze if instruktie
hoger dan 10. Oorzaak kan zijn een if-endif konstruktie in een macro
die niet goed gedefinieerd is.

macro nesting too deep
----------------------
Het niveau van macro's die elkaar aanroepen wordt hoger dan 10.

macro line buffer overflow
--------------------------
De lengte van argumenten van alle active macro's is groter dan 200
karakters. Mocht dit probleem zich voordoen, dan kan een oplossing
zijn het vervangen van complexe expressies door labels die staan voor
de waarde van die expressies.

macro linecount overflow
------------------------
Het aantal regels in de macro is groter dan 255. Opsplitsing van de
macro in meerdere macro's en/of verwijderen van kommentaarregels is
de oplossing.

origin specification
--------------------
In de definitie van de programmateller kwam een of andere fout voor
(voor pass 1 betekent dit o.a. dat er geen onbekend label in de
expressie mag voorkomen).

out of memory
-------------
Er is niet genoeg geheugen of labels en macro's in het geheugen op te
slaan. Oplossingen:
- vervang globale labels door locale. Globale labels nemen minimaal 9
  bytes in beslag tegen 3 bytes voor locale labels.
- verwijder kommentaar uit macro definities.
- inkorten van de sourceregels in de macrodefinitie. Dit kan zonder
  veel problemen gebeuren voor de macro parameters.

