/******************************************************************/
/* file : conv.c                                            	  */
/* convert AIM format source file to DOS65_AS format source file  */
/* author : Adri Hankel                                           */
/* date : 16-06-87                                                */
/* WARNING : check created .mac file for 			  */
/*	     syntax before ASsembling it !                        */
/*           (this programm does not support ALL aim-type         */
/*            facilities !!                  ---                  */
/* 								  */
/*								  */
/*                      ECO-C version : june 1987		  */
/*                    Turbo-C version : july 1987		  */
/* adapted for DOS65 small C compiler : august 1987  		  */
/* last revision : see 'version'                                  */
/******************************************************************/

#define LF 10
#define EOF -1
#define FALSE 0
#define TRUE 1
#define SIZE 80 	/* buffersize (one line) */

int spcount;		/* space and/or tab counter in current line */
int conflag;		/* conversion flag */
int end_sign; 		/* to indicate end of conversion */
char input[SIZE];	/* inputbuffer  */
char output[SIZE]; 	/* outputbuffer */
int fp1, fp2;		/* file descriptors */

main(argc,argv)
int argc,*argv;
{
	int linecounter;
	char *fname1, *fname2, *version;
	conflag = FALSE;
	linecounter = 1;
	fname1="               ";
	fname2="               ";
	version="19-08-87";

/* start with a clear screen */

	putchar(12);

/* check for argument */

	if (--argc > 0) fname1 = *++argv;
	else 
		{ 
		  beep();
		  printf ("Error : Missing filename\n");
		  exit (-1);
		}
	strcpy (fname2, fname1);
	strcat (fname2, ".mac");  /* set extension for dest. file */

/* open files */

	if (!(fp1 = fopen (fname1, "r"))) 
		{
		beep();
		printf ("Error : Cannot open source file %s\n", fname1);
		exit (-1);
		}

	if (!(fp2 = fopen (fname2, "w"))) 
		{
		beep();
		printf ("Error : Cannot open destination file %s\n", fname2);
		exit (-1);
		}

/* start conversion */
	printf("\fAIM to DOS65 sourcefile conversion utility. ");
	printf("Version : %s\n\n", version);
	printf("Converting '%s' to '%s'.\n\n", fname1, fname2);
	printf("Current line :\n");
	end_sign = FALSE;
	while (end_sign == FALSE)		/* eof indicator */
		{
		printf("\r%d",linecounter);  
		read_line();			/* read from source */
		convert_line();			/* convert it       */
		write_line();			/* write to dest    */
		linecounter++;			/* adjust lc        */
		}
	fclose (fp2); fclose (fp1);
	printf("\nConversion completed.\n");
}
		

read_line()
{
int count;
char ch;
for (count = 0; count != SIZE; count++ )
	{ 
	if ((ch = getc(fp1)) == EOF) 
		{ input[count] = '\000'; end_sign = TRUE; break; }
	else if (ch == LF) 
		{ input[count] = LF; input[count+1] = '\000'; break; }
	else input[count] = ch;
	}
}

convert_line()
{
int count;
input_low();	/* convert input buffer to lower case */
totab();	/* convert spaces to tabs where posible */
bytfcc();	/* convert .byt to fcc */
worfdb();	/* convert .wor to fdb */
resset();	/* convert *=*+ to res<tab> */
setorg();	/* set 'org' if possible */
setlow();	/* convert '<label' to 'label&255' */
sethigh();	/* convert '>label' to 'label>>8' */
indy();		/* convert '(opr)y' to '[opr],y */
convp();	/* convert '.' at pos 0 to tab */
labset();	/* adjust label in line */
for (count = 0; input[count] != 0; count++ )
	{ 
	 output[count] = input[count];
	}
output[count] = '\000';
}

write_line()
{
	fputs(output, fp2);
}
/*****************************************************************/
/*			low level routines			 */
/*****************************************************************/

input_low() /* convert input buffer to lower case */
{
int count;
for (count = 0; input[count] != 0; count++ )
	{
	if (input[count] == 39) break; /* when ''' found no tolower */
	input[count] = tolower(input[count]); 
	}
}

totab()	/* convert spaces to tabs where posible */
{
int count;
char flag;
flag = FALSE;
for (count = 0; input[count] != 0; count++ )
	{
	if (input[count] == 59) flag = TRUE; /* when ';' found no conv. */
	if (input[count] == 39) flag = TRUE; /* when ''' found no conv. */
	if ((input[count] == 32) & (flag == FALSE))
		input[count] = 9;
	}
}

			
bytfcc()	/* convert .byt to fcc */
{
int count, teller;
char *source, *dest;

for (count = 0; input[count] !=0; count++)
	if (input[count] == 46)	/* when '.' found */
		{
		source = "   ";
		for (teller = 0; teller != 3; teller++)			
			{
			source[teller] = input[(count+teller+1)];
			}
		dest = "byt";
		if (!(strcmp(source,dest)))
			{
			input[count]   =   9; /* tab */
			input[count+1] = 102; /* f */
 			input[count+2] =  99; /* c */
			input[count+3] =  99; /* c */
			}

		}
}

worfdb()	/* convert .wor to fdb */
{
int count, teller;
char *source, *dest;

for (count = 0; input[count] != 0; count++)
	if (input[count] == 46)	/* when '.' found */
		{
		source = "   ";
		for (teller = 0; teller != 3; teller++)			
			{
			source[teller] = input[(count+teller+1)];
			}
		dest = "wor";
		if (!(strcmp(source,dest)))
			{
			input[count]   =   9; /* tab */
			input[count+1] = 102; /* f */
 			input[count+2] = 100; /* d */
			input[count+3] =  98; /* b */
			}
		}
}

resset()	/* convert *=*+ to res<tab> */
{
int count, teller;
char *source, *dest;
for (count = 0; input[count] != 0; count++)
	if (input[count] == 42)	/* when '*' found */
		{
		source="   ";
		for (teller = 0; teller != 3; teller++)			
			{
			source[teller] = input[(count+teller+1)];
			}
		dest="=*+";
		if (!(strcmp(source,dest)))
			{
			input[count]   = 114; /* r */
			input[count+1] = 101; /* e */
 			input[count+2] = 115; /* s */
			input[count+3] =   9; /* tab */
			}
		}
}

setorg()	/* set 'org' if possible */
{
int count;

if ((input[0] == 42) & (input[1] == 61) & (input[2] != 42))
	{
	for (count = (SIZE-3); count != -1; count--)	
		{
		input[count+3] = input[count];
		}
	input[0] =   9; /* tab */
	input[1] = 111; /* o */
	input[2] = 114; /* r */
	input[3] = 103; /* g */
	input[4] =   9; /* tab */
	conflag  = TRUE;
	}
}

setlow()	/* convert '<label' to 'label&255' */
{
int count, teller, helpv, secnd;
for (count = 0; input[count] != 0; count++)
   if (input[count] == 39) break;  /* when ''' found no conv */
   else	if (input[count] == 60)	/* when '<' found */
	 {
	 for (teller = count+1; teller != SIZE; teller++)
	  {
	  if (input[teller] > 47)
		{
		input[teller-1] = input[teller];
		}
	  else 	
		{
		helpv = teller-1; break;
		}
	  }
	 for (secnd = (SIZE-3); secnd != helpv; secnd--)		
		{
		input[secnd+3] = input[secnd]; 
		}
	 input[helpv]   = 38; /* &  */
	 input[helpv+1] = 50; /* 2  */
	 input[helpv+2] = 53; /* 5  */
	 input[helpv+3] = 53; /* 5  */
	 }
}

sethigh()	/* convert '>label' to 'label>>8' */
{
int count, teller, helpv, secnd;
for (count = 0; input[count] != 0; count++)
   if (input[count] == 39) break;  /* when ''' found no conv */
   else	if (input[count] == 62)	/* when '>' found */
	 {
	 for (teller = count+1; teller != SIZE; teller++)
	  {
	  if (input[teller] > 47)
		{
		input[teller-1] = input[teller];
		}
	  else 	
		{
		helpv = teller-1; break;
		}
	  }
	 for (secnd = (SIZE-2); secnd != helpv; secnd--)		
		{
		input[secnd+2] = input[secnd]; 
		}
	 input[helpv]   = 62; /* >  */
	 input[helpv+1] = 62; /* >  */
	 input[helpv+2] = 56; /* 8  */
	 break;
	 }
}

indy()		/* convert '(opr)y' to '[opr],y */
{
int count, teller, secnd;
for (count = 0; input[count] != 0; count++)
 {
 if (input[count] == 41)	/* when ')' found */
	{
	if (input[count+1] == 121) 
		{ for (secnd=(SIZE-1); secnd != count; secnd--)
		   	{
		   	input[secnd+1] = input[secnd]; 
		   	}
	    	  input[count]   = 93; /* ] */
	    	  input[count+1] = 44; /* , */
		  for (teller = count; teller > 0; teller--)
			{ if (input[teller] == 40)
				{
				input[teller] = 91; 
				break;
				} 
			}
	        }
	}
    }
}

isblank()
{
int count;
for (count = 0; input[count] != 0; count++)
	{
	if (input[count] ==  9) 
		{
		return(1);
		break;
		}
	if (input[count] == 32)
		{
		return(1);
		break;
		}
	}
return(0);
}

labset()	/* adjust label in line */
{
int count, secnd;
if (input[0] != 59) 
{
if (input[0] != LF) 		/* skip comment lines & empty lines*/
	{
	if (!( isblank() ))
		{
		for (count = 0; input[count] != 0; count++)
			{ 
			 output[count] = input[count];
			}
		output[count-1] = 9; /* tab instead of lf */
		output[count]   = '\000';
		write_line();
		read_line();
		input_low();
		totab();
		bytfcc();
		}
	else	{
		if ((input[0] != 9) & (conflag == TRUE))
			{ 
			sptel();
			if (spcount == 1) 
			{
			for (secnd=(SIZE-1); secnd != -1; secnd--)
			   	{
		   		input[secnd+1] = input[secnd]; 
			   	}
		    	input[0]   = 9;
			}
			}
		}
	}
}
}

sptel()		/* count spaces and/or tabs in current line */
{
int count;
spcount = 0;
for (count = 0; input[count] != 0; count++)
	{
	if (input[0] == LF) break; /* skip empty lines */
	if (input[0] == 59) break; /* skip comment lines */
	if (input[count] == 9) spcount++; /* count tabs */
	if (input[count] == 59) 
		{
		spcount--; /* found ';' --> adjust & exit */
		break;
		}
	if (input[count] == 39) 
		{
		spcount--; /* found ''' --> adjust & exit */
		break;
		}
	}
}

convp() 	/* convert '.' at pos 0 to tab */
{
if (input[0] == 46) input[0] = 9;
}

beep()
{
putchar(7); /* ring bell */
}
