 ttl "tp 6502 PC/AT keyboard interface V0.1               %s             page %d"
 
	pag	66
;
;files		keyb.MAC
;
;last modified	5th May 1988
;
;program	KeyB
;
;function	Routines for reading from
;               and sending commands to PC/AT keyboard
;               interface thru' spare 6522 VIA at $E160
;               Data input connected to PB0
;               Keyboard clock connected to PB1
;		This version for 128K discs
;
;usage		SIlicon -AVY
;
;by		Andrew Gregory
;		22, St. Mary's Avenue
;		Teddington
;		Middx.
;		TW11 0HZ
;		England
;
;DOS65 routines and variables
	lib	dvar.mac
	opt	lis
;
;interface addresses
;
VIA	equ	$E160	; 6522
ORB	equ	VIA	; Input/Output register
DDRB    equ     VIA+2   ; Data Direction register B
;
;zero page workspace
;
	org	$80
opt1	        res	1
;
	org	$A000
	jmp	begin
;
;give help reply
	fcc	$C8,$C5,$CC,$D0
	fcc	$EA,$EA,$EA
	fcc	'128K SILICON DISC FORMATTER v0.1'
	fcc	'\rSyntax:  SILicon -AVY'
	fcc	'\rOptions  -A : Close all files if error'
	fcc	'\r         -V : Verify before formatting'
	fcc	'\r         -Y : Do not ask for '
        fcc     'permission first',0
;
;tables
;point to each fcb+0 (indicates if file open)
fcb0	fcc 0,24,48,72,96,120
;point to each fcb+13 (indicates drive/dir)
fcb13	fcc 13,37,61,85,109,133
;
begin	php			save flags
;
	jsr	sopt		get options
	fcc	'AYV',0
	bcc	1.f		branch if OK
er1	jsr	print
	fcc	'Illegal -options',0
exitcr	jsr	crlf
exit	plp
	rts			return to DOS65
;
er2	jsr	print
	fcc	'*** File(s) open on drive 2',0
	jmp	err
;
;Check that all files to this drive are closed:
1	ldx	#5		six files
3	ldy	fcb0,x
	lda	varo,y		file number x+4 open?
	beq	2.f		branch if no
	ldy	fcb13,x
	lda	varo,y
	and	#3		discard sub-dir
	cmp	#2		drive 2?
	beq	er2		error if yes
2	dex
	bpl	3.b
;
	lda	opt		Get options
	asla
	sta	opt1
	asl	opt1		Permission needed?
	bcs	1.f		branch if no
	jsr	print
	fcc	'Destroy silicon disc? Y/N ',0
	cli
	jsr	in		get input
	jsr	loupch
	cmp	#'Y
	bne	exitcr		abort if no
	jsr	crlf
;
1	lda	#0		try to find out if
	tay			card plugged in.
	dey
	sta	latch		First block
	sta	silic
	cmp	silic
	bne	0.f
	sty	silic
	cpy	silic
	beq	2.f
0	jsr	print
	fcc	'*** Silicon disc not working',0
;
err	lda	opt		-A option
	bpl	0.f
	jsr	sync		close all files
0	jmp	exitcr
;
2	sta	silic+$100	second block
	cmp	silic+$100
	bne	0.b
	sty	silic+$100
	cpy	silic+$100
	bne	0.b
1	asl	opt1		Verification?
	bcs	4.f		Branch if yes
	jmp	9.f
;
;
;fill all memory with $00
4	tax
3	stx	latch
	tay
2	sta	silic,y
	sta	silic+$100,y	second page
	iny
	bne	2.b
	inx
	bne	3.b
;
;check all 0's and fill with $ff
	tax
3	stx	latch
	ldy	#0
2	lda	silic,y
	bne	badmem1
	lda	#$ff
	sta	silic,y
	cmp	silic,y
	bne	badmem1
        lda	silic+$100,y
	bne	badmem2
	lda	#$ff
	sta	silic+$100,y
	cmp	silic+$100,y
	bne	badmem2
	iny
	bne	2.b
	inx
	bne	3.b
;
	beq	9.f
;
;Error message and return.
badmem1	sec
	bcs	1.f
badmem2	clc
1	txa
	php
	jsr	print
	fcc	'*** Error at block=',0
	tay
	pha
	txa
	jsr	hexout
	jsr	print
	fcc	'  address=',0
	pla
	plp
	bcc	1.f
	jsr	print
	fcc	'E2',0
	jmp	2.f
1	jsr	print
	fcc	'E3',0
2	jsr	hexout
	jsr	crlf
	jmp	err
;
;
;Copy syssec to track 0 sector 1
9	ldy	#0
	sty	latch
1	lda	sysdat,y
	sta	silic,y
	iny
	bne	1.b
;
;set creation and modification dates
	ldx	#3
6	lda	date,x
	sta	silic+$58,x
	sta	silic+$5C,x
	dex
	bpl	6.b
;
;fill directory sector with zeros
;track 0 sector 3.
	tya
	ldx	#32
	stx	latch
2	sta	silic,y
	iny
	bne	2.b
	plp
	rts
;
;system sector. 256 bytes.
sysdat	fcc	'0123456789ABCDEF'	stab. Not used.
        fcc	'0123456789ABCDEF'	
	fcc	$80	s.mode	indicate stab not used
	fcc	32	s.mtrk	number of tracks
	fcc	16	s.mcil	sectors/track
	fcc	16	s.msec	single-sided
	fcc	$ff,$ff,$ff,$ff
	fcc	1	s.acnt	1 sector per bit
	fcc	1	s.sht	one shift -> bmap pos.
	fcc	0	s.tbas	first tsl track
	fcc	$ff	s.tbam
	fcc	1	s.dbas	first data track
	fcc	0,0,0	reserved
	fcc	0,0	s.boot	Not bootable
;
;			Subdirectory track-sector addresses
	fcc	0,0	A
	fcc	0,0	B
	fcc	0,0	C
	fcc	0,0	D
	fcc	0,0	E
	fcc	0,0	F
	fcc	0,0	G
;
;disc name. Exactly 24 characters.
	fcc	'Silicon disc'
	fcc	0,0,0,0
        fcc     0,0,0,0
        fcc     0,0,0,0
;
	fcc	0,0,0,0  s.cdat	creation date
	fcc	0,0,0,0	 s.mdat	modification date
;
;bitmap follows. 64 bytes signifigant. Unused bytes
;must all be zero. Each bit represents occupancy
;of one sector.
	fcc	$fa,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	fcc	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	fcc	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	fcc	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	fcc	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	fcc	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	fcc	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	fcc	$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff

	fcc	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	fcc	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	fcc	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	fcc	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	fcc	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	fcc	0,0,0,0,0,0,0,0,0,0,0
