/* DOS65 LABELLING DISASSEMBLER */
/* Takes a binary file and generates an output file which could
   be assembled immediately with AS65 */

#define NL printf("\n")
#define EOF 3
#define NULL 0
main(argc,argv)
int argc;
int *argv[]; /* Array of pointers to command parameter strings */
 {
 char *codefile[16]; /* filenames */
 char *library[16];
 char ip[1];       /* Data */
 int libflag,n,err;
 int fl_org;        /* Flag to indicate an org statement needed */
 int fp_bin,fp_lib; /* Pointers to binary and library files (read) */
 int fp_mac;        /* Pointer to output (mac) file */
 char *mnem;
 char *opcod[];

 mnem="fccsecclcplaphaldasta";
 opcod="\0101\0102\0103"; /* Opcodes in octal" */
 printf("%s\n",mnem);
 printf("%s\n",opcod);

 if (argc==1)
  {
  printf("Error - Filename required\n");
  exit(-1);
  }

/* checkend(*++argv,codefile,".bin"); */ 

strcpy(codefile,*++argv);
 if (argc>2)
  {
 checkend(*++argv,library,".dlb");
  libflag=1;
  }
 else libflag=0;
/*Open files here*/ 
if (!(fp_bin = fopen(codefile,"br")))
  {
   printf("Cannot open %s\n",codefile);
   exit(-1);
  }
 if (libflag==1)
  {
   if (!(fp_lib = fopen(library,"r")))
    {
     printf("Cannot open %s\n",library);
     fclose(fp_bin);
     exit(-1);
    }
   }
 /* temporary lines *************** */
 if (libflag==1) fclose(fp_lib);

 prstar(55);
 printf(";   DOS65 6502 labelling Disassembler version 0.0\n;\n");
 printf(";   File: ");
 printf("%s",codefile);
 NL;
 printf(";\n");
 printf(";   Label library: ");
 if (libflag==1) printf("%s",library);
 NL;
 prstar(55);
 fl_org=1;
 /* Read binary data */
 /* At the beginning of a binary file is a data block of length 5 or 8 bytes:

   some data blocks only:    02                
                             Run address low
                             Run address high

   All data blocks:          01
                             Load address low
                             Load address high
                             Length low        (bytes remaining until next
                             Length high       data block)

      The load address of one block may follow on from the previous one. 
    Often a file ends in a data block: 02 Rl Rh stop. */

n=0;
do
 {
++n;
err=fgets(&ip[0],2,fp_bin);
if(err!=0) printf(" fcc $%x\n",ip[0]);
  }
while (err!=0);

  fclose(fp_bin);
 }

/* Origin to output an org $xxxx statement */
origin(address)
 int address;
 {
 prstar(50);
 printf(" org $%x",address);
 }


/* Routine to print a separator with i stars */
 prstar(i)
 int i;
 {
  int j;
  printf(";\n;");
  for(j=0;j<i;j=j+1) printf("*");
  printf("\n;\n");
  return;
 }

/* Routine to get string at p, save in s, check the ending se
   and append it if not. */
checkend(p,s,se)
char *p,*s[16],*se; /* A string of unknown length at this location */
{
 int f1,len_s,len_se,n;
 char s1,se1;
 strcpy(s,p);
 len_s=strlen(s);
 if (len_s<5) f1=0;
 else
 {
  len_se=strlen(se);
  s1=len_s-len_se;
  f1=1;
  se1=0;
  for(n=len_se;n>0;--n)
  {
   if(s[s1++] != se[se1++]) f1=0;
  }
 }
 if (f1==0) strcat(s,se);
 return;
}


