{$C6000} {$X+} {$G+} {$D+}
program beamshape (input,output,data_file);
{A program to calculate power along the axis of a gaussian beam}

const pi=3.14159265;
      gyborder=70;
      gxborder=50;
      gheight=780;{graphics screen size}
      gwidth=1000;

type styles=(dot,nodot);
     string=packed array [1..32] of char;
      
var
  lambda                                   :real;
  x,z1,z2,x3,incx,w0,y                     :real;
  x_old,y_old                              :real;
  horiz_scale,vert_scale                   :real;
  ipi,n                                    :integer;
  l                                        :real;
  ipc                                      :char;
  neg1,neg3                                :boolean;
  data_file                                :text;


procedure tab(x,y:integer);
begin;
 vdu(31,x,y);
end;

procedure dump;
begin;
 tab(71,30);writeln('Copying');
 oscli('GIMAGE EPSON');
 tab(71,30);writeln('       ');
end;

procedure clear_menu;
var y:integer;
begin;
  for y:=2 to 30 do
  begin;
  tab(71,y);write('         ');
  end;
tab(71,2);
end;

procedure graph_plot(s:integer; x,y:real);
begin;
 plot(s,gxborder+trunc(gwidth*x),gyborder+trunc(gheight*y));
end;

procedure plot_anchor(x,y :real);
begin;
 graph_plot(4,x,y);
end;

procedure plot_relative(style:styles; x,y :real);
var    s :integer;
begin;
 case style of
 dot:s:=17;
 nodot:s:=1;
 end;
 plot(s,trunc(gwidth*x),trunc(gheight*y));
end;

procedure plotline(style:styles; h_end,y_end :real; var h_beg :real;
                    var y_beg :real);
var     s:integer;

begin;
 case style of
 dot:s:=21;
 nodot:s:=5;
 end;
 plot_anchor(h_beg,y_beg);
 graph_plot(s,h_end,y_end);
 h_beg:=h_end;
 y_beg:=y_end;
end;

procedure drawaxes;
var n         :integer;

begin;
 plot_anchor(0.0,0.0); 
 plot_relative(nodot,1.0,0.0);
 plot_anchor(0.0,0.0);
 plot_relative(nodot,0.0,1.0);
 for n:=0 to 10 do
  begin;
  plot_anchor(n*0.1,0.0);
  plot(1,0,-10); 
  plot_anchor(0.0,n*0.1);
  plot(1,-6,0);
  end;
end;

function omega(z,w0,lambda :real):real;
begin;
 omega:=w0*sqrt( 1 + sqr(lambda*z/(pi*sqr(w0))) );
end;


procedure save_menu(w0,lambda,z1,z2 :real);

type   string=packed array[1..11] of char;

var    k, f_int, n            :integer;
       incr,st                :real;
       name                   :string;
       no_error               :boolean;

procedure get_name(var s:string;var b:boolean);
var    i, k                   :integer;
       f                      :boolean;
begin;
tab(71,17);write('name ?');
tab(71,18);
i:=6;
s:=':1.g.      '; {g to indicate pascal textfile of gaussian data }
f:=false;
 repeat
   repeat
   k:=inkey(10);
   until ((k>27) and (k<128)) or (k=13);
  case k of
  127:if i>6 then 
      begin;
      i:=i-1;
      s[i]:=' ';
      write(chr(127):1);
      end;
  13 :f:=true;
  end {case in Acornsoft}

  otherwise if i<11 then
  begin;
  s[i]:=chr(k);
  i:=i+1;
  write(chr(k):1);
  end;

 until f;
 if i>6 then b:=true else b:=false;

end;



begin;

tab(71,14);write('ivals ?'); {number of points}
tab(71,15);read(f_int);
get_name(name,no_error);
 if no_error then
 begin;
 rewrite(data_file,name);
 writeln(data_file,1); {type of data file} 
 writeln(data_file,0); {Dummy}
 writeln(data_file,0);{Dummy}
 writeln(data_file,w0);
 writeln(data_file,lambda);
 writeln(data_file,z1);
 writeln(data_file,z2);
 writeln(data_file,0);{A dummy}
 writeln(data_file,f_int);{number of intervals=pts-1}

 incr:=(z2-z1)/f_int;
  for n:=0 to f_int do
  begin;
  y:=w0/omega(z1+n*incr,w0,lambda);
  writeln(data_file,sqr(y));
  end;
 end;
end;    


begin;
repeat
 mode(0);
 writeln('GAUSSIAN BEAM POWER ALONG AXIS CALCULATOR');
 writeln;
 write('Wavelength = ');
 readln(lambda);
 write('w0 = ');
 readln(w0);
 write('Starting distance from w0 = ');
 readln(z1);
 write('Ending distance from w0 = ');
 readln(z2);
 mode(0);
repeat
  tab(0,0);
  writeln('GAUSSIAN BEAM - POWER ALONG AXIS');
  writeln;
  writeln('w0=',w0:3:3,' z1=',z1:3:3,' z2=',z2:3:3);
  if z2<z1 then writeln('Backwards horizontal scale');
  tab(2,30);writeln('z1');
  tab(65,30);writeln('z2');
  drawaxes;

  vert_scale:=1.0;

{  tab(trunc((horiz_scale*(l-d1))*62)+1,17);}

{  tab(trunc((horiz_scale*(l+d3))*62)+1,17);  }

   horiz_scale:=1/(z2-z1);
 


  y:=w0/(omega(z1,w0,lambda));
  y:=sqr(y);
  plot_anchor(0,vert_scale*y);
  incx:=(z2-z1)/200;
  x_old:=0.0; y_old:=y;
  for n:=1 to 200 do
   begin;
   x:=z1+n*incx;
   y:=w0/omega(x,w0,lambda); {relative Amplitude}
   y:=sqr(y);                {relative Power}
   plotline(nodot,horiz_scale*(n*abs(incx)),vert_scale*y,x_old,y_old);
   end;
   
 repeat
   clear_menu;
   tab(71,2);
   writeln('Quit');
   tab(71,4);                                                                      writeln('Copy');
   tab(71,6);
   writeln('Run');
   tab(71,8);
   writeln('Save');
  repeat

   repeat
     ipi:=inkey(10);
   until ipi > 0;

    ipc:=chr(ipi);
  until ipc in ['C','c','D','S','s','d','Q','q','R','r'];

   if ipc in ['C','c'] then dump;
   if ipc in ['S','s'] then save_menu(w0,lambda,z1,z2);

 until ipc in ['Q','q','R','r'];
            
until ipc in ['Q','q','R','r'];

until ipc in ['Q','q'];

end.
